searchData={"items":[{"type":"module","title":"BSON","doc":"Functions for encoding and decoding BSON documents.","ref":"BSON.html"},{"type":"function","title":"BSON.decode/1","doc":"Decode `iodata` to a BSON document.","ref":"BSON.html#decode/1"},{"type":"function","title":"BSON.encode/1","doc":"Encode a BSON document to `iodata`.","ref":"BSON.html#encode/1"},{"type":"type","title":"BSON.document/0","doc":"","ref":"BSON.html#t:document/0"},{"type":"type","title":"BSON.t/0","doc":"","ref":"BSON.html#t:t/0"},{"type":"module","title":"BSON.Binary","doc":"Represents BSON binary type","ref":"BSON.Binary.html"},{"type":"type","title":"BSON.Binary.t/0","doc":"","ref":"BSON.Binary.html#t:t/0"},{"type":"module","title":"BSON.Decimal128","doc":"see https://en.wikipedia.org/wiki/Decimal128_floating-point_format","ref":"BSON.Decimal128.html"},{"type":"function","title":"BSON.Decimal128.decode/1","doc":"","ref":"BSON.Decimal128.html#decode/1"},{"type":"function","title":"BSON.Decimal128.encode/1","doc":"s 11110 xx...x    ±infinity\ns 11111 0x...x    a quiet NaN\ns 11111 1x...x    a signalling NaN","ref":"BSON.Decimal128.html#encode/1"},{"type":"module","title":"BSON.JavaScript","doc":"Represents BSON JavaScript (with and without scope) types","ref":"BSON.JavaScript.html"},{"type":"type","title":"BSON.JavaScript.t/0","doc":"","ref":"BSON.JavaScript.html#t:t/0"},{"type":"module","title":"BSON.LongNumber","doc":"Represents BSON long type","ref":"BSON.LongNumber.html"},{"type":"type","title":"BSON.LongNumber.t/0","doc":"","ref":"BSON.LongNumber.html#t:t/0"},{"type":"module","title":"BSON.ObjectId","doc":"Represents BSON ObjectId type","ref":"BSON.ObjectId.html"},{"type":"function","title":"BSON.ObjectId.decode/1","doc":"Converts string representation of ObjectId to a BSON.ObjectId struct","ref":"BSON.ObjectId.html#decode/1"},{"type":"function","title":"Examples - BSON.ObjectId.decode/1","doc":"{:ok, id} <- BSON.ObjectId.decode(bson_id)","ref":"BSON.ObjectId.html#decode/1-examples"},{"type":"function","title":"BSON.ObjectId.decode!/1","doc":"Converts string representation of ObjectId to a BSON.ObjectId struct","ref":"BSON.ObjectId.html#decode!/1"},{"type":"function","title":"BSON.ObjectId.do_get_timestamp/1","doc":"","ref":"BSON.ObjectId.html#do_get_timestamp/1"},{"type":"function","title":"BSON.ObjectId.encode/1","doc":"Converts BSON.ObjectId struct to a string representation","ref":"BSON.ObjectId.html#encode/1"},{"type":"function","title":"Examples - BSON.ObjectId.encode/1","doc":"{:ok, bson_id} <- BSON.ObjectId.encode(id)","ref":"BSON.ObjectId.html#encode/1-examples"},{"type":"function","title":"BSON.ObjectId.encode!/1","doc":"Converts BSON.ObjectId struct to a string representation","ref":"BSON.ObjectId.html#encode!/1"},{"type":"function","title":"BSON.ObjectId.get_timestamp/1","doc":"Extracts timestamp from BSON.ObjectId","ref":"BSON.ObjectId.html#get_timestamp/1"},{"type":"function","title":"Examples - BSON.ObjectId.get_timestamp/1","doc":"{:ok, timestamp} <- BSON.ObjectId.get_timestamp(id)","ref":"BSON.ObjectId.html#get_timestamp/1-examples"},{"type":"function","title":"BSON.ObjectId.get_timestamp!/1","doc":"Extracts timestamp from BSON.ObjectId","ref":"BSON.ObjectId.html#get_timestamp!/1"},{"type":"function","title":"BSON.ObjectId.new/4","doc":"Creates a new ObjectId from the consisting parts","ref":"BSON.ObjectId.html#new/4"},{"type":"type","title":"BSON.ObjectId.t/0","doc":"","ref":"BSON.ObjectId.html#t:t/0"},{"type":"module","title":"BSON.Regex","doc":"Represents BSON Regex type","ref":"BSON.Regex.html"},{"type":"type","title":"BSON.Regex.t/0","doc":"","ref":"BSON.Regex.html#t:t/0"},{"type":"module","title":"BSON.Timestamp","doc":"Represents BSON Timestamp type","ref":"BSON.Timestamp.html"},{"type":"function","title":"BSON.Timestamp.is_after/2","doc":"","ref":"BSON.Timestamp.html#is_after/2"},{"type":"function","title":"BSON.Timestamp.is_before/2","doc":"","ref":"BSON.Timestamp.html#is_before/2"},{"type":"type","title":"BSON.Timestamp.t/0","doc":"","ref":"BSON.Timestamp.html#t:t/0"},{"type":"task","title":"mix mongo","doc":"Migrations are used to modify your database collection over time.\n\nThis module provides some helpers for migrating the database, allowing developers to use Elixir to alter their storage in a way that is database independent.\n\nMigrations typically provide two operations: up and down, allowing us to migrate the database forward or roll it back in case of errors.\n\nIn order to manage migrations, the driver creates a collection called `migrations` in the database, which stores all migrations that have already been executed.\nYou can configure the name of this collection with the :collection configuration option.","ref":"Mix.Tasks.Mongo.html"},{"type":"task","title":"Creating your first migration - mix mongo","doc":"Migrations are defined inside the \"priv/mongo/migrations\". You can change the path using the configuration key `:path`.\n\nEach file in the migrations directory has the following structure:\n\nNUMBER_NAME.exs\nThe NUMBER is a unique number that identifies the migration. It is usually the timestamp of when the migration was created.\nThe NAME must also be unique and it quickly identifies what the migration does. For example, if you need to track the \"weather\" in your system,\nyou can start a new file at \"priv/mongo/migrations/20190417140000_add_weather_index.exs\" that will have the following contents:\n\n    defmodule Mongo.Migrations.AddWeatherIndex do\n      def up() do\n        indexes = [[key: [files_id: 1, n: 1], name: \"files_n_index\", unique: true]]\n        Mongo.create_indexes(:mongo, \"weather\", indexes)\n      end\n\n      def down() do\n            Mongo.drop_index(:mongo, \"weather\", \"files_n_index\")\n      end\n    end\n\nThe up/0 function is responsible to migrate your database forward. The down/0 function is executed whenever you want to rollback.\nThe down/0 function must always do the opposite of up/0. Inside those functions, we invoke the API defined in this module, you will\nfind conveniences for managing collections, indexes, as well as running custom MongoDB commands.\n\nTo run a migration, we generally use Mix tasks. For example, you can run the migration above by going to the root of your project and typing:\n\n      $ mix mongo.migrate\n\nYou can also roll it back by calling:\n\n      $ mix mongo.drop\n\nIn practice, we don't create migration files by hand either, we typically use mix mongo.gen.migration to generate the file with the proper timestamp and then we just fill in its contents:\n\n      $ mix mongo.gen.migration add_weather_index","ref":"Mix.Tasks.Mongo.html#module-creating-your-first-migration"},{"type":"task","title":"Configuration - mix mongo","doc":"config :mongodb_driver,\n        migration: [\n          path: \"migrations\",\n          otp_app: :mongodb_driver,\n          topology: :mongo,\n          collection: \"migrations\"\n        ]\n\nThe following migration configuration options are available:\n  * `:collection` - Version numbers of migrations will be saved in a\n    collection named `migrations` by default. You can configure the name of\n    the collection via:\n\n      config :mongodb_driver, :migration, collection: \"my_migrations\"\n\n  * `:path` - the `priv` sub-directory for migrations. `:path` defaults to \"migrations\" and migrations should be placed at \"priv/mongo/migrations\"\n  * `:otp_app` - the name of the otp_app to resolve the priv folder, defaults to :mongodb_driver. In most cases you use your application name.\n  * `:topology` - the topology for running the migrations, :topology defaults to :mongo","ref":"Mix.Tasks.Mongo.html#module-configuration"},{"type":"task","title":"mix mongo.drop","doc":"Drop the migrations when calling `mix mongo.drop`","ref":"Mix.Tasks.Mongo.Drop.html"},{"type":"task","title":"mix mongo.migrate","doc":"Runs the migrations when calling `mix mongo.migrate`","ref":"Mix.Tasks.Mongo.Migrate.html"},{"type":"task","title":"mix mongo.reset","doc":"Resets the database when calling `mix mongo.reset`","ref":"Mix.Tasks.Mongo.Reset.html"},{"type":"task","title":"mix mongo.unlock","doc":"Unlocks the migration lock","ref":"Mix.Tasks.Mongo.Unlock.html"},{"type":"module","title":"Mongo","doc":"The main entry point for doing queries. All functions take a topology to\nrun the query on.","ref":"Mongo.html"},{"type":"module","title":"Generic options - Mongo","doc":"All operations take these options.\n\n  * `:timeout` - The maximum time that the caller is allowed the to hold the\n    connection’s state (ignored when using a run/transaction connection,\n    default: `15_000`)\n  * `:checkout_timeout` - The maximum time for checking out a new session and connection (default: `60_000`).\n    When the connection pool exhausted then the function call times out after :checkout_timeout.\n  * `:pool` - The pooling behaviour module to use, this option is required\n    unless the default `DBConnection` pool is used\n  * `:pool_timeout` - The maximum time to wait for a reply when making a\n    synchronous call to the pool (default: `5_000`)\n  * `:queue` - Whether to block waiting in an internal queue for the\n    connection's state (boolean, default: `true`)\n  * `:log` - A function to log information about a call, either\n    a 1-arity fun, `{module, function, args}` with `DBConnection.LogEntry.t`\n    prepended to `args` or `nil`. See `DBConnection.LogEntry` (default: `nil`)\n  * `:database` - the database to run the operation on\n  * `:connect_timeout` - maximum timeout for connect (default: `5_000`)","ref":"Mongo.html#module-generic-options"},{"type":"module","title":"Read options - Mongo","doc":"All read operations that returns a cursor take the following options\nfor controlling the behaviour of the cursor.\n\n  * `:batch_size` - Number of documents to fetch in each batch\n  * `:limit` - Maximum number of documents to fetch with the cursor\n  * `:read_preference` - specifies the rules for selecting a server to query","ref":"Mongo.html#module-read-options"},{"type":"module","title":"Write options - Mongo","doc":"All write operations take the following options for controlling the\nwrite concern.\n\n  * `:w` - The number of servers to replicate to before returning from write\n    operators, a 0 value will return immediately, :majority will wait until\n    the operation propagates to a majority of members in the replica set\n    (Default: 1)\n  * `:j` If true, the write operation will only return after it has been\n    committed to journal - (Default: false)\n  * `:wtimeout` - If the write concern is not satisfied in the specified\n    interval, the operation returns an error","ref":"Mongo.html#module-write-options"},{"type":"function","title":"Mongo.abort_transaction/1","doc":"","ref":"Mongo.html#abort_transaction/1"},{"type":"function","title":"Mongo.abort_transaction/2","doc":"","ref":"Mongo.html#abort_transaction/2"},{"type":"function","title":"Mongo.admin_command/2","doc":"Executes an admin command against the `admin` database using always the primary. Retryable writes are disabled.","ref":"Mongo.html#admin_command/2"},{"type":"function","title":"Example - Mongo.admin_command/2","doc":"iex>  cmd = [\n    configureFailPoint: \"failCommand\",\n    mode: \"alwaysOn\",\n    data: [errorCode: 6, failCommands: [\"commitTransaction\"], errorLabels: [\"TransientTransactionError\"]]\n  ]\n\n  iex> {:ok, _doc} = Mongo.admin_command(top, cmd)","ref":"Mongo.html#admin_command/2-example"},{"type":"function","title":"Mongo.aggregate/4","doc":"Performs aggregation operation using the aggregation pipeline and returns a Mongo.Stream.\nIt should be noted that code that uses the paginated query results without engaging Mongo.Streams Enumerable behavior\ncan result in the sessions hanging around and causing resource exhaustion.\n\n  Example:\n    # Results in an open session\n    %Mongo.Stream{docs: docs} = Mongo.aggregate(@topology, collection, pipeline, opts)\n    docs |> Enum.map(fn elem -> elem end)\n\n    # Results in a closed session via the Enumerable protocol\n    Mongo.aggregate(@topology, collection, pipeline, opts)\n    |> Enum.map(fn elem -> elem end)\n\n\nFor all options see [Options](https://docs.mongodb.com/manual/reference/command/aggregate/#aggregate)","ref":"Mongo.html#aggregate/4"},{"type":"function","title":"Mongo.causal_consistency/3","doc":"Convenient function to execute write and read operation with a causal consistency session.\n\nWith causally consistent sessions, MongoDB executes causal operations in an order that respect their\ncausal relationships, and clients observe results that are consistent with the causal relationships.","ref":"Mongo.html#causal_consistency/3"},{"type":"function","title":"Example - Mongo.causal_consistency/3","doc":"{:ok, 0} = Mongo.causal_consistency(top, fn ->\n        Mongo.delete_many(top, \"dogs\", %{name: \"Greta\"}, w: :majority)\n        Mongo.count(top, \"dogs\", %{name: \"Greta\"}, read_concern: %{level: :majority})\n    end)\n\nThe function creates a causal consistency session and stores it in the process dictionary under\nthe key `:session`. But you need to specify the write and read concerns for each operation to\n`:majority`","ref":"Mongo.html#causal_consistency/3-example"},{"type":"function","title":"Mongo.child_spec/1","doc":"","ref":"Mongo.html#child_spec/1"},{"type":"function","title":"Mongo.command/3","doc":"Issue a database command. If the command has parameters use a keyword\nlist for the document because the \"command key\" has to be the first\nin the document.","ref":"Mongo.html#command/3"},{"type":"function","title":"Mongo.command!/3","doc":"Similar to `command/3` but unwraps the result and raises on error.","ref":"Mongo.html#command!/3"},{"type":"function","title":"Mongo.count_documents/4","doc":"Returns the count of documents that would match a find/4 query.","ref":"Mongo.html#count_documents/4"},{"type":"function","title":"Options - Mongo.count_documents/4","doc":"* `:limit` - Maximum number of documents to fetch with the cursor\n  * `:skip` - Number of documents to skip before returning the first","ref":"Mongo.html#count_documents/4-options"},{"type":"function","title":"Mongo.count_documents!/4","doc":"Similar to `count_documents/4` but unwraps the result and raises on error.","ref":"Mongo.html#count_documents!/4"},{"type":"function","title":"Mongo.create/3","doc":"Explicitly creates a collection or view.","ref":"Mongo.html#create/3"},{"type":"function","title":"Mongo.create_indexes/4","doc":"Convenient function to creates new indexes in the collection `coll`. The `indexes` parameter is a\nlist with all options for creating indexes in the MongoDB.\n\nSee\n[options](https://docs.mongodb.com/manual/reference/command/createIndexes/#dbcmd.createIndexes)\nabout the details of each parameter.","ref":"Mongo.html#create_indexes/4"},{"type":"function","title":"Mongo.delete_many/4","doc":"Remove all documents matching the filter from the collection.","ref":"Mongo.html#delete_many/4"},{"type":"function","title":"Mongo.delete_many!/4","doc":"Similar to `delete_many/4` but unwraps the result and raises on error.","ref":"Mongo.html#delete_many!/4"},{"type":"function","title":"Mongo.delete_one/4","doc":"Remove a document matching the filter from the collection.","ref":"Mongo.html#delete_one/4"},{"type":"function","title":"Mongo.delete_one!/4","doc":"Similar to `delete_one/4` but unwraps the result and raises on error.","ref":"Mongo.html#delete_one!/4"},{"type":"function","title":"Mongo.distinct/5","doc":"Finds the distinct values for a specified field across a collection.","ref":"Mongo.html#distinct/5"},{"type":"function","title":"Options - Mongo.distinct/5","doc":"* `:max_time` - Specifies a time limit in milliseconds\n  * `:collation` - Optionally specifies a collation to use in MongoDB 3.4 and","ref":"Mongo.html#distinct/5-options"},{"type":"function","title":"Mongo.distinct!/5","doc":"Similar to `distinct/5` but unwraps the result and raises on error.","ref":"Mongo.html#distinct!/5"},{"type":"function","title":"Mongo.drop_collection/3","doc":"Convenient function that drops the collection `coll`.","ref":"Mongo.html#drop_collection/3"},{"type":"function","title":"Mongo.drop_database/3","doc":"Convenient function that drops the database `name`.","ref":"Mongo.html#drop_database/3"},{"type":"function","title":"Mongo.drop_index/4","doc":"Convenient function that drops the index `name` in the collection `coll`.","ref":"Mongo.html#drop_index/4"},{"type":"function","title":"Mongo.estimated_document_count/3","doc":"Estimate the number of documents in a collection using collection metadata.","ref":"Mongo.html#estimated_document_count/3"},{"type":"function","title":"Mongo.estimated_document_count!/3","doc":"Similar to `estimated_document_count/3` but unwraps the result and raises on\nerror.","ref":"Mongo.html#estimated_document_count!/3"},{"type":"function","title":"Mongo.exec_hello/2","doc":"","ref":"Mongo.html#exec_hello/2"},{"type":"function","title":"Mongo.exec_hello/3","doc":"","ref":"Mongo.html#exec_hello/3"},{"type":"function","title":"Mongo.exec_more_to_come/2","doc":"","ref":"Mongo.html#exec_more_to_come/2"},{"type":"function","title":"Mongo.find/4","doc":"Selects documents in a collection and returns a cursor for the selected\ndocuments.\n\nFor all options see [Options](https://docs.mongodb.com/manual/reference/command/find/#dbcmd.find)\n\nUse the underscore style, for example to set the option `singleBatch` use `single_batch`. Another example:\n\n     Mongo.find(top, \"jobs\", %{}, batch_size: 2)","ref":"Mongo.html#find/4"},{"type":"function","title":"Mongo.find_one/4","doc":"Selects a single document in a collection and returns either a document\nor nil.\n\nIf multiple documents satisfy the query, this method returns the first document\naccording to the natural order which reflects the order of documents on the disk.\n\nFor all options see [Options](https://docs.mongodb.com/manual/reference/command/find/#dbcmd.find)\n\nUse the underscore style, for example to set the option `readConcern` use `read_concern`. Another example:\n\n     Mongo.find_one(top, \"jobs\", %{}, read_concern: %{level: \"local\"})","ref":"Mongo.html#find_one/4"},{"type":"function","title":"Mongo.find_one_and_delete/4","doc":"Finds a document and deletes it.","ref":"Mongo.html#find_one_and_delete/4"},{"type":"function","title":"Options - Mongo.find_one_and_delete/4","doc":"* `:max_time` -  The maximum amount of time to allow the query to run (in MS)\n  * `:projection` -  Limits the fields to return for all matching documents.\n  * `:sort` - Determines which document the operation modifies if the query selects multiple documents.\n  * `:collation` - Optionally specifies a collation to use in MongoDB 3.4 and higher.","ref":"Mongo.html#find_one_and_delete/4-options"},{"type":"function","title":"Mongo.find_one_and_replace/5","doc":"Finds a document and replaces it.","ref":"Mongo.html#find_one_and_replace/5"},{"type":"function","title":"Options - Mongo.find_one_and_replace/5","doc":"* `:bypass_document_validation` -  Allows the write to opt-out of document\n    level validation\n  * `:max_time` -  The maximum amount of time to allow the query to run (in MS)\n  * `:projection` -  Limits the fields to return for all matching documents.\n  * `:return_document` - Returns the replaced or inserted document rather than\n    the original. Values are :before or :after. (default is :before)\n  * `:sort` - Determines which document the operation modifies if the query\n    selects multiple documents.\n  * `:upsert` -  Create a document if no document matches the query or updates\n    the document.\n  * `:collation` - Optionally specifies a collation to use in MongoDB 3.4 and\n    higher.","ref":"Mongo.html#find_one_and_replace/5-options"},{"type":"function","title":"Mongo.find_one_and_update/5","doc":"Finds a document and updates it (using atomic modifiers).","ref":"Mongo.html#find_one_and_update/5"},{"type":"function","title":"Options - Mongo.find_one_and_update/5","doc":"* `:bypass_document_validation` -  Allows the write to opt-out of document\n    level validation\n  * `:max_time` -  The maximum amount of time to allow the query to run (in MS)\n  * `:projection` -  Limits the fields to return for all matching documents.\n  * `:return_document` - Returns the replaced or inserted document rather than\n     the original. Values are :before or :after. (default is :before)\n  * `:sort` - Determines which document the operation modifies if the query\n    selects multiple documents.\n  * `:upsert` -  Create a document if no document matches the query or updates\n    the document.\n  * `:collation` - Optionally specifies a collation to use in MongoDB 3.4 and","ref":"Mongo.html#find_one_and_update/5-options"},{"type":"function","title":"Mongo.get_session/1","doc":"","ref":"Mongo.html#get_session/1"},{"type":"function","title":"Mongo.insert_many/4","doc":"Insert multiple documents into the collection.\n\nIf any of the documents is missing the `_id` field or it is `nil`, an ObjectId will be generated, and inserted into the document.\nIds of all documents will be returned in the result struct.","ref":"Mongo.html#insert_many/4"},{"type":"function","title":"Options - Mongo.insert_many/4","doc":"For more information about options see [Options](https://docs.mongodb.com/manual/reference/command/insert/)","ref":"Mongo.html#insert_many/4-options"},{"type":"function","title":"Examples - Mongo.insert_many/4","doc":"Mongo.insert_many(pid, \"users\", [%{first_name: \"John\", last_name: \"Smith\"}, %{first_name: \"Jane\", last_name: \"Doe\"}])","ref":"Mongo.html#insert_many/4-examples"},{"type":"function","title":"Mongo.insert_many!/4","doc":"Similar to `insert_many/4` but unwraps the result and raises on error.","ref":"Mongo.html#insert_many!/4"},{"type":"function","title":"Mongo.insert_one/4","doc":"Insert a single document into the collection.\n\nIf the document is missing the `_id` field or it is `nil`, an ObjectId\nwill be generated, inserted into the document, and returned in the result struct.","ref":"Mongo.html#insert_one/4"},{"type":"function","title":"Examples - Mongo.insert_one/4","doc":"Mongo.insert_one(pid, \"users\", %{first_name: \"John\", last_name: \"Smith\"})\n\n    {:ok, session} = Session.start_session(pid)\n    Session.start_transaction(session)\n    Mongo.insert_one(pid, \"users\", %{first_name: \"John\", last_name: \"Smith\"}, session: session)\n    Session.commit_transaction(session)\n    Session.end_session(pid)","ref":"Mongo.html#insert_one/4-examples"},{"type":"function","title":"Mongo.insert_one!/4","doc":"Similar to `insert_one/4` but unwraps the result and raises on error.","ref":"Mongo.html#insert_one!/4"},{"type":"function","title":"Mongo.issue_command/4","doc":"This function is very fundamental.","ref":"Mongo.html#issue_command/4"},{"type":"function","title":"Mongo.limits/1","doc":"Returns the limits of the database.","ref":"Mongo.html#limits/1"},{"type":"function","title":"Example - Mongo.limits/1","doc":"{:ok, top} = Mongo.start_link(...)\n    Mongo.limits(top)\n\n    {:ok, %{\n       compression: [],\n       logical_session_timeout: 30,\n       max_bson_object_size: 16777216,\n       max_message_size_bytes: 48000000,\n       max_wire_version: 8,\n       max_write_batch_size: 100000,\n       read_only: false\n    }}","ref":"Mongo.html#limits/1-example"},{"type":"function","title":"Mongo.list_index_names/3","doc":"Convenient function that returns a cursor with the names of the indexes.","ref":"Mongo.html#list_index_names/3"},{"type":"function","title":"Mongo.list_indexes/3","doc":"Returns a cursor to enumerate all indexes","ref":"Mongo.html#list_indexes/3"},{"type":"function","title":"Mongo.object_id/0","doc":"Generates a new `BSON.ObjectId`.","ref":"Mongo.html#object_id/0"},{"type":"function","title":"Mongo.ping/1","doc":"Sends a ping command to the server.","ref":"Mongo.html#ping/1"},{"type":"function","title":"Mongo.rename_collection/4","doc":"Changes the name of an existing collection. Specify collection names to rename_collection in the form of a\ncomplete namespace ( . ).","ref":"Mongo.html#rename_collection/4"},{"type":"function","title":"Mongo.replace_one/5","doc":"Replace a single document matching the filter with the new document.","ref":"Mongo.html#replace_one/5"},{"type":"function","title":"Options - Mongo.replace_one/5","doc":"* `:upsert` - if set to `true` creates a new document when no document\n    matches the filter (default: `false`)","ref":"Mongo.html#replace_one/5-options"},{"type":"function","title":"Mongo.replace_one!/5","doc":"Similar to `replace_one/5` but unwraps the result and raises on error.","ref":"Mongo.html#replace_one!/5"},{"type":"function","title":"Mongo.retryable_reads/1","doc":"In case of retryable reads are enabled, the keyword `:read_counter` is added with the value of 1.\n\nIn other cases like\n\n* `:retryable_reads` is false or nil\n* `:session` is nil\n* `:read_counter` is nil\n\nthe `opts` is unchanged","ref":"Mongo.html#retryable_reads/1"},{"type":"function","title":"Example - Mongo.retryable_reads/1","doc":"iex> Mongo.retryable_reads([retryable_reads: true])\n  [retryable_reads: true, read_counter: 1]","ref":"Mongo.html#retryable_reads/1-example"},{"type":"function","title":"Mongo.retryable_writes/2","doc":"In case of retryable writes are enabled, the keyword `:write_counter` is added with the value of 1.\n\nIn other cases like\n\n* `:retryable_writes` is false or nil\n* `:session` is nil\n* `:write_counter` is nil\n\nthe `opts` is unchanged","ref":"Mongo.html#retryable_writes/2"},{"type":"function","title":"Example - Mongo.retryable_writes/2","doc":"iex> Mongo.retryable_writes([retryable_writes: true], true)\n  [retryable_writes: true, write_counter: 1]","ref":"Mongo.html#retryable_writes/2-example"},{"type":"function","title":"Mongo.show_collections/2","doc":"Getting Collection Names","ref":"Mongo.html#show_collections/2"},{"type":"function","title":"Mongo.start_link/1","doc":"Start and link to a database connection process.","ref":"Mongo.html#start_link/1"},{"type":"function","title":"Options - Mongo.start_link/1","doc":"* `:database` - The database to use (required)\n  * `:hostname` - The host to connect to (require)\n  * `:port` - The port to connect to your server (default: 27017)\n  * `:url` - A mongo connection url. Can be used in place of `:hostname` and `:database` (optional)\n  * `:socket_dir` - Connect to MongoDB via UNIX sockets in the given directory.\n    The socket name is derived based on the port. This is the preferred method\n    for configuring sockets and it takes precedence over the hostname. If you\n    are connecting to a socket outside of the MongoDB convection, use\n   `:socket` instead.\n  * `:socket` - Connect to MongoDB via UNIX sockets in the given path.\n    This option takes precedence over `:hostname` and `:socket_dir`.\n  * `:database` (optional)\n  * `:seeds` - A list of host names in the cluster. Can be used in place of\n    `:hostname` (optional)\n  * `:username` - The User to connect with (optional)\n  * `:password` - The password to connect with (optional)\n  * `:auth_source` - The database to authenticate against\n  * `:appname` - The name of the application used the driver for the MongoDB-Handshake\n  * `:set_name` - The name of the replica set to connect to (required if\n  connecting to a replica set)\n  * `:type` - a hint of the topology type. See `t:initial_type/0` for\n    valid values (default: `:unknown`)\n  * `:idle` - The idle strategy, `:passive` to avoid checkin when idle and\n    `:active` to checking when idle (default: `:passive`)\n  * `:idle_timeout` - The idle timeout to ping the database (default: `1_000`)\n  * `:connect_timeout` - The maximum timeout for the initial connection\n    (default: `5_000`)\n  * `:backoff_min` - The minimum backoff interval (default: `1_000`)\n  * `:backoff_max` - The maximum backoff interval (default: `30_000`)\n  * `:backoff_type` - The backoff strategy, `:stop` for no backoff and to\n    stop, `:exp` of exponential, `:rand` for random and `:ran_exp` for random\n    exponential (default: `:rand_exp`)\n  * `:after_connect` - A function to run on connect use `run/3`. Either a\n    1-arity fun, `{module, function, args}` with `DBConnection.t`, prepended\n    to `args` or `nil` (default: `nil`)\n  * `:auth_mechanism` - options for the mongo authentication mechanism,\n    currently only supports `:x509` atom as a value\n  * `:ssl` - Set to `true` if ssl should be used (default: `false`)\n  * `:ssl_opts` - A list of ssl options, see the ssl docs","ref":"Mongo.html#start_link/1-options"},{"type":"function","title":"Error Reasons - Mongo.start_link/1","doc":"* `:single_topology_multiple_hosts` - A topology of `:single` was set\n    but multiple hosts were given\n  * `:set_name_bad_topology` - A `:set_name` was given but the topology was\n    set to something other than `:replica_set_no_primary` or `:single`","ref":"Mongo.html#start_link/1-error-reasons"},{"type":"function","title":"Mongo.timestamp/1","doc":"Converts the DataTime to a MongoDB timestamp.","ref":"Mongo.html#timestamp/1"},{"type":"function","title":"Mongo.transaction/3","doc":"Convenient function for running multiple write commands in a transaction.\n\nIn case of `TransientTransactionError` or `UnknownTransactionCommitResult` the function will retry the whole transaction or\nthe commit of the transaction. You can specify a timeout (`:transaction_retry_timeout_s`) to limit the time of repeating.\nThe default value is 120 seconds. If you don't wait so long, you call `with_transaction` with the\noption `transaction_retry_timeout_s: 10`. In this case after 10 seconds of retrying, the function will return\nan error.","ref":"Mongo.html#transaction/3"},{"type":"function","title":"Example - Mongo.transaction/3","doc":"{:ok, ids} = Mongo.transaction(top, fn ->\n    {:ok, %InsertOneResult{:inserted_id => id1}} = Mongo.insert_one(top, \"dogs\", %{name: \"Greta\"})\n    {:ok, %InsertOneResult{:inserted_id => id2}} = Mongo.insert_one(top, \"dogs\", %{name: \"Waldo\"})\n    {:ok, %InsertOneResult{:inserted_id => id3}} = Mongo.insert_one(top, \"dogs\", %{name: \"Tom\"})\n    {:ok, [id1, id2, id3]}\n    end, transaction_retry_timeout_s: 10)\n\nIf transaction/3 is called inside another transaction, the function is simply executed, without wrapping the new transaction call in any way.\nIf there is an error in the inner transaction and the error is rescued, or the inner transaction is aborted (abort_transaction/1),\nthe whole outer transaction is aborted, guaranteeing nothing will be committed.","ref":"Mongo.html#transaction/3-example"},{"type":"function","title":"Mongo.update/4","doc":"Performs one or more update operations.\n\nThis function is especially useful for more complex update operations (e.g.\nupserting multiple documents). For more straightforward use cases you may\nprefer to use these higher level APIs:\n\n* `update_one/5`\n* `update_one!/5`\n* `update_many/5`\n* `update_many!5`\n\nEach update in `updates` may be specified using either the short-hand\nMongo-style syntax (in reference to their docs) or using a long-hand, Elixir\nfriendly syntax.\n\nSee\nhttps://docs.mongodb.com/manual/reference/command/update/#update-statements\n\ne.g. long-hand `query` becomes short-hand `q`, snake case `array_filters`\nbecomes `arrayFilters`\n\nExample:\n\n    Mongo.update(MongoPool,\n      \"test_collection\",\n      query: %{foo => 4},\n      update: %{\"$set\": %{\"modified_field\": \"new_value\"}},\n      multi: true)\n\n      Mongo.update(MongoPool,\n        \"test_collection\",\n        query: %{foo: 4},\n        update: %{foo: 5, new_field: \"new_value\"}},\n        upsert: true)\n\n      Mongo.update(MongoPool, \"test_collection\", [\n        [q: %{foo: 24}, update: %{flag: \"old\"}],\n        [q: %{foo: 99}, update: %{luftballons: \"yes\"}, upsert: true]\n      ])","ref":"Mongo.html#update/4"},{"type":"function","title":"Mongo.update_many/5","doc":"Update all documents matching the filter.\n\nUses MongoDB update operators to specify the updates. For more information and all options\nplease refer to the [MongoDB documentation](https://docs.mongodb.com/manual/reference/command/update/#dbcmd.update)","ref":"Mongo.html#update_many/5"},{"type":"function","title":"Mongo.update_many!/5","doc":"Similar to `update_many/5` but unwraps the result and raises on error.","ref":"Mongo.html#update_many!/5"},{"type":"function","title":"Mongo.update_one/5","doc":"Update a single document matching the filter.\n\nUses MongoDB update operators to specify the updates. For more information\nplease refer to the\n[MongoDB documentation](http://docs.mongodb.org/manual/reference/operator/update/)\n\nExample:\n\n    Mongo.update_one(MongoPool,\n      \"my_test_collection\",\n      %{\"filter_field\": \"filter_value\"},\n      %{\"$set\": %{\"modified_field\": \"new_value\"}})","ref":"Mongo.html#update_one/5"},{"type":"function","title":"Options - Mongo.update_one/5","doc":"* `:upsert` - if set to `true` creates a new document when no document\n    matches the filter (default: `false`)","ref":"Mongo.html#update_one/5-options"},{"type":"function","title":"Mongo.update_one!/5","doc":"Similar to `update_one/5` but unwraps the result and raises on error.","ref":"Mongo.html#update_one!/5"},{"type":"function","title":"Mongo.uuid/0","doc":"Creates a new UUID.","ref":"Mongo.html#uuid/0"},{"type":"function","title":"Mongo.uuid/1","doc":"Converts the binary to UUID","ref":"Mongo.html#uuid/1"},{"type":"function","title":"Example - Mongo.uuid/1","doc":"iex> Mongo.uuid(\"848e90e9-5750-4e0a-ab73-66ac6b328242\")\n    {:ok, #BSON.UUID<848e90e9-5750-4e0a-ab73-66ac6b328242>}\n\n    iex> Mongo.uuid(\"848e90e9-5750-4e0a-ab73-66ac6b328242x\")\n    {:error, %ArgumentError{message: \"invalid UUID string\"}}\n\n    iex> Mongo.uuid(\"848e90e9-5750-4e0a-ab73-66-c6b328242\")\n    {:error, %ArgumentError{message: \"non-alphabet digit found: \"-\" (byte 45)\"}}","ref":"Mongo.html#uuid/1-example"},{"type":"function","title":"Mongo.uuid!/1","doc":"Similar to `uuid/1` except it will unwrap the error tuple and raise\nin case of errors.","ref":"Mongo.html#uuid!/1"},{"type":"function","title":"Example - Mongo.uuid!/1","doc":"iex> Mongo.uuid!(\"848e90e9-5750-4e0a-ab73-66ac6b328242\")\n    #BSON.UUID<848e90e9-5750-4e0a-ab73-66ac6b328242>\n\n    iex> Mongo.uuid!(\"848e90e9-5750-4e0a-ab73-66ac6b328242x\")\n    ** (ArgumentError) invalid UUID string\n    (mongodb_driver 0.6.4) lib/mongo.ex:205: Mongo.uuid!/1","ref":"Mongo.html#uuid!/1-example"},{"type":"function","title":"Mongo.watch_collection/5","doc":"Creates a change stream cursor on collections.\n\n`on_resume_token` is function that takes the new resume token, if it changed.","ref":"Mongo.html#watch_collection/5"},{"type":"function","title":"Options - Mongo.watch_collection/5","doc":"* `:full_document` -\n  * `:max_time` - Specifies a time limit in milliseconds. This option is used on `getMore` commands\n  * `:batch_size` - Specifies the number of maximum number of documents to\n    return (default: 1)\n  * `:resume_after` - Specifies the logical starting point for the new change stream.\n  * `:start_at_operation_time` - The change stream will only provide changes that occurred at or after the specified timestamp (since 4.0)\n  * `:start_after` - Similar to `resumeAfter`, this option takes a resume token and starts a new change stream\n      returning the first notification after the token. This will allow users to watch collections that have been dropped and recreated\n      or newly renamed collections without missing any notifications. (since 4.0.7)","ref":"Mongo.html#watch_collection/5-options"},{"type":"function","title":"Mongo.watch_db/4","doc":"Creates a change stream cursor all collections of the database.\n\n`on_resume_token` is function that takes the new resume token, if it changed.","ref":"Mongo.html#watch_db/4"},{"type":"function","title":"Options - Mongo.watch_db/4","doc":"* `:full_document` -\n  * `:max_time` - Specifies a time limit in milliseconds. This option is used on `getMore` commands\n  * `:batch_size` - Specifies the number of maximum number of documents to\n    return (default: 1)\n  * `:resume_after` - Specifies the logical starting point for the new change stream.\n  * `:start_at_operation_time` - The change stream will only provide changes that occurred at or after the specified timestamp (since 4.0)\n  * `:start_after` - Similar to `resumeAfter`, this option takes a resume token and starts a new change stream\n      returning the first notification after the token. This will allow users to watch collections that have been dropped and recreated\n      or newly renamed collections without missing any notifications. (since 4.0.7)","ref":"Mongo.html#watch_db/4-options"},{"type":"function","title":"Mongo.wire_version/1","doc":"Returns the wire version of the database","ref":"Mongo.html#wire_version/1"},{"type":"function","title":"Example - Mongo.wire_version/1","doc":"{:ok, top} = Mongo.start_link(...)\n    Mongo.wire_version(top)\n\n    {:ok, 8}","ref":"Mongo.html#wire_version/1-example"},{"type":"type","title":"Mongo.collection/0","doc":"","ref":"Mongo.html#t:collection/0"},{"type":"type","title":"Mongo.conn/0","doc":"","ref":"Mongo.html#t:conn/0"},{"type":"type","title":"Mongo.cursor/0","doc":"","ref":"Mongo.html#t:cursor/0"},{"type":"type","title":"Mongo.result/1","doc":"","ref":"Mongo.html#t:result/1"},{"type":"type","title":"Mongo.result!/1","doc":"","ref":"Mongo.html#t:result!/1"},{"type":"module","title":"Mongo.BulkOps","doc":"This module defines bulk operation for insert, update and delete. A bulk operation is a tuple of two elements\n\n1. an atom, which specify the type `:insert`, `:update` and `:delete`\n2. a document or another tuple which contains all parameters of the operation.\n\nYou use these function in streams:","ref":"Mongo.BulkOps.html"},{"type":"module","title":"Example - Mongo.BulkOps","doc":"```\nalias Mongo.UnorderedBulk\nalias Mongo.BulkOps\n\nFilestream!(\"large.csv\")\n|> Stream.map(&String.trim(&1))\n|> Stream.map(&String.split(&1,\",\"))\n|> Stream.map(fn [firstname | [lastname | _]] -> %{firstname: firstname, lastname: lastname} end)\n|> Stream.map(fn doc -> BulkOps.get_insert_one(doc) end)\n|> UnorderedBulk.write(:mongo, \"bulk\", 1_000)\n|> Stream.run()\n```","ref":"Mongo.BulkOps.html#module-example"},{"type":"function","title":"Mongo.BulkOps.get_delete_many/1","doc":"Returns an `delete_many` operation for appending to a bulk. Used to perform stream bulk writes.\n\n  Example\n\n```\nMongo.BulkOps.get_delete_many(%{name: \"Waldo\"})\n\n{:delete, {%{name: \"Waldo\"}, [limit: 0]}}\n```","ref":"Mongo.BulkOps.html#get_delete_many/1"},{"type":"function","title":"Mongo.BulkOps.get_delete_one/1","doc":"Returns an `delete_one` operation tuple for appending to a bulk. Used to perform stream bulk writes.\n\n  Example\n\n```\nMongo.BulkOps.get_delete_one(%{name: \"Waldo\"})\n\n{:delete, {%{name: \"Waldo\"}, [limit: 1]}}\n```","ref":"Mongo.BulkOps.html#get_delete_one/1"},{"type":"function","title":"Mongo.BulkOps.get_insert_one/1","doc":"Returns an `insert_one` operation tuple for appending to a bulk. Used to perform stream bulk writes.\n\n  Example\n```\nMongo.BulkOps.get_insert_one(%{name: \"Waldo\"})\n\n{:insert, %{name: \"Waldo\"}}\n```","ref":"Mongo.BulkOps.html#get_insert_one/1"},{"type":"function","title":"Mongo.BulkOps.get_replace_one/3","doc":"Returns an `replace_one` operation for appending to a bulk. Used to perform stream bulk writes.\n\n  Example\n\n```\nMongo.BulkOps.get_replace_one(%{name: \"Waldo\"}, %{name: \"Greta\", kind: \"dog\"})\n\n{:update, {%{name: \"Waldo\"}, %{kind: \"dog\", name: \"Greta\"}, [multi: false]}}\n```","ref":"Mongo.BulkOps.html#get_replace_one/3"},{"type":"function","title":"Mongo.BulkOps.get_update_many/3","doc":"Returns an `update_many` operation for appending to a bulk. Used to perform stream bulk writes.\n\n  Example\n\n```\nMongo.BulkOps.get_update_many(%{name: \"Waldo\"}, %{\"$set\" : %{name: \"Greta\", kind: \"dog\"}})\n\n{:update,\n  {%{name: \"Waldo\"}, %{\"$set\": %{kind: \"dog\", name: \"Greta\"}}, [multi: true]}}\n```","ref":"Mongo.BulkOps.html#get_update_many/3"},{"type":"function","title":"Mongo.BulkOps.get_update_one/3","doc":"Returns an `update_one` operation for appending to a bulk. Used to perform stream bulk writes.\n\n    Example\n\n```\nMongo.BulkOps.get_update_one(%{name: \"Waldo\"}, %{\"$set\" : %{name: \"Greta\", kind: \"dog\"}})\n\n{:update,\n  {%{name: \"Waldo\"}, %{\"$set\": %{kind: \"dog\", name: \"Greta\"}}, [multi: false]}}\n```","ref":"Mongo.BulkOps.html#get_update_one/3"},{"type":"type","title":"Mongo.BulkOps.bulk_op/0","doc":"","ref":"Mongo.BulkOps.html#t:bulk_op/0"},{"type":"module","title":"Mongo.BulkWrite","doc":"The driver supports the so-called bulk writes ([Specification](https://github.com/mongodb/specifications/blob/master/source/crud/crud.rst#basic)):\n\nThe motivation for bulk writes lies in the possibility of optimizing to group the same operations.  The driver supports\n\n* unordered and ordered bulk writes\n* in-memory and stream bulk writes","ref":"Mongo.BulkWrite.html"},{"type":"module","title":"Unordered bulk writes - Mongo.BulkWrite","doc":"Unordered bulk writes have the highest optimization factor. Here all operations can be divided into\nthree groups (inserts, updates and deletes).\nThe order of execution within a group does not matter. However, the groups are executed in the\norder: inserts, updates and deletes. The following example creates three records, changes them, and then\ndeletes all records. After execution, the collection is unchanged. It's valid, because of the execution order:\n\n1. inserts\n2. updates\n3. deletes","ref":"Mongo.BulkWrite.html#module-unordered-bulk-writes"},{"type":"module","title":"Example: - Mongo.BulkWrite","doc":"```\nalias Mongo.BulkWrite\nalias Mongo.UnorderedBulk\n\nbulk = \"bulk\"\n    |> UnorderedBulk.new()\n    |> UnorderedBulk.insert_one(%{name: \"Greta\"})\n    |> UnorderedBulk.insert_one(%{name: \"Tom\"})\n    |> UnorderedBulk.insert_one(%{name: \"Waldo\"})\n    |> UnorderedBulk.update_one(%{name: \"Greta\"}, %{\"$set\": %{kind: \"dog\"}})\n    |> UnorderedBulk.update_one(%{name: \"Tom\"}, %{\"$set\": %{kind: \"dog\"}})\n    |> UnorderedBulk.update_one(%{name: \"Waldo\"}, %{\"$set\": %{kind: \"dog\"}})\n    |> UnorderedBulk.delete_one(%{kind: \"dog\"})\n    |> UnorderedBulk.delete_one(%{kind: \"dog\"})\n    |> UnorderedBulk.delete_one(%{kind: \"dog\"})\n\nresult = BulkWrite.write(:mongo, bulk, w: 1)\n```","ref":"Mongo.BulkWrite.html#module-example"},{"type":"module","title":"Ordered bulk writes - Mongo.BulkWrite","doc":"Sometimes the order of execution is important for successive operations to yield a correct result.\nIn this case, one uses ordered bulk writes. The following example would not work with unordered bulk writes\nbecause the order within the update operations is undefined. The `update_many()` will only work, if it is\nexecuted after the `update_one()` functions.\n\n```\nbulk = \"bulk\"\n     |> OrderedBulk.new()\n     |> OrderedBulk.insert_one(%{name: \"Greta\"})\n     |> OrderedBulk.insert_one(%{name: \"Tom\"})\n     |> OrderedBulk.insert_one(%{name: \"Waldo\"})\n     |> OrderedBulk.update_one(%{name: \"Greta\"}, %{\"$set\": %{kind: \"dog\"}})\n     |> OrderedBulk.update_one(%{name: \"Tom\"}, %{\"$set\": %{kind: \"dog\"}})\n     |> OrderedBulk.update_one(%{name: \"Waldo\"}, %{\"$set\": %{kind: \"dog\"}})\n     |> OrderedBulk.update_many(%{kind: \"dog\"}, %{\"$set\": %{kind: \"cat\"}})\n     |> OrderedBulk.delete_one(%{kind: \"cat\"})\n     |> OrderedBulk.delete_one(%{kind: \"cat\"})\n     |> OrderedBulk.delete_one(%{kind: \"cat\"})\n\nresult = BulkWrite.write(:mongo, bulk, w: 1)\n```","ref":"Mongo.BulkWrite.html#module-ordered-bulk-writes"},{"type":"module","title":"Stream bulk writes - Mongo.BulkWrite","doc":"The examples shown initially filled the bulk with a few operations and then the bulk is written to the database.\nThis is all done in memory. For larger amounts of operations or imports of very long files, the main memory would\nbe unnecessarily burdened. It could come to some resource problems.\n\nFor such cases you could use streams. Unordered and ordered bulk writes can also be combined with Streams.\nYou set the maximum size of the bulk. Once the number of bulk operations has been reached,\nit will be sent to the database. While streaming you can limit the memory consumption regarding the current task.\n\nIn the following example we import 1.000.000 integers into the MongoDB using the stream api:\n\nWe need to create an insert operation (`BulkOps.get_insert_one()`) for each number. Then we call the `UnorderedBulk.stream`\nfunction to import it. This function returns a stream function which accumulate\nall inserts operations until the limit `1000` is reached. In this case the operation group is written to\nMongoDB.","ref":"Mongo.BulkWrite.html#module-stream-bulk-writes"},{"type":"module","title":"Example - Mongo.BulkWrite","doc":"```\n1..1_000_000\n  |> Stream.map(fn i -> BulkOps.get_insert_one(%{number: i}) end)\n  |> UnorderedBulk.write(:mongo, \"bulk\", 1_000)\n  |> Stream.run()\n```","ref":"Mongo.BulkWrite.html#module-example"},{"type":"module","title":"Benchmark - Mongo.BulkWrite","doc":"The following benchmark compares multiple `Mongo.insert_one()` calls with a stream using unordered bulk writes.\nBoth tests inserts documents into a replica set with `w: 1`.\n\n```\nBenchee.run(\n    %{\n      \"inserts\" => fn input ->\n       input\n       |> Enum.map(fn i -> %{number: i} end)\n       |> Enum.each(fn doc -> Mongo.insert_one!(top, \"bulk_insert\", doc) end)\n      end,\n      \"streams\" => fn input ->\n                      input\n                      |> Stream.map(fn i -> get_insert_one(%{number: i}) end)\n                      |> Mongo.UnorderedBulk.write(top, \"bulk\", 1_0000)\n                      |> Stream.run()\n      end,\n    },\n    inputs: %{\n      \"Small\" => Enum.to_list(1..10_000),\n      \"Medium\" => Enum.to_list(1..100_000),\n      \"Bigger\" => Enum.to_list(1..1_000_000)\n    }\n  )\n```\n\nResult:\n\n```\n##### With input Bigger #####\nName              ips        average  deviation         median         99th %\nstreams        0.0885      0.188 min     ±0.00%      0.188 min      0.188 min\ninserts       0.00777       2.14 min     ±0.00%       2.14 min       2.14 min\n\nComparison:\nstreams        0.0885\ninserts       0.00777 - 11.39x slower +1.96 min\n\n##### With input Medium #####\nName              ips        average  deviation         median         99th %\nstreams          1.00         1.00 s     ±8.98%         0.99 s         1.12 s\ninserts        0.0764        13.09 s     ±0.00%        13.09 s        13.09 s\n\nComparison:\nstreams          1.00\ninserts        0.0764 - 13.12x slower +12.10 s\n\n##### With input Small #####\nName              ips        average  deviation         median         99th %\nstreams          8.26        0.121 s    ±30.46%        0.112 s         0.23 s\ninserts          0.75         1.34 s     ±7.15%         1.29 s         1.48 s\n\nComparison:\nstreams          8.26\ninserts          0.75 - 11.07x slower +1.22 s\n```\n\nThe result is, that using bulk writes is much faster (about 15x faster at all).","ref":"Mongo.BulkWrite.html#module-benchmark"},{"type":"function","title":"Mongo.BulkWrite.write/3","doc":"Executes unordered and ordered bulk writes.","ref":"Mongo.BulkWrite.html#write/3"},{"type":"function","title":"Unordered bulk writes - Mongo.BulkWrite.write/3","doc":"The operation are grouped (inserts, updates, deletes). The order of execution is:\n\n1. inserts\n2. updates\n3. deletes\n\nThe execution order within the group is not preserved.","ref":"Mongo.BulkWrite.html#write/3-unordered-bulk-writes"},{"type":"function","title":"Ordered bulk writes - Mongo.BulkWrite.write/3","doc":"Sequences of the same operations are grouped and sent as one command. The order is preserved.\n\nIf a group (inserts, updates or deletes) exceeds the limit `maxWriteBatchSize` it will be split into chunks.\nEverything is done in memory, so this use case is limited by memory. A better approach seems to use streaming bulk writes.","ref":"Mongo.BulkWrite.html#write/3-ordered-bulk-writes"},{"type":"module","title":"Mongo.BulkWriteResult","doc":"The successful result struct of `Mongo.BulkWrite.write`. Its fields are:\n\n  * `:acknowledged` - Write-concern\n  * `:matched_count` - Number of matched documents\n  * `:modified_count` - Number of modified documents\n  * `:inserted_count` - Number of inserted documents\n  * `:deleted_count` - Number of deleted documents\n  * `:upserted_count` - Number of upserted documents\n  * `:upserted_ids` - If the operation was an upsert, the upserted ids\n  * `:inserted_ids` - If the operation was an insert, the inserted ids\n  * `:errors` - If the operation results in an error, the error is collected","ref":"Mongo.BulkWriteResult.html"},{"type":"function","title":"Mongo.BulkWriteResult.add/2","doc":"","ref":"Mongo.BulkWriteResult.html#add/2"},{"type":"function","title":"Mongo.BulkWriteResult.delete_result/2","doc":"","ref":"Mongo.BulkWriteResult.html#delete_result/2"},{"type":"function","title":"Mongo.BulkWriteResult.empty/0","doc":"","ref":"Mongo.BulkWriteResult.html#empty/0"},{"type":"function","title":"Mongo.BulkWriteResult.error/1","doc":"","ref":"Mongo.BulkWriteResult.html#error/1"},{"type":"function","title":"Mongo.BulkWriteResult.insert_result/3","doc":"","ref":"Mongo.BulkWriteResult.html#insert_result/3"},{"type":"function","title":"Mongo.BulkWriteResult.reduce/1","doc":"","ref":"Mongo.BulkWriteResult.html#reduce/1"},{"type":"function","title":"Mongo.BulkWriteResult.reduce/2","doc":"","ref":"Mongo.BulkWriteResult.html#reduce/2"},{"type":"function","title":"Mongo.BulkWriteResult.update_result/5","doc":"","ref":"Mongo.BulkWriteResult.html#update_result/5"},{"type":"type","title":"Mongo.BulkWriteResult.t/0","doc":"","ref":"Mongo.BulkWriteResult.html#t:t/0"},{"type":"module","title":"Mongo.Collection","doc":"This module provides some boilerplate code for a better support of structs while using the\nMongoDB driver:\n\n  * automatic load and dump function\n  * reflection functions\n  * type specification\n  * support for embedding one and many structs\n  * support for `after load` function\n  * support for `before dump` function\n  * support for id generation\n  * support for default values\n  * support for derived values\n\nWhen using the MongoDB driver only maps and keyword lists are used to\nrepresent documents.\nIf you prefer to use structs instead of the maps to give the document a stronger meaning or to emphasize\nits importance, you have to create a `defstruct` and fill it from the map manually:\n\n    defmodule Label do\n      defstruct name: \"warning\", color: \"red\"\n    end\n\n    iex> label_map = Mongo.find_one(:mongo, \"labels\", %{})\n    %{\"name\" => \"warning\", \"color\" => \"red\"}\n    iex> label = %Label{name: label_map[\"name\"], color: label_map[\"color\"]}\n\nWe have defined a module `Label` as `defstruct`, then we get the first label document\nthe collection `labels`. The function `find_one` returns a map. We convert the map manually and\nget the desired struct.\n\nIf we want to save a new structure, we have to do the reverse. We convert the struct into a map:\n\n    iex> label = %Label{}\n    iex> label_map = %{\"name\" => label.name, \"color\" => label.color}\n    iex> {:ok, _} = Mongo.insert_one(:mongo, \"labels\", label_map)\n\nAlternatively, you can also remove the `__struct__` key from `label`. The MongoDB driver automatically\nconverts the atom keys into strings.\n\n    iex>  Map.drop(label, [:__struct__])\n    %{color: :red, name: \"warning\"}\n\nIf you use nested structures, the work becomes a bit more complex. In this case, you have to use the inner structures\nconvert manually, too.\n\nIf you take a closer look at the necessary work, two basic functions can be derived:\n\n  * `load` Conversion of the map into a struct.\n  * `dump` Conversion of the struct into a map.\n\nThis module provides the necessary macros to automate this boilerplate code.\nThe above example can be rewritten as follows:\n\n    defmodule Label do\n\n      use Collection\n\n      document do\n        attribute :name, String.t(), default: \"warning\"\n        attribute :color, String.t(), default: :red\n      end\n\n    end\n\nThis results in the following module:\n\n    defmodule Label do\n\n      defstruct [name: \"warning\", color: \"red\"]\n\n      @type t() :: %Label{String.t(), String.t()}\n\n      def new()...\n      def load(map)...\n      def dump(%Label{})...\n      def __collection__(:attributes)...\n      def __collection__(:types)...\n      def __collection__(:collection)...\n      def __collection__(:id)...\n\n    end\n\nYou can now create new structs with the default values and use the conversion functions between maps and\nstructs:\n\n    iex(1)> x = Label.new()\n    %Label{color: :red, name: \"warning\"}\n    iex(2)> m = Label.dump(x)\n    %{color: :red, name: \"warning\"}\n    iex(3)> Label.load(m, true)\n    %Label{color: :red, name: \"warning\"}\n\nThe `load/2` function distinguishes between keys of type binaries `load(map, false)` and keys of type atoms `load(map, true)`.\nThe default is `load(map, false)`:\n\n    iex(1)> m = %{\"color\" => :red, \"name\" => \"warning\"}\n    iex(2)> Label.load(m)\n    %Label{color: :red, name: \"warning\"}\n\nIf you would now expect atoms as keys, the result of the conversion is not correct in this case:\n\n    iex(3)> Label.load(m, true)\n    %Label{color: nil, name: nil}\n\nThe background is that MongoDB always returns binaries as keys and structs use atoms as keys.","ref":"Mongo.Collection.html"},{"type":"module","title":"Dump and load function - Mongo.Collection","doc":"Using the collection modules increases the cpu usage because we need to\nserialize the map into the struct if we load the document from the database.\nAnd if we want to save the struct to the database, the dump function is called,\nthat serializes the struct into a map. Both functions take care about the key\nmapping as well. What do the generated functions look like in detail?\n\nAssuming we have the following collections defined:\n\n    defmodule Label do\n      use Collection\n      document do\n        attribute :name, String.t(), default: \"warning\"\n      end\n    end\n\n    defmodule User do\n      use Collection\n      document do\n        attribute :first_name, String.t()\n        attribute :last_name, String.t()\n        attribute :email, String.t()\n        embeds_one :label, Label\n      end\n    end\n\nThe collection module creates the load function like this:\n\n   Map.put(%{\n     first_name: Map.get(user, \"first_name\"),\n     last_name: Map.get(user, \"last_name\"),\n     email: Map.get(user, \"email\"),\n     label: Label.load(Map.get(user, \"label\"))\n   }, :__struct__, User)\n\nThe performance depends on the number of attributes and embedded structs. It seems, that\nusing a map first is the fasted way to create a new struct. A few variations were tried out:\n\n  new quoted load                            2.43 M\n  load manually created using Map.get        2.25 M - 1.08x slower +32.91 ns\n  load manually created using []             2.12 M - 1.15x slower +60.34 ns\n  original load                              0.82 M - 2.96x slower +805.70 ns\n\nThe dump function looks like this:\n\n    [\n      {\"first_name\", user.first_name},\n      {\"last_name\", user.last_name},\n      {\"email\", user.email},\n      {\"label\", Label.dump(user.label)}\n    ]\n    |> Enum.filter(fn {_key, value} -> value != nil end)\n    |> Map.new()\n\nThe load and dump function uses only the defined attributes and embedded structs.\nUnknown attributes are ignored.","ref":"Mongo.Collection.html#module-dump-and-load-function"},{"type":"module","title":"Default and derived values - Mongo.Collection","doc":"Attributes have two options:\n\n* `default:` a value or a function, which is called, when a new struct is created\n* `derived:` `true` to indicate, that is attribute should not be saved to the database\n\nIf you call `new/0` a new struct is returned filled with the default values. In case of a function the\nfunction is called to use the return value as default.\n\n      attribute: created, DateTime.t(), &DateTime.utc_now/0\n\nIf you mark an attribute as a derived attribute (`derived: true`) then the dump function will remove\nthe attributes from the struct automatically for you, so these kind of attributes won't be saved in\nthe database.\n\n      attribute :id, String.t(), derived: true","ref":"Mongo.Collection.html#module-default-and-derived-values"},{"type":"module","title":"Key mapping - Mongo.Collection","doc":"It is possible to define a different name for the keys. The name of the key is defined by using the `:name` option.\n\n  attribute :very_long_name, String.t(), name: v\n\nThe dump and load functions will use the name `v` instead of `very_long_name`:\n\n    defmodule Label do\n      use Mongo.Collection\n      document do\n        attribute :very_long_attribute, String.t(), name: :v\n      end\n    end\n\n    iex > l = %Label{very_long_attribute: \"Hello\"}\n    %Label{very_long_attribute: \"Hello\"}\n    iex > Label.dump(l)\n    %{\"v\" => \"Hello\"}\n    iex > dumped_l = Label.dump(l)\n    %{\"v\" => \"Hello\"}\n    iex > Label.load(dumped_l)\n    %Label{very_long_attribute: \"Hello\"}\n\nYou can reduce the size of the collection by using short attribute-names or use the `:name` option to import the\ndocuments for a migration.","ref":"Mongo.Collection.html#module-key-mapping"},{"type":"module","title":"Collections - Mongo.Collection","doc":"In MongoDB, documents are written in collections. We can use the `collection/2` macro to create\na collection:\n\n      defmodule Card do\n\n        use Collection\n\n        collection \"cards\" do\n          attribute :title, String.t(), default: \"new title\"\n        end\n\n      end\n\nThe `collection/2` macro creates a collection that is basically similar to a document, where\nan attribute for the ID is added automatically. Additionally, the attribute `@collection` is assigned and\ncan be used as a constant in other functions.\n\nIn the example above we only suppress a warning of the editor by `@collection`. The macro creates the following\nexpression: `@collection \"cards\"`. By default, the following attribute is created for the ID:\n\n    {:_id, BSON.ObjectId.t(), &Mongo.object_id/0}\n\nwhere the default value is created via the function `&Mongo.object_id/0` when calling `new/0`:\n\n      iex> Card.new()\n      %Card{_id: #BSON.ObjectId<5ec3d04a306a5f296448a695>, title: \"new title\"}\n\nTwo additional reflection features are also provided:\n\n      iex> Card.__collection__(:id)\n      :_id\n      iex(3)> Card.__collection__(:collection)\n      \"cards\"","ref":"Mongo.Collection.html#module-collections"},{"type":"module","title":"MongoDB example - Mongo.Collection","doc":"We define the following collection:\n\n      defmodule Card do\n\n        use Collection\n\n        @collection nil","ref":"Mongo.Collection.html#module-mongodb-example"},{"type":"module","title":"keeps the editor happy - Mongo.Collection","doc":"@id nil\n\n        collection \"cards\" do\n          attribute :title, String.t(), default: \"new title\"\n        end\n\n        def insert_one(%Card{} = card) do\n          with map <- dump(card),\n               {:ok, _} <- Mongo.insert_one(:mongo, @collection, map) do\n            :ok\n          end\n        end\n\n        def find_one(id) do\n          :mongo\n          |> Mongo.find_one(@collection, %{@id => id})\n          |> load()\n        end\n\n      end\n\nThen we can call the functions `insert_one` and `find_one`. Thereby\nwe always use the defined structs as parameters or get the\nstruct as result:\n\n    iex(1)> card = Card.new()\n    %Card{_id: #BSON.ObjectId<5ec3ed0d306a5f377943c23c>, title: \"new title\"}\n    iex(6)> Card.insert_one(card)\n    :ok\n    iex(2)> Card.find_one(card._id)\n    %XCard{_id: #BSON.ObjectId<5ec3ecbf306a5f3779a5edaa>, title: \"new title\"}","ref":"Mongo.Collection.html#module-keeps-the-editor-happy"},{"type":"module","title":"ID generator - Mongo.Collection","doc":"In MongoDB it is common to use the attribute `_id` as id. The value is\nuses an ObjectId generated by the mongodb driver. This behavior can be specified by\nthe module attribute `@id_generator` when using `collection`.\nThe default setting is\n\n      {:_id, BSON.ObjectId.t(), &Mongo.object_id/0}\n\nNow you can overwrite this tuple `{name, type, function}` as you like:\n\n      @id_generator false # no ID creation\n      @id_generator {id, String.t, &IDGenerator.next()/0} # customized name and generator\n      @id_generator nil # use default: {:_id, BSON.ObjectId.t(), &Mongo.object_id/0}","ref":"Mongo.Collection.html#module-id-generator"},{"type":"module","title":"Embedded documents - Mongo.Collection","doc":"Until now we had only shown simple attributes. It will only be interesting when we\nembed other structs. With the macros `embeds_one/3` and `embeds_many/3`, structs can be\nadded to the attributes:","ref":"Mongo.Collection.html#module-embedded-documents"},{"type":"module","title":"Example `embeds_one` - Mongo.Collection","doc":"defmodule Label do\n\n        use Collection\n\n        document do\n          attribute :name, String.t(), default: \"warning\"\n          attribute :color, String.t(), default: :red\n        end\n\n      end\n\n      defmodule Card do\n\n        use Collection\n\n        collection \"cards\" do\n          attribute   :title, String.t()\n          attribute   :list, BSON.ObjectId.t()\n          attribute   :created, DateString.t(), default: &DateTime.utc_now/0\n          attribute   :modified, DateString.t(), default: &DateTime.utc_now/0\n          embeds_one  :label, Label, default: &Label.new/0\n        end\n\n      end\n\nIf we now call `new/0`, we get the following structure:\n\n      iex(1)> Card.new()\n      %Card{\n        _id: #BSON.ObjectId<5ec3f0f0306a5f3aa5418a24>,\n        created: ~U[2020-05-19 14:45:04.141044Z],\n        label: %Label{color: :red, name: \"warning\"},\n        list: nil,\n        modified: ~U[2020-05-19 14:45:04.141033Z],\n        title: nil\n      }\n\n\n## `after_load/1` and `before_dump/1` macros\n\nSometimes you may want to perform post-processing after loading the data set, for example\nto create derived attributes. Conversely, before saving, you may want to\ndrop the derived attributes so that they are not saved to the database.\n\nFor this reason there are two macros `after_load/1` and `before_dump/1`. You can\nspecify functions that are called after the `load/0` or before the `dump`:","ref":"Mongo.Collection.html#module-example-embeds_one"},{"type":"module","title":"Example `embeds_many` - Mongo.Collection","doc":"defmodule Board do\n\n        use Collection\n\n        collection \"boards\" do\n\n          attribute   :id, String.t()","ref":"Mongo.Collection.html#module-example-embeds_many"},{"type":"module","title":"derived attribute - Mongo.Collection","doc":"attribute   :title, String.t()\n          attribute   :created, DateString.t(), default: &DateTime.utc_now/0\n          attribute   :modified, DateString.t(), default: &DateTime.utc_now/0\n          embeds_many :lists, BoardList\n\n          after_load  &Board.after_load/1\n          before_dump &Board.before_dump/1\n        end\n\n        def after_load(%Board{_id: id} = board) do\n          %Board{board | id: BSON.ObjectId.encode!(id)}\n        end\n\n        def before_dump(board) do\n          %Board{board | id: nil}\n        end\n\n        def new(title) do\n          new()\n          |> Map.put(:title, title)\n          |> Map.put(:lists, [])\n          |> after_load()\n        end\n\n        def store(board) do\n          with map <- dump(board),\n              {:ok, _} <- Mongo.insert_one(:mongo, @collection, map) do\n            :ok\n          end\n        end\n\n        def fetch(id) do\n          :mongo\n          |> Mongo.find_one(@collection, %{@id => id})\n          |> load()\n        end\n\n      end\n\nIn this example the attribute `id` is derived from the actual ID and stored as a binary.\nThis attribute is often used and therefore we want to save the conversion of the ID.\nTo avoid storing the derived attribute `id`, the `before_dump/1` function is called, which\nremoves the `id` from the struct:\n\n      iex(1)> board = Board.new(\"Vega\")\n      %Board{\n        _id: #BSON.ObjectId<5ec3f802306a5f3ee3b71cf2>,\n        created: ~U[2020-05-19 15:15:14.374556Z],\n        id: \"5ec3f802306a5f3ee3b71cf2\",\n        lists: [],\n        modified: ~U[2020-05-19 15:15:14.374549Z],\n        title: \"Vega\"\n      }\n      iex(2)> Board.store(board)\n      :ok\n      iex(3)> Board.fetch(board._id)\n      %Board{\n        _id: #BSON.ObjectId<5ec3f802306a5f3ee3b71cf2>,\n        created: ~U[2020-05-19 15:15:14.374Z],\n        id: \"5ec3f802306a5f3ee3b71cf2\",\n        lists: [],\n        modified: ~U[2020-05-19 15:15:14.374Z],\n        title: \"Vega\"\n      }\n\nIf we call the document in the Mongo shell, we see that the attribute `id` was not stored there:\n\n      > db.boards.findOne({\"_id\" : ObjectId(\"5ec3f802306a5f3ee3b71cf2\")})\n      {\n        \"_id\" : ObjectId(\"5ec3f802306a5f3ee3b71cf2\"),\n        \"created\" : ISODate(\"2020-05-19T15:15:14.374Z\"),\n        \"lists\" : [ ],\n        \"modified\" : ISODate(\"2020-05-19T15:15:14.374Z\"),\n        \"title\" : \"Vega\"\n      }","ref":"Mongo.Collection.html#module-derived-attribute"},{"type":"module","title":"Example `timestamps` - Mongo.Collection","doc":"defmodule Post do\n\n        use Mongo.Collection\n\n        collection \"posts\" do\n          attribute :title, String.t()\n          timestamps()\n        end\n\n        def new(title) do\n          Map.put(new(), :title, title)\n        end\n\n        def store(post) do\n          MyRepo.insert_or_update(post)\n        end\n      end\n\nIn this example the macro `timestamps` is used to create two DateTime attributes, `inserted_at` and `updated_at`.\nThis macro is intented to use with the Repo module, as it will be responsible for updating the value of `updated_at` attribute before execute the action.\n\n      iex(1)> post = Post.new(\"lorem ipsum dolor sit amet\")\n      %Post{\n        _id: #BSON.ObjectId<6327a7099626f7f61607e179>,\n        inserted_at: ~U[2022-09-18 23:17:29.087092Z],\n        title: \"lorem ipsum dolor sit amet\",\n        updated_at: ~U[2022-09-18 23:17:29.087070Z]\n      }\n\n      iex(2)> Post.store(post)\n      {:ok,\n       %{\n         _id: #BSON.ObjectId<6327a7099626f7f61607e179>,\n         inserted_at: ~U[2022-09-18 23:17:29.087092Z],\n         title: \"lorem ipsum dolor sit amet\",\n         updated_at: ~U[2022-09-18 23:19:24.516648Z]\n       }}\n\nIs possible to change the field names, like Ecto does, and also change the default behaviour:\n\n      defmodule Comment do\n\n        use Mongo.Collection\n\n        collection \"comments\" do\n          attribute :text, String.t()\n          timestamps(inserted_at: :created, updated_at: :modified, default: &__MODULE__.truncated_date_time/0)\n        end\n\n        def new(text) do\n          Map.put(new(), :text, text)\n        end\n\n        def truncated_date_time() do\n          utc_now = DateTime.utc_now()\n          DateTime.truncate(utc_now, :second)\n        end\n      end\n\n      iex(1)> comment = Comment.new(\"useful comment\")\n      %Comment{\n        _id: #BSON.ObjectId<6327aa979626f7f616ae5b4a>,\n        created: ~U[2022-09-18 23:32:39Z],\n        modified: ~U[2022-09-18 23:32:39Z],\n        text: \"useful comment\"\n      }\n\n      iex(2)> {:ok, comment} = MyRepo.insert(comment)\n      {:ok,\n       %Comment{\n         _id: #BSON.ObjectId<6327aa979626f7f616ae5b4a>,\n         created: ~U[2022-09-18 23:32:39Z],\n         modified: ~U[2022-09-18 23:32:42Z],\n         text: \"useful comment\"\n       }}\n\n      iex(3)> {:ok, comment} = MyRepo.update(%{comment | text: \"not so useful comment\"})\n      {:ok,\n       %Comment{\n         _id: #BSON.ObjectId<6327aa979626f7f616ae5b4a>,\n         created: ~U[2022-09-18 23:32:39Z],\n         modified: ~U[2022-09-18 23:32:46Z],\n         text: not so useful comment\"\n       }}\n\nThe `timestamps` macro has some limitations as it does not run in batch commands like `insert_all` or `update_all`, nor does it update embedded documents.","ref":"Mongo.Collection.html#module-example-timestamps"},{"type":"function","title":"Mongo.Collection.__attribute__/4","doc":"Adds the attribute to the attributes list.","ref":"Mongo.Collection.html#__attribute__/4"},{"type":"function","title":"Mongo.Collection.__embeds_many__/5","doc":"Adds the struct to the `embeds_many` list.","ref":"Mongo.Collection.html#__embeds_many__/5"},{"type":"function","title":"Mongo.Collection.__embeds_one__/4","doc":"Adds the struct to the `embeds_one` list.","ref":"Mongo.Collection.html#__embeds_one__/4"},{"type":"macro","title":"Mongo.Collection.__id__/2","doc":"Inserts the specified `@id_generator` to the list of attributes. Calls `add_id/3`.","ref":"Mongo.Collection.html#__id__/2"},{"type":"macro","title":"Mongo.Collection.__type__/1","doc":"Inserts boilercode for the @type attribute.","ref":"Mongo.Collection.html#__type__/1"},{"type":"function","title":"Mongo.Collection.add_id/3","doc":"Inserts the specified `@id_generator` to the list of attributes.","ref":"Mongo.Collection.html#add_id/3"},{"type":"function","title":"Mongo.Collection.add_name/3","doc":"Inserts name option for the attribute, embeds_one and embeds_many.","ref":"Mongo.Collection.html#add_name/3"},{"type":"macro","title":"Mongo.Collection.after_load/1","doc":"Defines the `after_load/1` function.","ref":"Mongo.Collection.html#after_load/1"},{"type":"macro","title":"Mongo.Collection.attribute/3","doc":"Adds the attribute to the attributes list. It call `__attribute__/4` function.","ref":"Mongo.Collection.html#attribute/3"},{"type":"macro","title":"Mongo.Collection.before_dump/1","doc":"Defines the `before_dump/1` function.","ref":"Mongo.Collection.html#before_dump/1"},{"type":"macro","title":"Mongo.Collection.collection/2","doc":"Defines a struct as a collection with id generator and a collection.\n\nInside a collection block, each attribute is defined through the `attribute/3` macro.","ref":"Mongo.Collection.html#collection/2"},{"type":"function","title":"Mongo.Collection.compile_dump_steps/1","doc":"","ref":"Mongo.Collection.html#compile_dump_steps/1"},{"type":"function","title":"Mongo.Collection.compile_load_steps/3","doc":"","ref":"Mongo.Collection.html#compile_load_steps/3"},{"type":"macro","title":"Mongo.Collection.document/1","doc":"Defines a struct as a document without id generator and a collection. These documents\nare used to be embedded within collection structs.\n\nInside a document block, each attribute is defined through the `attribute/3` macro.","ref":"Mongo.Collection.html#document/1"},{"type":"function","title":"Mongo.Collection.dump/1","doc":"","ref":"Mongo.Collection.html#dump/1"},{"type":"function","title":"Mongo.Collection.dump/2","doc":"","ref":"Mongo.Collection.html#dump/2"},{"type":"macro","title":"Mongo.Collection.embeds_many/3","doc":"Adds the struct to the `embeds_many` list. Calls `__embeds_many__`","ref":"Mongo.Collection.html#embeds_many/3"},{"type":"macro","title":"Mongo.Collection.embeds_one/3","doc":"Adds the struct to the `embeds_one` list. Calls `__embeds_one__`","ref":"Mongo.Collection.html#embeds_one/3"},{"type":"function","title":"Mongo.Collection.filter_nils/1","doc":"","ref":"Mongo.Collection.html#filter_nils/1"},{"type":"function","title":"Mongo.Collection.has_dump_function?/1","doc":"Returns true, if the Module has the `dump/1` function.","ref":"Mongo.Collection.html#has_dump_function?/1"},{"type":"function","title":"Mongo.Collection.has_load_function?/1","doc":"Returns true, if the Module has the `load/1` function.","ref":"Mongo.Collection.html#has_load_function?/1"},{"type":"function","title":"Mongo.Collection.struct_args/1","doc":"Returns the default arguments for the struct. They are used to provide the\ndefault values in the `new/0` call.","ref":"Mongo.Collection.html#struct_args/1"},{"type":"function","title":"Mongo.Collection.struct_args/2","doc":"","ref":"Mongo.Collection.html#struct_args/2"},{"type":"function","title":"Mongo.Collection.timestamp/2","doc":"Inserts src_name for the timestamp attribute","ref":"Mongo.Collection.html#timestamp/2"},{"type":"macro","title":"Mongo.Collection.timestamps/1","doc":"Defines the `timestamps/1` function.","ref":"Mongo.Collection.html#timestamps/1"},{"type":"function","title":"Mongo.Collection.timestamps/3","doc":"","ref":"Mongo.Collection.html#timestamps/3"},{"type":"type","title":"Mongo.Collection.t/0","doc":"","ref":"Mongo.Collection.html#t:t/0"},{"type":"module","title":"Mongo.DeleteResult","doc":"The successful result struct of `Mongo.delete_one/4` and `Mongo.delete_many/4`.\nIts fields are:\n\n  * `:deleted_count` - Number of deleted documents\n  * `:acknowledged` - Write-concern","ref":"Mongo.DeleteResult.html"},{"type":"type","title":"Mongo.DeleteResult.t/0","doc":"","ref":"Mongo.DeleteResult.html#t:t/0"},{"type":"protocol","title":"Mongo.Encoder","doc":"","ref":"Mongo.Encoder.html"},{"type":"function","title":"Mongo.Encoder.encode/1","doc":"","ref":"Mongo.Encoder.html#encode/1"},{"type":"type","title":"Mongo.Encoder.t/0","doc":"All the types that implement this protocol.","ref":"Mongo.Encoder.html#t:t/0"},{"type":"module","title":"Mongo.FindAndModifyResult","doc":"The successful result struct of `Mongo.find_one_and_*` functions, which under\nthe hood use Mongo's `findAndModify` API.\n\nSee   for\nmore information.","ref":"Mongo.FindAndModifyResult.html"},{"type":"type","title":"Mongo.FindAndModifyResult.t/0","doc":"","ref":"Mongo.FindAndModifyResult.html#t:t/0"},{"type":"module","title":"Mongo.GridFs.Bucket","doc":"This is the MongoDB Bucket struct, which specifies the underlying collections to support GridFS. There are always\ntwo kind of collections used for storing files by GridFS. The `fs.files` collection contains the meta information about\nthe file and the `fs.chunks` collection contains the data of the file chunked into blocks of bytes. The names of the\ncollection and the size of the block is defined by the following options:\n\nThe bucket has some configuration options:\n  * `:chunk_size` - The chunk size in bytes. Defaults to `255*1024`\n  * `:name` - The bucket name. Defaults to `fs`\n\nThe bucket checks whether the indexes already exist before attempting to create them. The names of the\ncreated indexes are \"filename_1_uploadDate_1\" and \"files_id_1_n_1\"","ref":"Mongo.GridFs.Bucket.html"},{"type":"function","title":"Mongo.GridFs.Bucket.add_session/2","doc":"In case of using transaction you need to add the session to the bucket. This functions adds the session pid to\nthe bucket.","ref":"Mongo.GridFs.Bucket.html#add_session/2"},{"type":"function","title":"Mongo.GridFs.Bucket.check_and_chunks_files_index/1","doc":"","ref":"Mongo.GridFs.Bucket.html#check_and_chunks_files_index/1"},{"type":"function","title":"Mongo.GridFs.Bucket.check_and_create_files_index/1","doc":"","ref":"Mongo.GridFs.Bucket.html#check_and_create_files_index/1"},{"type":"function","title":"Mongo.GridFs.Bucket.chunks_collection_name/1","doc":"Returns the collection name for the chunks collection, default is fs.chunks.","ref":"Mongo.GridFs.Bucket.html#chunks_collection_name/1"},{"type":"function","title":"Mongo.GridFs.Bucket.delete/2","doc":"Given a `id`, delete this stored file’s files collection document and\nassociated chunks from a GridFS bucket.","ref":"Mongo.GridFs.Bucket.html#delete/2"},{"type":"function","title":"Mongo.GridFs.Bucket.drop/1","doc":"Drops the files and chunks collections associated with\nthis bucket.","ref":"Mongo.GridFs.Bucket.html#drop/1"},{"type":"function","title":"Mongo.GridFs.Bucket.files_collection_name/1","doc":"Returns the collection name for the files collection, default is fs.files.","ref":"Mongo.GridFs.Bucket.html#files_collection_name/1"},{"type":"function","title":"Mongo.GridFs.Bucket.find/3","doc":"Returns a cursor from the fs.files collection.","ref":"Mongo.GridFs.Bucket.html#find/3"},{"type":"function","title":"Mongo.GridFs.Bucket.find_one/2","doc":"Finds one file document by `file_id` specified either as a string or `BSON.ObjectId`.","ref":"Mongo.GridFs.Bucket.html#find_one/2"},{"type":"function","title":"Mongo.GridFs.Bucket.index_member?/4","doc":"","ref":"Mongo.GridFs.Bucket.html#index_member?/4"},{"type":"function","title":"Mongo.GridFs.Bucket.new/2","doc":"Creates a new Bucket with a existing connection using the default values. It just contains the\nname of the collections (fs) and the chunk size (255KB).\n\nThe bucket checks the index for both collections as well. In case of multiple\nupload or downloads just create only one bucket and reuse it.","ref":"Mongo.GridFs.Bucket.html#new/2"},{"type":"function","title":"Mongo.GridFs.Bucket.rename/3","doc":"Renames the stored file with the specified file_id.","ref":"Mongo.GridFs.Bucket.html#rename/3"},{"type":"type","title":"Mongo.GridFs.Bucket.t/0","doc":"","ref":"Mongo.GridFs.Bucket.html#t:t/0"},{"type":"module","title":"Mongo.GridFs.Download","doc":"The main entry point for downloading files from the grid-fs specified by the bucket struct.","ref":"Mongo.GridFs.Download.html"},{"type":"function","title":"Mongo.GridFs.Download.find_and_stream/2","doc":"Same as above, but returns also the file document.","ref":"Mongo.GridFs.Download.html#find_and_stream/2"},{"type":"function","title":"Mongo.GridFs.Download.find_one_file/2","doc":"","ref":"Mongo.GridFs.Download.html#find_one_file/2"},{"type":"function","title":"Mongo.GridFs.Download.open_download_stream/2","doc":"Opens a Stream from which the application can read the contents of the stored file\nspecified by fileId. The fileId can be a string, an ObjectId or just a map with the\nkeys `length` and `_id`. In case of the map the function tries to stream the chunks\ndescribed by the `length` and the `_id` values.\n\nReturns a Stream.","ref":"Mongo.GridFs.Download.html#open_download_stream/2"},{"type":"type","title":"Mongo.GridFs.Download.result/0","doc":"","ref":"Mongo.GridFs.Download.html#t:result/0"},{"type":"module","title":"Mongo.GridFs.Upload","doc":"The main entry point for uploading files into the grid-fs specified by the bucket struct.","ref":"Mongo.GridFs.Upload.html"},{"type":"function","title":"Mongo.GridFs.Upload.open_upload_stream/4","doc":"Opens a stream that the application can write the contents of the file to.\nThe driver generates the file id if not provided.\n\nUser data for the 'metadata' field of the files collection document.","ref":"Mongo.GridFs.Upload.html#open_upload_stream/4"},{"type":"module","title":"Mongo.GridFs.UploadStream","doc":"This is the upload stream for save streams into the grid fs.\n\nFirst you need to create a bucket. The bucket contains the configuration for the grid fs.","ref":"Mongo.GridFs.UploadStream.html"},{"type":"module","title":"Example: - Mongo.GridFs.UploadStream","doc":"streaming the file `./test/data/test.jpg` into the grid fs using the upload-stream\n\n    bucket = Bucket.new( pid )\n    upload_stream = Upload.open_upload_stream(bucket, \"test.jpg\", j: true)\n\n    src_filename = \"./test/data/test.jpg\"\n    File.stream!(src_filename, [], 512) |> Stream.into(upload_stream) |> Stream.run()","ref":"Mongo.GridFs.UploadStream.html#module-example"},{"type":"function","title":"Mongo.GridFs.UploadStream.new/4","doc":"Creates a new upload stream to insert a file into the grid-fs.","ref":"Mongo.GridFs.UploadStream.html#new/4"},{"type":"type","title":"Mongo.GridFs.UploadStream.file_id/0","doc":"","ref":"Mongo.GridFs.UploadStream.html#t:file_id/0"},{"type":"type","title":"Mongo.GridFs.UploadStream.t/0","doc":"","ref":"Mongo.GridFs.UploadStream.html#t:t/0"},{"type":"module","title":"Mongo.InsertManyResult","doc":"The successful result struct of `Mongo.insert_many/4`. Its fields are:\n\n  * `:inserted_ids` - The ids of the inserted documents indexed by their order","ref":"Mongo.InsertManyResult.html"},{"type":"type","title":"Mongo.InsertManyResult.t/0","doc":"","ref":"Mongo.InsertManyResult.html#t:t/0"},{"type":"module","title":"Mongo.InsertOneResult","doc":"The successful result struct of `Mongo.insert_one/4`. Its fields are:\n\n  * `:inserted_id` - The id of the inserted document","ref":"Mongo.InsertOneResult.html"},{"type":"type","title":"Mongo.InsertOneResult.t/0","doc":"","ref":"Mongo.InsertOneResult.html#t:t/0"},{"type":"module","title":"Mongo.Messages","doc":"This module encodes and decodes the data from and to the mongodb server.\n  We only support MongoDB >= 3.2 and use op_query with the hack collection \"$cmd\"\n  Other op codes are deprecated. Therefore only op_reply and op_query are supported.","ref":"Mongo.Messages.html"},{"type":"function","title":"Mongo.Messages.decode_header/1","doc":"Decodes the header from response of a request sent by the mongodb server","ref":"Mongo.Messages.html#decode_header/1"},{"type":"function","title":"Mongo.Messages.decode_msg/1","doc":"","ref":"Mongo.Messages.html#decode_msg/1"},{"type":"function","title":"Mongo.Messages.decode_reply/1","doc":"Decodes a reply message from the response","ref":"Mongo.Messages.html#decode_reply/1"},{"type":"function","title":"Mongo.Messages.decode_response/2","doc":"Decodes the response body of a request sent by the mongodb server","ref":"Mongo.Messages.html#decode_response/2"},{"type":"function","title":"Mongo.Messages.decode_sections/1","doc":"","ref":"Mongo.Messages.html#decode_sections/1"},{"type":"function","title":"Mongo.Messages.decode_sections/2","doc":"","ref":"Mongo.Messages.html#decode_sections/2"},{"type":"function","title":"Mongo.Messages.decode_sequence/1","doc":"","ref":"Mongo.Messages.html#decode_sequence/1"},{"type":"function","title":"Mongo.Messages.encode/2","doc":"","ref":"Mongo.Messages.html#encode/2"},{"type":"macro","title":"Mongo.Messages.msg_header/1","doc":"","ref":"Mongo.Messages.html#msg_header/1"},{"type":"macro","title":"Mongo.Messages.msg_header/2","doc":"","ref":"Mongo.Messages.html#msg_header/2"},{"type":"macro","title":"Mongo.Messages.op_msg/1","doc":"","ref":"Mongo.Messages.html#op_msg/1"},{"type":"macro","title":"Mongo.Messages.op_msg/2","doc":"","ref":"Mongo.Messages.html#op_msg/2"},{"type":"macro","title":"Mongo.Messages.op_msg_compressed/1","doc":"","ref":"Mongo.Messages.html#op_msg_compressed/1"},{"type":"macro","title":"Mongo.Messages.op_msg_compressed/2","doc":"","ref":"Mongo.Messages.html#op_msg_compressed/2"},{"type":"macro","title":"Mongo.Messages.op_query/1","doc":"","ref":"Mongo.Messages.html#op_query/1"},{"type":"macro","title":"Mongo.Messages.op_query/2","doc":"","ref":"Mongo.Messages.html#op_query/2"},{"type":"macro","title":"Mongo.Messages.op_reply/1","doc":"","ref":"Mongo.Messages.html#op_reply/1"},{"type":"macro","title":"Mongo.Messages.op_reply/2","doc":"","ref":"Mongo.Messages.html#op_reply/2"},{"type":"macro","title":"Mongo.Messages.payload/1","doc":"","ref":"Mongo.Messages.html#payload/1"},{"type":"macro","title":"Mongo.Messages.payload/2","doc":"","ref":"Mongo.Messages.html#payload/2"},{"type":"macro","title":"Mongo.Messages.section/1","doc":"","ref":"Mongo.Messages.html#section/1"},{"type":"macro","title":"Mongo.Messages.section/2","doc":"","ref":"Mongo.Messages.html#section/2"},{"type":"macro","title":"Mongo.Messages.sequence/1","doc":"","ref":"Mongo.Messages.html#sequence/1"},{"type":"macro","title":"Mongo.Messages.sequence/2","doc":"","ref":"Mongo.Messages.html#sequence/2"},{"type":"module","title":"Mongo.MongoDBConnection","doc":"Implementation of the DBConnection behaviour module.","ref":"Mongo.MongoDBConnection.html"},{"type":"module","title":"Mongo.Monitor","doc":"Each server has a monitor process. The monitor process is created by the topology process.\n\nIf the network connection is working, then the monitor process reports this and the topology process starts the\nconnection pool. Per server we get 1 + pool size connections to each server.\n\nAfter waiting for `heartbeat_frequency_ms` milliseconds, the monitor process calls `hello` command and\nreports the result to the topology process.\n\nThe result of the hello command is mapped the `ServerDescription` structure and sent to the topology process, which\nupdates it internal data structure.\n\nsee https://github.com/mongodb/specifications/blob/master/source/server-discovery-and-monitoring/server-discovery-and-monitoring.rst#monitoring","ref":"Mongo.Monitor.html"},{"type":"function","title":"Mongo.Monitor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Mongo.Monitor.html#child_spec/1"},{"type":"function","title":"Mongo.Monitor.connected/3","doc":"Report the connection event, so the topology process can now create the connection pool.","ref":"Mongo.Monitor.html#connected/3"},{"type":"function","title":"Mongo.Monitor.force_check/1","doc":"Try to update the server description.","ref":"Mongo.Monitor.html#force_check/1"},{"type":"function","title":"Mongo.Monitor.get_state/1","doc":"","ref":"Mongo.Monitor.html#get_state/1"},{"type":"function","title":"Mongo.Monitor.info/1","doc":"","ref":"Mongo.Monitor.html#info/1"},{"type":"function","title":"Mongo.Monitor.init/1","doc":"Initialize the monitor process","ref":"Mongo.Monitor.html#init/1"},{"type":"function","title":"Mongo.Monitor.modes/0","doc":"Returns the possible modes of the monitor process.","ref":"Mongo.Monitor.html#modes/0"},{"type":"function","title":"Mongo.Monitor.set_heartbeat_frequency_ms/2","doc":"","ref":"Mongo.Monitor.html#set_heartbeat_frequency_ms/2"},{"type":"function","title":"Mongo.Monitor.start_link/1","doc":"","ref":"Mongo.Monitor.html#start_link/1"},{"type":"function","title":"Mongo.Monitor.stop_streaming_mode/1","doc":"","ref":"Mongo.Monitor.html#stop_streaming_mode/1"},{"type":"function","title":"Mongo.Monitor.terminate/2","doc":"In case of terminating we stop our linked processes as well:\n* connection\n* streaming process","ref":"Mongo.Monitor.html#terminate/2"},{"type":"module","title":"Mongo.OrderedBulk","doc":"An **ordered** bulk is filled in the memory with the bulk operations. If the ordered bulk is written to the database, the order\nis preserved. Only same types of operation are grouped and only if they have been inserted one after the other.","ref":"Mongo.OrderedBulk.html"},{"type":"module","title":"Example - Mongo.OrderedBulk","doc":"```\nalias Mongo.OrderedBulk\nalias Mongo.BulkWrite\n\nbulk = \"bulk\"\n|> OrderedBulk.new()\n|> OrderedBulk.insert_one(%{name: \"Greta\"})\n|> OrderedBulk.insert_one(%{name: \"Tom\"})\n|> OrderedBulk.insert_one(%{name: \"Waldo\"})\n|> OrderedBulk.update_one(%{name: \"Greta\"}, %{\"$set\": %{kind: \"dog\"}})\n|> OrderedBulk.update_one(%{name: \"Tom\"}, %{\"$set\": %{kind: \"dog\"}})\n|> OrderedBulk.update_one(%{name: \"Waldo\"}, %{\"$set\": %{kind: \"dog\"}})\n|> OrderedBulk.update_many(%{kind: \"dog\"}, %{\"$set\": %{kind: \"cat\"}})\n|> OrderedBulk.delete_one(%{kind: \"cat\"})\n|> OrderedBulk.delete_one(%{kind: \"cat\"})\n|> OrderedBulk.delete_one(%{kind: \"cat\"})\n\nBulkWrite.write(:mongo, bulk, w: 1)\n```\n\nThis example would not work by using an unordered bulk, because the `OrderedBulk.update_many` would executed too early.\n\nTo reduce the memory usage the ordered bulk can be used with streams as well.","ref":"Mongo.OrderedBulk.html#module-example"},{"type":"module","title":"Example - Mongo.OrderedBulk","doc":"```\n alias Mongo.OrderedBulk\n\n 1..1000\n |> Stream.map(fn\n   1    -> BulkOps.get_insert_one(%{count: 1})\n   1000 -> BulkOps.get_delete_one(%{count: 999})\n   i    -> BulkOps.get_update_one(%{count: i - 1}, %{\"$set\": %{count: i}})\n end)\n |> OrderedBulk.write(:mongo, \"bulk\", 25)\n |> Stream.run()\n```\n\nOf course, this example is a bit silly. A sequence of update operations is created that only work in the correct order.","ref":"Mongo.OrderedBulk.html#module-example"},{"type":"function","title":"Mongo.OrderedBulk.delete_many/2","doc":"Appends a delete operation with `:limit = 0`.\n\n  Example:\n\n```\nMongo.OrderedBulk.delete_many(bulk, %{name: \"Waldo\"})\n%Mongo.OrderedBulk{coll: \"bulk\", ops: [delete: {%{name: \"Waldo\"}, [limit: 0]}]}\n```","ref":"Mongo.OrderedBulk.html#delete_many/2"},{"type":"function","title":"Mongo.OrderedBulk.delete_one/2","doc":"Appends a delete operation with `:limit = 1`.\n\nExample:\n\n```\nMongo.OrderedBulk.delete_one(bulk, %{name: \"Waldo\"})\n%Mongo.OrderedBulk{coll: \"bulk\", ops: [delete: {%{name: \"Waldo\"}, [limit: 1]}]}\n```","ref":"Mongo.OrderedBulk.html#delete_one/2"},{"type":"function","title":"Mongo.OrderedBulk.empty?/1","doc":"Returns true, if the bulk is empty, that means it contains no inserts, updates or deletes operations","ref":"Mongo.OrderedBulk.html#empty?/1"},{"type":"function","title":"Mongo.OrderedBulk.insert_one/2","doc":"Appends an insert operation.\n\nExample:\n\n```\nMongo.OrderedBulk.insert_one(bulk, %{name: \"Waldo\"})\n%Mongo.OrderedBulk{coll: \"bulk\", ops: [insert: %{name: \"Waldo\"}]}\n```","ref":"Mongo.OrderedBulk.html#insert_one/2"},{"type":"function","title":"Mongo.OrderedBulk.new/1","doc":"Creates an empty ordered bulk for a collection.\n\nExample:\n\n```\nMongo.orderedBulk.new(\"bulk\")\n%Mongo.OrderedBulk{coll: \"bulk\", ops: []}\n```","ref":"Mongo.OrderedBulk.html#new/1"},{"type":"function","title":"Mongo.OrderedBulk.push/2","doc":"Appends a bulk operation to the ordered bulk.","ref":"Mongo.OrderedBulk.html#push/2"},{"type":"function","title":"Mongo.OrderedBulk.replace_one/4","doc":"Appends a replace operation with `:multi = false`.\n\n  Example:\n\n```\nMongo.OrderedBulk.replace_one(bulk, %{name: \"Waldo\"}, %{name: \"Greta\", kind: \"dog\"})\n%Mongo.OrderedBulk{\ncoll: \"bulk\",\nops: [\n  update: {%{name: \"Waldo\"}, %{kind: \"dog\", name: \"Greta\"}, [multi: false]}\n]\n}\n```","ref":"Mongo.OrderedBulk.html#replace_one/4"},{"type":"function","title":"Mongo.OrderedBulk.update_many/4","doc":"Appends a update operation with `:multi = true`.\n\n  Example:\n\n```\nMongo.OrderedBulk.update_many(bulk, %{name: \"Waldo\"}, %{\"$set\": %{name: \"Greta\", kind: \"dog\"}})\n%Mongo.OrderedBulk{\ncoll: \"bulk\",\nops: [\n  update: {%{name: \"Waldo\"}, %{\"$set\": %{kind: \"dog\", name: \"Greta\"}},\n   [multi: true]}\n]\n}\n```","ref":"Mongo.OrderedBulk.html#update_many/4"},{"type":"function","title":"Mongo.OrderedBulk.update_one/4","doc":"Appends a update operation with `:multi = false`.\n\n  Example:\n\n```\nMongo.OrderedBulk.update_one(bulk, %{name: \"Waldo\"}, %{\"$set\": %{name: \"Greta\", kind: \"dog\"}})\n%Mongo.OrderedBulk{\ncoll: \"bulk\",\nops: [\n  update: {%{name: \"Waldo\"}, %{\"$set\": %{kind: \"dog\", name: \"Greta\"}},\n   [multi: false]}\n]\n}\n```","ref":"Mongo.OrderedBulk.html#update_one/4"},{"type":"function","title":"Mongo.OrderedBulk.write/5","doc":"Returns a stream chunk function that can be used with streams. The `limit` specifies the number\nof operation hold in the memory while processing the stream inputs.\n\nThe inputs of the stream should be `Mongo.BulkOps.bulk_op`. See `Mongo.BulkOps`","ref":"Mongo.OrderedBulk.html#write/5"},{"type":"type","title":"Mongo.OrderedBulk.t/0","doc":"","ref":"Mongo.OrderedBulk.html#t:t/0"},{"type":"module","title":"Mongo.PBKDF2","doc":"`PBKDF2` implements PBKDF2 (Password-Based Key Derivation Function 2),\npart of PKCS #5 v2.0 (Password-Based Cryptography Specification).\nIt can be used to derive a number of keys for various purposes from a given\nsecret. This lets applications have a single secure secret, but avoid reusing\nthat key in multiple incompatible contexts.\nsee http://tools.ietf.org/html/rfc2898#section-5.2","ref":"Mongo.PBKDF2.html"},{"type":"function","title":"Mongo.PBKDF2.generate/3","doc":"Returns a derived key suitable for use.","ref":"Mongo.PBKDF2.html#generate/3"},{"type":"function","title":"Options - Mongo.PBKDF2.generate/3","doc":"* `:iterations` - defaults to 1000 (increase to at least 2^16 if used for\n    passwords)\n  * `:length` - a length in octets for the derived key. Defaults to 32\n  * `:digest` - an hmac function to use as the pseudo-random function.\n    Defaults to `:sha256`","ref":"Mongo.PBKDF2.html#generate/3-options"},{"type":"module","title":"Mongo.PasswordSafe","doc":"The password safe stores the password while parsing the url and/or the options to avoid it from logging while the sasl logger is activated.\n\nThe password is encrypted before storing in the GenServer's state. It will be encrypted before returning. This should help, that the password\nis not stored as plain text in the memory.","ref":"Mongo.PasswordSafe.html"},{"type":"function","title":"Mongo.PasswordSafe.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Mongo.PasswordSafe.html#child_spec/1"},{"type":"function","title":"Mongo.PasswordSafe.get_password/1","doc":"","ref":"Mongo.PasswordSafe.html#get_password/1"},{"type":"function","title":"Mongo.PasswordSafe.init/1","doc":"","ref":"Mongo.PasswordSafe.html#init/1"},{"type":"function","title":"Mongo.PasswordSafe.set_password/2","doc":"","ref":"Mongo.PasswordSafe.html#set_password/2"},{"type":"function","title":"Mongo.PasswordSafe.start_link/0","doc":"","ref":"Mongo.PasswordSafe.html#start_link/0"},{"type":"module","title":"Mongo.Query","doc":"This is the query implementation for the Query Protocol\n\nEncoding and decoding does not take place at this point, but is directly performed\n  into the functions of Mongo.MongoDBConnection.Utils.","ref":"Mongo.Query.html"},{"type":"module","title":"Mongo.ReadPreference","doc":"Determines which servers are considered suitable for read operations\n\nA read preference consists of a mode and optional `tags`, max_staleness_ms, and `hedge`.\nThe mode prioritizes between primaries and secondaries to produce either a single suitable server or a list of candidate servers.\nIf tags and maxStalenessSeconds are set, they determine which candidate servers are eligible for selection.\nIf hedge is set, it configures how server hedged reads are used.\n\nThe default mode is `:primary`.\nThe default tags is a list with an empty tag set: [{}].\nThe default max_staleness_ms is unset.\nThe default hedge is unset.","ref":"Mongo.ReadPreference.html"},{"type":"module","title":"mode - Mongo.ReadPreference","doc":"* `:primary` Only an available primary is suitable.\n* `:secondary` All secondaries (and only secondaries) are candidates, but only eligible candidates (i.e. after applying tags and maxStalenessSeconds) are suitable.\n* `:primary_preferred` If a primary is available, only the primary is suitable. Otherwise, all secondaries are candidates,\n     but only eligible secondaries are suitable.\n* `:secondary_preferred` All secondaries are candidates. If there is at least one eligible secondary, only eligible secondaries are suitable.\n     Otherwise, when there are no eligible secondaries, the primary is suitable.\n* `:nearest` The primary and all secondaries are candidates, but only eligible candidates are suitable.","ref":"Mongo.ReadPreference.html#module-mode"},{"type":"function","title":"Mongo.ReadPreference.add_read_preference/2","doc":"Add read preference to the cmd","ref":"Mongo.ReadPreference.html#add_read_preference/2"},{"type":"function","title":"Mongo.ReadPreference.merge_defaults/1","doc":"Merge default values to the read preferences and converts deprecated tag_sets to tags","ref":"Mongo.ReadPreference.html#merge_defaults/1"},{"type":"function","title":"Mongo.ReadPreference.to_mongos/1","doc":"Converts the preference to the mongodb format for mongos","ref":"Mongo.ReadPreference.html#to_mongos/1"},{"type":"function","title":"Mongo.ReadPreference.to_replica_set/1","doc":"Converts the preference to the mongodb format for replica sets","ref":"Mongo.ReadPreference.html#to_replica_set/1"},{"type":"function","title":"Mongo.ReadPreference.to_topology_single_type/1","doc":"","ref":"Mongo.ReadPreference.html#to_topology_single_type/1"},{"type":"behaviour","title":"Mongo.Repo","doc":"Defines a repository.\n\nA repository serves as a convenience module for a mongodb instance.\n\nTo include the `Mongo.Repo` module in your application, you can put the use macro in your\napp's Repo module.\n\n    defmodule MyApp.Repo do\n      use Mongo.Repo,\n        otp_app: :my_app,\n        topology: :mongo\n    end\n\nWith that in place we can configure the Repo:\n\n    config :my_app, MyApp.Repo,\n      url: \"mongodb://localhost:27017/my-app-dev\",\n      timeout: 60_000,\n      idle_interval: 10_000,\n      queue_target: 5_000\n\nFor a complete list of configuration options take a look at `Mongo`.\n\nFinally we can add the `Mongo.Repo` instance to our application supervision tree\n\n    children = [\n      # ...\n      MyApp.Repo,\n      # ...\n    ]","ref":"Mongo.Repo.html"},{"type":"behaviour","title":"Read-only repositories - Mongo.Repo","doc":"To explicitly set a repository as read-only, we can pass in the `:read_only` flag to `use`:\n\n    use Mongo.Repo,\n      otp_app: :my_app,\n      topology: :mongo,\n      read_only: true\n\nThe read-only option will not include any write operation related functions in the module.","ref":"Mongo.Repo.html#module-read-only-repositories"},{"type":"callback","title":"Mongo.Repo.aggregate/3","doc":"Performs aggregation operation using the aggregation pipeline on the given collection module and returns\na list of collection structs.\n\nFor all options see [Options](https://docs.mongodb.com/manual/reference/command/aggregate/#aggregate)","ref":"Mongo.Repo.html#c:aggregate/3"},{"type":"callback","title":"Example - Mongo.Repo.aggregate/3","doc":"MyApp.Repo.aggregate(Post, [\n      %{\"$match\" => %{title: title}},\n      %{\"$sort\" => [{\"title\", -1}]},\n      %{\"$limit\" => 10}\n    ])","ref":"Mongo.Repo.html#c:aggregate/3-example"},{"type":"callback","title":"Mongo.Repo.all/3","doc":"Selects documents for the collection defined in the given module and returns a list of collection\nstructs for the given filter\n\nFor all options see [Options](https://docs.mongodb.com/manual/reference/command/find/#dbcmd.find)","ref":"Mongo.Repo.html#c:all/3"},{"type":"callback","title":"Example - Mongo.Repo.all/3","doc":"MyApp.Repo.all(Post, %{title: title})\n    MyApp.Repo.all(Post, %{title: title}, batch_size: 2)","ref":"Mongo.Repo.html#c:all/3-example"},{"type":"callback","title":"Mongo.Repo.config/0","doc":"Returns the mongo configuration stored in the `:otp_app` environment.","ref":"Mongo.Repo.html#c:config/0"},{"type":"callback","title":"Mongo.Repo.count/3","doc":"Returns the count of documents in the given collection module for the given filter.","ref":"Mongo.Repo.html#c:count/3"},{"type":"callback","title":"Options - Mongo.Repo.count/3","doc":"* `:limit` - Maximum number of documents to fetch with the cursor\n  * `:skip` - Number of documents to skip before returning the first","ref":"Mongo.Repo.html#c:count/3-options"},{"type":"callback","title":"Example - Mongo.Repo.count/3","doc":"MyApp.Repo.count(Post)","ref":"Mongo.Repo.html#c:count/3-example"},{"type":"callback","title":"Mongo.Repo.delete/2","doc":"Deletes a document struct from the database and returns a `{:ok, doc}` tuple.\n\nFor all options see [Options](https://www.mongodb.com/docs/manual/reference/method/db.collection.deleteOne/)","ref":"Mongo.Repo.html#c:delete/2"},{"type":"callback","title":"Example - Mongo.Repo.delete/2","doc":"MyApp.Repo.delete(post)","ref":"Mongo.Repo.html#c:delete/2-example"},{"type":"callback","title":"Mongo.Repo.delete!/2","doc":"Same as `c:delete/2` but raises an error.","ref":"Mongo.Repo.html#c:delete!/2"},{"type":"callback","title":"Mongo.Repo.delete_all/3","doc":"Deletes all documents for the given collection module and filter.\n\nFor all options see [Options](https://www.mongodb.com/docs/manual/reference/command/delete/#dbcmd.delete)","ref":"Mongo.Repo.html#c:delete_all/3"},{"type":"callback","title":"Example - Mongo.Repo.delete_all/3","doc":"MyApp.Repo.delete_all(Post, %{})\n    MyApp.Repo.delete_all(Post, %{title: \"todelete\"})","ref":"Mongo.Repo.html#c:delete_all/3-example"},{"type":"callback","title":"Mongo.Repo.exists?/3","doc":"Checks whether there are any documents in the given collection module for the given filter.\n\nReturns a boolean.","ref":"Mongo.Repo.html#c:exists?/3"},{"type":"callback","title":"Example - Mongo.Repo.exists?/3","doc":"MyApp.Repo.exists?(Post, %{title: title})","ref":"Mongo.Repo.html#c:exists?/3-example"},{"type":"callback","title":"Mongo.Repo.fetch/3","doc":"Returns a single document struct for the collection defined in the given module and bson object id as\na tuple of `{:ok, document}`.\n\nReturns `{:error, :not_found}` if no result was found.\n\nIf multiple documents satisfy the query, this method returns the first document\naccording to the natural order which reflects the order of documents on the disk.\n\nFor all options see [Options](https://docs.mongodb.com/manual/reference/command/find/#dbcmd.find)","ref":"Mongo.Repo.html#c:fetch/3"},{"type":"callback","title":"Example - Mongo.Repo.fetch/3","doc":"MyApp.Repo.fetch(Post, id)\n    MyApp.Repo.fetch(Post, id, read_concern: %{level: \"local\"})","ref":"Mongo.Repo.html#c:fetch/3-example"},{"type":"callback","title":"Mongo.Repo.fetch_by/3","doc":"Returns a single document struct for the collection defined in the given module and query as\na tuple of `{:ok, document}`.\n\nReturns `{:error, :not_found}` if no result was found.\n\nIf multiple documents satisfy the query, this method returns the first document\naccording to the natural order which reflects the order of documents on the disk.\n\nFor all options see [Options](https://docs.mongodb.com/manual/reference/command/find/#dbcmd.find)","ref":"Mongo.Repo.html#c:fetch_by/3"},{"type":"callback","title":"Example - Mongo.Repo.fetch_by/3","doc":"MyApp.Repo.fetch_by(Post, %{title: title})\n    MyApp.Repo.fetch_by(Post, %{title: title}, read_concern: %{level: \"local\"})","ref":"Mongo.Repo.html#c:fetch_by/3-example"},{"type":"callback","title":"Mongo.Repo.get/3","doc":"Returns a single document struct for the collection defined in the given module and bson object id.\n\nReturns `nil` if no result was found.\n\nIf multiple documents satisfy the query, this method returns the first document\naccording to the natural order which reflects the order of documents on the disk.\n\nFor all options see [Options](https://docs.mongodb.com/manual/reference/command/find/#dbcmd.find)","ref":"Mongo.Repo.html#c:get/3"},{"type":"callback","title":"Example - Mongo.Repo.get/3","doc":"MyApp.Repo.get(Post, id)\n    MyApp.Repo.get(Post, id, read_concern: %{level: \"local\"})","ref":"Mongo.Repo.html#c:get/3-example"},{"type":"callback","title":"Mongo.Repo.get_by/3","doc":"Returns a single document struct for the collection defined in the given module and query.\n\nReturns `nil` if no result was found.\n\nIf multiple documents satisfy the query, this method returns the first document\naccording to the natural order which reflects the order of documents on the disk.\n\nFor all options see [Options](https://docs.mongodb.com/manual/reference/command/find/#dbcmd.find)","ref":"Mongo.Repo.html#c:get_by/3"},{"type":"callback","title":"Example - Mongo.Repo.get_by/3","doc":"MyApp.Repo.get_by(Post, %{title: title})\n    MyApp.Repo.get_by(Post, %{title: title}, read_concern: %{level: \"local\"})","ref":"Mongo.Repo.html#c:get_by/3-example"},{"type":"callback","title":"Mongo.Repo.insert/2","doc":"Inserts a new document struct into the database and returns a `{:ok, doc}` tuple.\n\nFor all options see [Options](https://www.mongodb.com/docs/manual/reference/method/db.collection.insertOne/#mongodb-method-db.collection.insertOne)","ref":"Mongo.Repo.html#c:insert/2"},{"type":"callback","title":"Example - Mongo.Repo.insert/2","doc":"MyApp.Repo.insert(Post.new())","ref":"Mongo.Repo.html#c:insert/2-example"},{"type":"callback","title":"Mongo.Repo.insert!/2","doc":"Same as `c:insert/2` but raises an error.","ref":"Mongo.Repo.html#c:insert!/2"},{"type":"callback","title":"Mongo.Repo.insert_all/3","doc":"Inserts all given documents into the document in one write operation and returns an `:ok` tuple\nwith the count of inserted documents as second element and the inserted ids as third element.\n\nReturns `{:error, reason}` on failure.","ref":"Mongo.Repo.html#c:insert_all/3"},{"type":"callback","title":"Example - Mongo.Repo.insert_all/3","doc":"MyApp.Repo.insert_all(Post, [%{title: \"a\"}, %{title: \"b\"}])","ref":"Mongo.Repo.html#c:insert_all/3-example"},{"type":"callback","title":"Mongo.Repo.insert_or_update/2","doc":"Upserts a document struct and returns a `{:ok, doc}` tuple.","ref":"Mongo.Repo.html#c:insert_or_update/2"},{"type":"callback","title":"Example - Mongo.Repo.insert_or_update/2","doc":"MyApp.Repo.insert_or_update(Post.new())","ref":"Mongo.Repo.html#c:insert_or_update/2-example"},{"type":"callback","title":"Mongo.Repo.insert_or_update!/2","doc":"Same as `c:insert_or_update/2` but raises an error.","ref":"Mongo.Repo.html#c:insert_or_update!/2"},{"type":"callback","title":"Mongo.Repo.stream/3","doc":"Selects documents for the collection defined in the given module and returns a stream of collection\nstructs for the given filter\n\nFor all options see [Options](https://docs.mongodb.com/manual/reference/command/find/#dbcmd.find)","ref":"Mongo.Repo.html#c:stream/3"},{"type":"callback","title":"Example - Mongo.Repo.stream/3","doc":"MyApp.Repo.stream(Post, %{title: title})\n    MyApp.Repo.stream(Post, %{title: title}, batch_size: 2)","ref":"Mongo.Repo.html#c:stream/3-example"},{"type":"callback","title":"Mongo.Repo.transaction/2","doc":"Convenient function for running multiple write commands in a transaction.\n\nIn case of `TransientTransactionError` or `UnknownTransactionCommitResult` the function will retry the whole transaction or\nthe commit of the transaction. You can specify a timeout (`:transaction_retry_timeout_s`) to limit the time of repeating.\nThe default value is 120 seconds. If you don't wait so long, you call `transaction` with the\noption `transaction_retry_timeout_s: 10`. In this case after 10 seconds of retrying, the function will return\nan error.\n\nYou can nest the function calls. In this case the first session will be reused.","ref":"Mongo.Repo.html#c:transaction/2"},{"type":"callback","title":"Mongo.Repo.update/2","doc":"Updates a document struct and returns a `{:ok, doc}` tuple.","ref":"Mongo.Repo.html#c:update/2"},{"type":"callback","title":"Example - Mongo.Repo.update/2","doc":"post = MyApp.Repo.insert!(Post.new())\n    MyApp.Repo.update(%{post | title: \"new\"})","ref":"Mongo.Repo.html#c:update/2-example"},{"type":"callback","title":"Mongo.Repo.update!/2","doc":"Same as `c:update/2` but raises an error.","ref":"Mongo.Repo.html#c:update!/2"},{"type":"callback","title":"Mongo.Repo.update_all/4","doc":"Applies the updates for the documents in the given collection module and filter.\n\nUses MongoDB update operators to specify the updates. For more information and all options\nplease refer to the [MongoDB documentation](https://docs.mongodb.com/manual/reference/command/update/#dbcmd.update)","ref":"Mongo.Repo.html#c:update_all/4"},{"type":"callback","title":"Example - Mongo.Repo.update_all/4","doc":"MyApp.Repo.update_all(Post, %{}, %{\"$set\" => %{title: \"updated\"}})\n    MyApp.Repo.update_all(Post, %{title: \"old\"}, %{\"$set\" => %{title: \"updated\"}})","ref":"Mongo.Repo.html#c:update_all/4-example"},{"type":"type","title":"Mongo.Repo.t/0","doc":"","ref":"Mongo.Repo.html#t:t/0"},{"type":"module","title":"Mongo.Session","doc":"This module implements the details of the transactions api ([see specs](https://github.com/mongodb/specifications/blob/master/source/transactions/transactions.rst#committransaction)).\n\nIn case of MongoDB 3.6 or greater the driver uses sessions for each operation. If no session is created the driver will create a so-called implicit session. A session is a UUID-Number which\nis added to some operations. The sessions are used to manage the transaction state as well. In most situation you need not to create a session instance, so the api of the driver is not changed.\n\nIn case of multiple insert statements you can use transaction (MongoDB 4.x) to be sure that all operations are grouped like a single operation. Prerequisites for transactions are:\nMongoDB 4.x must be used as replica set or cluster deployment. The collection used in the operations must already exist. Some operation are not allowed (For example: create index or call count).","ref":"Mongo.Session.html"},{"type":"module","title":"Example - Mongo.Session","doc":"alias Mongo.Session\n\n    {:ok, session} = Session.start_session(top, :write, [])\n    :ok = Session.start_transaction(session)\n\n    Mongo.insert_one(top, \"dogs\", %{name: \"Greta\"}, session: session)\n    Mongo.insert_one(top, \"dogs\", %{name: \"Waldo\"}, session: session)\n    Mongo.insert_one(top, \"dogs\", %{name: \"Tom\"}, session: session)\n\n    :ok = Session.commit_transaction(session)\n    :ok = Session.end_session(top, session)\n\nFirst you start a explicit session and a transactions. Use the session for each insert statement as an options with key `:session` otherwise the insert statement won't be\nexecuted in the transaction. After that you commit the transaction and end the session by calling `end_session`.","ref":"Mongo.Session.html#module-example"},{"type":"module","title":"Convenient API for Transactions - Mongo.Session","doc":"This method is responsible for starting a transaction, invoking a callback, and committing a transaction.\nThe callback is expected to execute one or more operations with the transaction; however, that is not enforced.\nThe callback is allowed to execute other operations not associated with the transaction.","ref":"Mongo.Session.html#module-convenient-api-for-transactions"},{"type":"module","title":"Example - Mongo.Session","doc":"{:ok, ids} = Mongo.transaction(top, fn ->\n      {:ok, %InsertOneResult{:inserted_id => id1}} = Mongo.insert_one(top, \"dogs\", %{name: \"Greta\"})\n      {:ok, %InsertOneResult{:inserted_id => id2}} = Mongo.insert_one(top, \"dogs\", %{name: \"Waldo\"})\n      {:ok, %InsertOneResult{:inserted_id => id3}} = Mongo.insert_one(top, \"dogs\", %{name: \"Tom\"})\n      {:ok, [id1, id2, id3]}\n    end, w: 3)\n\nIf the callback is successful then it returns a tuple with the keyword `:ok` and a used defined result like `{:ok, [id1, id2, id3]}`. In this example we use\nthe write concern `w: 3`. The write concern used in the insert operation will be removed by the driver. It is applied in the commit transaction command.","ref":"Mongo.Session.html#module-example"},{"type":"module","title":"Implicit vs explicit sessions - Mongo.Session","doc":"In most cases the driver will create implicit sessions for you. The session is put in the process' dictionary under the key `:session` and the opts\nis extended by `:session` as well. This behaviour is specified by the mongodb specification for\n[drivers](https://github.com/mongodb/specifications/blob/master/source/sessions/driver-sessions.rst#explicit-vs-implicit-sessions).\n\nIf you use the `:causal_consistency` flag, then you need to create an explicit session:\n\n    alias Mongo.Session\n\n    {:ok, session} = Session.start_session(top, :write, causal_consistency: true)\n\n    Mongo.delete_many(top, \"dogs\", %{\"Greta\"}, session: session, w: :majority)\n    {:ok, 0} = Mongo.count(top, \"dogs\", %{name: \"Greta\"}, session: session, read_concern: %{level: :majority})\n\n    :ok = Session.end_session(top, session)\n\nFor more information about causal consistency see the [officially documentation](https://docs.mongodb.com/manual/core/read-isolation-consistency-recency/#causal-consistency).\n\nNote that Mongo.Stream implements the Enumerable protocol and the reduce/3 function calls Mongo.Stream.checkin_session/3 after the stream is exhausted.\n\nIf you want to use transaction, then you need to create a session as well:\n\n    alias Mongo.Session\n\n    {:ok, session} = Session.start_session(top, :write, [])\n    :ok = Session.start_transaction(session)\n\n    Mongo.insert_one(top, \"dogs\", %{name: \"Greta\"}, session: session)\n    Mongo.insert_one(top, \"dogs\", %{name: \"Waldo\"}, session: session)\n    Mongo.insert_one(top, \"dogs\", %{name: \"Tom\"}, session: session)\n\n    :ok = Session.commit_transaction(session)\n    :ok = Session.end_session(top, session)\n\nYou can shorten this code by using the `with_transaction` function:\n\n    {:ok, ids} = Mongo.transaction(top, fn ->\n      {:ok, %InsertOneResult{:inserted_id => id1}} = Mongo.insert_one(top, \"dogs\", %{name: \"Greta\"})\n      {:ok, %InsertOneResult{:inserted_id => id2}} = Mongo.insert_one(top, \"dogs\", %{name: \"Waldo\"})\n      {:ok, %InsertOneResult{:inserted_id => id3}} = Mongo.insert_one(top, \"dogs\", %{name: \"Tom\"})\n      {:ok, [id1, id2, id3]}\n    end, w: 1)","ref":"Mongo.Session.html#module-implicit-vs-explicit-sessions"},{"type":"function","title":"Mongo.Session.abort_transaction/1","doc":"Abort the current transaction and rollback all changes.","ref":"Mongo.Session.html#abort_transaction/1"},{"type":"function","title":"Mongo.Session.advance_operation_time/2","doc":"Advance the `operationTime` for causally consistent read commands","ref":"Mongo.Session.html#advance_operation_time/2"},{"type":"function","title":"Mongo.Session.alive?/1","doc":"Check if the session is alive.","ref":"Mongo.Session.html#alive?/1"},{"type":"function","title":"Mongo.Session.bind_session/3","doc":"Merge the session / transaction data into the cmd. There is no need to call this function directly. It is called automatically.\nThe global session timeout is merged to the options as well.","ref":"Mongo.Session.html#bind_session/3"},{"type":"function","title":"Mongo.Session.cast/2","doc":"","ref":"Mongo.Session.html#cast/2"},{"type":"function","title":"Mongo.Session.commit_transaction/1","doc":"Commit the current transaction.","ref":"Mongo.Session.html#commit_transaction/1"},{"type":"function","title":"Mongo.Session.commit_transaction/2","doc":"","ref":"Mongo.Session.html#commit_transaction/2"},{"type":"function","title":"Mongo.Session.connection/1","doc":"Return the connection used in the session.","ref":"Mongo.Session.html#connection/1"},{"type":"function","title":"Mongo.Session.end_session/2","doc":"End explicit session.","ref":"Mongo.Session.html#end_session/2"},{"type":"function","title":"Mongo.Session.handle_call_event/3","doc":"","ref":"Mongo.Session.html#handle_call_event/3"},{"type":"function","title":"Mongo.Session.handle_cast_event/3","doc":"","ref":"Mongo.Session.html#handle_cast_event/3"},{"type":"function","title":"Mongo.Session.in_read_session/3","doc":"","ref":"Mongo.Session.html#in_read_session/3"},{"type":"function","title":"Mongo.Session.in_session/5","doc":"","ref":"Mongo.Session.html#in_session/5"},{"type":"function","title":"Mongo.Session.in_write_session/3","doc":"This function allows nested `in_session` calls and provides a session if no session exists so far. A provided\nsession lives in the Process dictionary `:session` or is specified in the `opts` dictionary.","ref":"Mongo.Session.html#in_write_session/3"},{"type":"function","title":"Mongo.Session.init/6","doc":"","ref":"Mongo.Session.html#init/6"},{"type":"function","title":"Mongo.Session.mark_server_unknown/1","doc":"","ref":"Mongo.Session.html#mark_server_unknown/1"},{"type":"function","title":"Mongo.Session.run_in_transaction/5","doc":"","ref":"Mongo.Session.html#run_in_transaction/5"},{"type":"function","title":"Mongo.Session.select_server/2","doc":"","ref":"Mongo.Session.html#select_server/2"},{"type":"function","title":"Mongo.Session.start_link/6","doc":"Start the generic state machine.","ref":"Mongo.Session.html#start_link/6"},{"type":"function","title":"Mongo.Session.start_session/3","doc":"Start a new session for the `topology_pid`. You need to specify the `type`: `:read` for read and `:write` for write\noperations.","ref":"Mongo.Session.html#start_session/3"},{"type":"function","title":"Example - Mongo.Session.start_session/3","doc":"{:ok, session} = Session.start_session(top, :write, [])","ref":"Mongo.Session.html#start_session/3-example"},{"type":"function","title":"Mongo.Session.start_transaction/1","doc":"Start a new transaction.","ref":"Mongo.Session.html#start_transaction/1"},{"type":"function","title":"Mongo.Session.update_recovery_token/2","doc":"Update the `recoveryToken` after each response from mongos","ref":"Mongo.Session.html#update_recovery_token/2"},{"type":"function","title":"Mongo.Session.update_session/3","doc":"Update the `operationTime` for causally consistent read commands. There is no need to call this function directly. It is called automatically.","ref":"Mongo.Session.html#update_session/3"},{"type":"function","title":"Mongo.Session.wire_version/1","doc":"Return the wire_version used in the session.","ref":"Mongo.Session.html#wire_version/1"},{"type":"function","title":"Mongo.Session.with_transaction/3","doc":"Convenient function for running multiple write commands in a transaction.\n\nIn case of `TransientTransactionError` or `UnknownTransactionCommitResult` the function will retry the whole transaction or\nthe commit of the transaction. You can specify a timeout (`:transaction_retry_timeout_s`) to limit the time of repeating.\nThe default value is 120 seconds. If you don't wait so long, you call `with_transaction` with the\noption `transaction_retry_timeout_s: 10`. In this case after 10 seconds of retrying, the function will return\nan error.","ref":"Mongo.Session.html#with_transaction/3"},{"type":"function","title":"Example - Mongo.Session.with_transaction/3","doc":"alias Mongo.Session\n\n    {:ok, ids} = Session.with_transaction(top, fn opts ->\n    {:ok, %InsertOneResult{:inserted_id => id1}} = Mongo.insert_one(top, \"dogs\", %{name: \"Greta\"}, opts)\n    {:ok, %InsertOneResult{:inserted_id => id2}} = Mongo.insert_one(top, \"dogs\", %{name: \"Waldo\"}, opts)\n    {:ok, %InsertOneResult{:inserted_id => id3}} = Mongo.insert_one(top, \"dogs\", %{name: \"Tom\"}, opts)\n    {:ok, [id1, id2, id3]}\n    end, transaction_retry_timeout_s: 10)\n\nFrom the specs:\n\nThe callback function may be executed multiple times\n\nThe implementation of `with_transaction` is based on the original examples for Retry Transactions and\nCommit Operation from the MongoDB Manual. As such, the callback may be executed any number of times.\nDrivers are free to encourage their users to design idempotent callbacks.","ref":"Mongo.Session.html#with_transaction/3-example"},{"type":"type","title":"Mongo.Session.t/0","doc":"","ref":"Mongo.Session.html#t:t/0"},{"type":"module","title":"Mongo.Session.ServerSession","doc":"This module represents the server-side session. There are three fields:\n\n  * `last_use` - The timestamp for the last use of this server session\n  * `txn_num` - The current transaction number\n  * `session_id` - The session id of this server session\n\nWhen a transaction is active, all operations in that transaction\nuse the same transaction number.\n\nTransaction number is also used outside of transactions for\nretryable writes. In this case, each write operation has its own\ntransaction number, but retries of a write operation use the same\ntransaction number as the first write (which is how the server\nknows that subsequent writes are retries and should be ignored if\nthe first write succeeded on the server but was not read by the\nclient, for example).","ref":"Mongo.Session.ServerSession.html"},{"type":"function","title":"Mongo.Session.ServerSession.about_to_expire?/2","doc":"Return true, if the server session will time out. In this case the session\n  can be removed from the queue.","ref":"Mongo.Session.ServerSession.html#about_to_expire?/2"},{"type":"function","title":"Mongo.Session.ServerSession.new/0","doc":"Create a new server session.","ref":"Mongo.Session.ServerSession.html#new/0"},{"type":"function","title":"Mongo.Session.ServerSession.next_txn_num/1","doc":"Increment the current transaction number and return the new value.","ref":"Mongo.Session.ServerSession.html#next_txn_num/1"},{"type":"function","title":"Mongo.Session.ServerSession.set_last_use/1","doc":"Update the last_use attribute of the server session to now.","ref":"Mongo.Session.ServerSession.html#set_last_use/1"},{"type":"type","title":"Mongo.Session.ServerSession.t/0","doc":"","ref":"Mongo.Session.ServerSession.html#t:t/0"},{"type":"module","title":"Mongo.Session.SessionPool","doc":"A FIFO cache for sessions. To get a new session, call `checkout`. This returns a new session or a cached session.\nAfter running the operation call `checkin(session)` to put the session into the FIFO cache for reuse.\n\nThe MongoDB specifications allows to generate the uuid from the client. That means, that we can\njust create server sessions and use them for logicial sessions. If they expire then we drop these sessions,\notherwise we can reuse the server sessions.","ref":"Mongo.Session.SessionPool.html"},{"type":"function","title":"Mongo.Session.SessionPool.checkin/2","doc":"Checkin a used server session. It if is already expired, the server session is dropped. Otherwise the server session\nis cache for reuse, until it expires due of being cached all the time.","ref":"Mongo.Session.SessionPool.html#checkin/2"},{"type":"function","title":"Mongo.Session.SessionPool.checkout/1","doc":"Return a server session. If the session timeout is not reached, then a cached server session is return for reuse.\nOtherwise a newly created server session is returned.","ref":"Mongo.Session.SessionPool.html#checkout/1"},{"type":"function","title":"Mongo.Session.SessionPool.new/2","doc":"","ref":"Mongo.Session.SessionPool.html#new/2"},{"type":"type","title":"Mongo.Session.SessionPool.session_pool/0","doc":"","ref":"Mongo.Session.SessionPool.html#t:session_pool/0"},{"type":"module","title":"Mongo.Stream","doc":"This module provides a stream implementation that automatically checks out a session when the stream is started and an Enumerable\n  protocol that checks it back in when the stream has been consumed.","ref":"Mongo.Stream.html"},{"type":"function","title":"Mongo.Stream.checkin_session/3","doc":"","ref":"Mongo.Stream.html#checkin_session/3"},{"type":"function","title":"Mongo.Stream.new/3","doc":"","ref":"Mongo.Stream.html#new/3"},{"type":"module","title":"Mongo.StreamingHelloMonitor","doc":"See https://github.com/mongodb/specifications/blob/master/source/server-discovery-and-monitoring/server-monitoring.rst#streaming-protocol\n\nThe streaming protocol is used to monitor MongoDB 4.4+ servers and optimally reduces the time it takes for a client to discover server state changes.\nMulti-threaded or asynchronous drivers MUST use the streaming protocol when connected to a server that supports the awaitable hello or legacy hello commands.\nThis protocol requires an extra thread and an extra socket for each monitor to perform RTT calculations.\n\nThis module implements the streaming protocol. The GenServer is started and maintained by the Monitor process. The streaming hello monitor uses the\nmore to come flag while updating the current server description.","ref":"Mongo.StreamingHelloMonitor.html"},{"type":"function","title":"Mongo.StreamingHelloMonitor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Mongo.StreamingHelloMonitor.html#child_spec/1"},{"type":"function","title":"Mongo.StreamingHelloMonitor.connected/2","doc":"Report the connection event, so the topology process can now create the connection pool.","ref":"Mongo.StreamingHelloMonitor.html#connected/2"},{"type":"function","title":"Mongo.StreamingHelloMonitor.handle_cast/2","doc":"Time to update the topology. Calling `hello` and updating the server description","ref":"Mongo.StreamingHelloMonitor.html#handle_cast/2"},{"type":"function","title":"Mongo.StreamingHelloMonitor.info/1","doc":"","ref":"Mongo.StreamingHelloMonitor.html#info/1"},{"type":"function","title":"Mongo.StreamingHelloMonitor.init/1","doc":"Initialize the monitor process","ref":"Mongo.StreamingHelloMonitor.html#init/1"},{"type":"function","title":"Mongo.StreamingHelloMonitor.start_link/1","doc":"","ref":"Mongo.StreamingHelloMonitor.html#start_link/1"},{"type":"function","title":"Mongo.StreamingHelloMonitor.terminate/2","doc":"In this case we stop the DBConnection.","ref":"Mongo.StreamingHelloMonitor.html#terminate/2"},{"type":"module","title":"Mongo.UnorderedBulk","doc":"An **unordered** bulk is filled in the memory with the bulk operations. These are divided into three lists (inserts, updates, deletes)\nadded. If the unordered bulk is written to the database, the groups are written in the following order:\n\n1. inserts\n2. updates\n3. deletes\n\nThe order within the group is undefined.","ref":"Mongo.UnorderedBulk.html"},{"type":"module","title":"Example - Mongo.UnorderedBulk","doc":"```\nalias Mongo.UnorderedBulk\nalias Mongo.BulkWrite\n\nbulk = \"bulk\"\n|> UnorderedBulk.new()\n|> UnorderedBulk.insert_one(%{name: \"Greta\"})\n|> UnorderedBulk.insert_one(%{name: \"Tom\"})\n|> UnorderedBulk.insert_one(%{name: \"Waldo\"})\n|> UnorderedBulk.update_one(%{name: \"Greta\"}, %{\"$set\": %{kind: \"dog\"}})\n|> UnorderedBulk.update_one(%{name: \"Tom\"}, %{\"$set\": %{kind: \"dog\"}})\n|> UnorderedBulk.update_one(%{name: \"Waldo\"}, %{\"$set\": %{kind: \"dog\"}})\n|> UnorderedBulk.delete_one(%{kind: \"dog\"})\n|> UnorderedBulk.delete_one(%{kind: \"dog\"})\n|> UnorderedBulk.delete_one(%{kind: \"dog\"})\n\nresult = BulkWrite.write(:mongo, bulk, w: 1)\n```\n\nTo reduce the memory usage the unordered bulk can be used with streams.","ref":"Mongo.UnorderedBulk.html#module-example"},{"type":"module","title":"Example - Mongo.UnorderedBulk","doc":"```\n1..1_000_000\n|> Stream.map(fn i -> BulkOps.get_insert_one(%{number: i}) end)\n|> UnorderedBulk.write(:mongo, \"bulk\", 1_000)\n|> Stream.run()\n```\n\nThis example first generates the bulk operation by calling `Mongo.BulkOps.get_insert_one\\1`. The operation is used as a parameter in the `Mongo.UnorderedBulk.write\\3` function.\nThe unordered bulk was created with a buffer of 1000 operations. After 1000 operations, the\nunordered bulk is written to the database. Depending on the selected size you can control the speed and memory consumption. The higher the\nvalue, the faster the processing and the greater the memory consumption.","ref":"Mongo.UnorderedBulk.html#module-example"},{"type":"function","title":"Mongo.UnorderedBulk.add/2","doc":"Adds the two unordered bulks together.","ref":"Mongo.UnorderedBulk.html#add/2"},{"type":"function","title":"Mongo.UnorderedBulk.delete_many/2","doc":"Appends a delete operation with `:limit = 0`.\n\n  Example:\n\n```\nMongo.UnorderedBulk.delete_many(bulk, %{name: \"Waldo\"})\n%Mongo.UnorderedBulk{\ncoll: \"bulk\",\ndeletes: [{%{name: \"Waldo\"}, [limit: 0]}],\ninserts: [],\nupdates: []\n}\n```","ref":"Mongo.UnorderedBulk.html#delete_many/2"},{"type":"function","title":"Mongo.UnorderedBulk.delete_one/2","doc":"Appends a delete operation with `:limit = 1`.\n\nExample:\n\n```\nMongo.UnorderedBulk.delete_one(bulk, %{name: \"Waldo\"})\n%Mongo.UnorderedBulk{\ncoll: \"bulk\",\ndeletes: [{%{name: \"Waldo\"}, [limit: 1]}],\ninserts: [],\nupdates: []\n}\n```","ref":"Mongo.UnorderedBulk.html#delete_one/2"},{"type":"function","title":"Mongo.UnorderedBulk.empty?/1","doc":"Returns true, if the bulk is empty, that means it contains no inserts, updates or deletes operations","ref":"Mongo.UnorderedBulk.html#empty?/1"},{"type":"function","title":"Mongo.UnorderedBulk.insert_one/2","doc":"Appends an insert operation.\n\nExample:\n\n```\nMongo.UnorderedBulk.insert_one(bulk, %{name: \"Waldo\"})\n%Mongo.UnorderedBulk{\ncoll: \"bulk\",\ndeletes: [],\ninserts: [%{name: \"Waldo\"}],\nupdates: []\n}\n```","ref":"Mongo.UnorderedBulk.html#insert_one/2"},{"type":"function","title":"Mongo.UnorderedBulk.new/1","doc":"Creates an empty unordered bulk for a collection.\n\nExample:\n\n```\nMongo.UnorderedBulk.new(\"bulk\")\n%Mongo.UnorderedBulk{coll: \"bulk\", deletes: [], inserts: [], updates: []}\n```","ref":"Mongo.UnorderedBulk.html#new/1"},{"type":"function","title":"Mongo.UnorderedBulk.push/2","doc":"Appends a bulk operation to the unordered bulk. One of the field (inserts, updates or deletes)\nwill be updated.","ref":"Mongo.UnorderedBulk.html#push/2"},{"type":"function","title":"Mongo.UnorderedBulk.replace_one/4","doc":"Appends a replace operation with `:multi = false`.\n\n  Example:\n\n```\nMongo.UnorderedBulk.replace_one(bulk, %{name: \"Waldo\"}, %{name: \"Greta\", kind: \"dog\"})\n%Mongo.UnorderedBulk{\ncoll: \"bulk\",\ndeletes: [],\ninserts: [],\nupdates: [{%{name: \"Waldo\"}, %{kind: \"dog\", name: \"Greta\"}, [multi: false]}]\n}\n```","ref":"Mongo.UnorderedBulk.html#replace_one/4"},{"type":"function","title":"Mongo.UnorderedBulk.update_many/4","doc":"Appends a update operation with `:multi = true`.\n\n  Example:\n\n```\nMongo.UnorderedBulk.update_many(bulk, %{name: \"Waldo\"}, %{\"$set\": %{name: \"Greta\", kind: \"dog\"}})\n%Mongo.UnorderedBulk{\ncoll: \"bulk\",\ndeletes: [],\ninserts: [],\nupdates: [\n  {%{name: \"Waldo\"}, %{\"$set\": %{kind: \"dog\", name: \"Greta\"}}, [multi: true]}\n]\n}\n```","ref":"Mongo.UnorderedBulk.html#update_many/4"},{"type":"function","title":"Mongo.UnorderedBulk.update_one/4","doc":"Appends a update operation with `:multi = false`.\n\n  Example:\n\n```\nMongo.UnorderedBulk.update_one(bulk, %{name: \"Waldo\"}, %{\"$set\": %{name: \"Greta\", kind: \"dog\"}})\n%Mongo.UnorderedBulk{\ncoll: \"bulk\",\ndeletes: [],\ninserts: [],\nupdates: [\n  {%{name: \"Waldo\"}, %{\"$set\": %{kind: \"dog\", name: \"Greta\"}}, [multi: false]}\n]\n}\n```","ref":"Mongo.UnorderedBulk.html#update_one/4"},{"type":"function","title":"Mongo.UnorderedBulk.write/5","doc":"Returns a stream chunk function that can be used with streams. The `limit` specifies the number\nof operation hold in the memory while processing the stream inputs.\n\nThe inputs of the stream should be `Mongo.BulkOps.bulk_op`. See `Mongo.BulkOps`","ref":"Mongo.UnorderedBulk.html#write/5"},{"type":"type","title":"Mongo.UnorderedBulk.t/0","doc":"","ref":"Mongo.UnorderedBulk.html#t:t/0"},{"type":"module","title":"Mongo.UpdateResult","doc":"The successful result struct of `Mongo.update_one/5`, `Mongo.update_many/5`\nand `Mongo.replace_one/5`. Its fields are:\n\n  * `:matched_count` - Number of matched documents\n  * `:modified_count` - Number of modified documents\n  * `:upserted_ids` - If the operation was an upsert, the upserted ids","ref":"Mongo.UpdateResult.html"},{"type":"type","title":"Mongo.UpdateResult.t/0","doc":"","ref":"Mongo.UpdateResult.html#t:t/0"},{"type":"module","title":"Mongo.UrlParser","doc":"Mongo connection URL parsing util\n\n  [See](https://docs.mongodb.com/manual/reference/connection-string/#connections-connection-options) for the complete list of options.","ref":"Mongo.UrlParser.html"},{"type":"function","title":"Mongo.UrlParser.parse_url/1","doc":"","ref":"Mongo.UrlParser.html#parse_url/1"},{"type":"module","title":"Mongo.Version","doc":"This module contains the constant of all wire versions.\n\nsee https://github.com/mongodb/mongo/blob/master/src/mongo/db/wire_version.h","ref":"Mongo.Version.html"},{"type":"function","title":"Mongo.Version.decode/1","doc":"","ref":"Mongo.Version.html#decode/1"},{"type":"function","title":"Mongo.Version.encode/1","doc":"","ref":"Mongo.Version.html#encode/1"},{"type":"exception","title":"Mongo.Error","doc":"","ref":"Mongo.Error.html"},{"type":"function","title":"Mongo.Error.fail_command?/1","doc":"Returns true if the error is issued by the failCommand","ref":"Mongo.Error.html#fail_command?/1"},{"type":"function","title":"Mongo.Error.has_label/2","doc":"","ref":"Mongo.Error.html#has_label/2"},{"type":"function","title":"Mongo.Error.not_primary_no_secondary_ok?/1","doc":"","ref":"Mongo.Error.html#not_primary_no_secondary_ok?/1"},{"type":"function","title":"Mongo.Error.not_primary_or_secondary?/1","doc":"","ref":"Mongo.Error.html#not_primary_or_secondary?/1"},{"type":"function","title":"Mongo.Error.not_writable_primary?/1","doc":"","ref":"Mongo.Error.html#not_writable_primary?/1"},{"type":"function","title":"Mongo.Error.not_writable_primary_or_recovering?/2","doc":"Return true if the error == not writable primary or in recovering mode.","ref":"Mongo.Error.html#not_writable_primary_or_recovering?/2"},{"type":"function","title":"Mongo.Error.should_retry_read/3","doc":"Return true if the error is retryable for read operations.","ref":"Mongo.Error.html#should_retry_read/3"},{"type":"function","title":"Mongo.Error.should_retry_write/3","doc":"Return true if the error is retryable for writes operations.","ref":"Mongo.Error.html#should_retry_write/3"},{"type":"type","title":"Mongo.Error.t/0","doc":"","ref":"Mongo.Error.html#t:t/0"},{"type":"exception","title":"Mongo.WriteError","doc":"","ref":"Mongo.WriteError.html"},{"type":"function","title":"Mongo.WriteError.message/1","doc":"","ref":"Mongo.WriteError.html#message/1"},{"type":"type","title":"Mongo.WriteError.t/0","doc":"","ref":"Mongo.WriteError.html#t:t/0"},{"type":"extras","title":"The Elixir Driver for MongoDB","doc":"# The Elixir Driver for MongoDB\n\n[![Hex.pm](https://img.shields.io/hexpm/v/mongodb_driver.svg)](https://hex.pm/packages/mongodb_driver)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/mongodb_driver/)\n[![Hex.pm](https://img.shields.io/hexpm/dt/mongodb_driver.svg)](https://hex.pm/packages/mongodb_driver)\n[![Hex.pm](https://img.shields.io/hexpm/dw/mongodb_driver.svg)](https://hex.pm/packages/mongodb_driver)\n[![Hex.pm](https://img.shields.io/hexpm/dd/mongodb_driver.svg)](https://hex.pm/packages/mongodb_driver)\n[![License](https://img.shields.io/hexpm/l/mongodb_driver.svg)](https://github.com/zookzook/elixir-mongodb-driver/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/zookzook/elixir-mongodb-driver.svg)](https://github.com/zookzook/elixir-mongodb-driver/commits/master)","ref":"readme.html"},{"type":"extras","title":"Features - The Elixir Driver for MongoDB","doc":"- supports MongoDB versions 4.x, 5.x, 6.x, 7.x, 8.x\n- connection pooling ([through DBConnection 2.x](https://github.com/elixir-ecto/db_connection))\n- streaming cursors\n- performant ObjectID generation\n- aggregation pipeline\n- replica sets\n- support for SCRAM-SHA-256 (MongoDB 4.x)\n- support for GridFS ([See](https://github.com/mongodb/specifications/blob/master/source/gridfs/gridfs-spec.md))\n- support for change streams api ([See](https://github.com/mongodb/specifications/blob/master/source/change-streams/change-streams.md))\n- support for bulk writes ([See](https://github.com/mongodb/specifications/blob/master/source/crud/crud.md#write))\n- support for driver sessions ([See](https://github.com/mongodb/specifications/blob/master/source/sessions/driver-sessions.md))\n- support for driver transactions ([See](https://github.com/mongodb/specifications/blob/master/source/transactions/transactions.md))\n- support for command monitoring ([See](https://github.com/mongodb/specifications/blob/master/source/command-logging-and-monitoring/command-logging-and-monitoring.md))\n- support for retryable reads ([See](https://github.com/mongodb/specifications/blob/master/source/retryable-reads/retryable-reads.md))\n- support for retryable writes ([See](https://github.com/mongodb/specifications/blob/master/source/retryable-writes/retryable-writes.md))\n- support for simple structs using the Mongo.Encoder protocol\n- support for complex and nested documents using the `Mongo.Collection` macros\n- support for streaming protocol ([See](https://github.com/mongodb/specifications/blob/master/source/server-discovery-and-monitoring/server-monitoring.md#streaming-protocol))\n- support for migration scripts\n- support for compression for zlib and zstd ([See](https://github.com/mongodb/specifications/blob/07b7649cc5c805ef4f85fccddf39226add7114e6/source/compression/OP_COMPRESSED.md))","ref":"readme.html#features"},{"type":"extras","title":"Usage - The Elixir Driver for MongoDB","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Installation - The Elixir Driver for MongoDB","doc":"Add `mongodb_driver` to your mix.exs `deps`.\n\n```elixir\ndefp deps do\n  [{:mongodb_driver, \"~> 1.5.0\"}]\nend\n```\n\nThen run `mix deps.get` to fetch dependencies.","ref":"readme.html#installation"},{"type":"extras","title":"Simple Connection to MongoDB - The Elixir Driver for MongoDB","doc":"```elixir\n# Starts an unpooled connection\n{:ok, top} = Mongo.start_link(url: \"mongodb://localhost:27017/my-database\")\n\ntop\n|> Mongo.find(\"test-collection\", %{})\n|> Enum.to_list()\n```\n\nTo specify a username and password, use the `:username`, `:password`, and `:auth_source` options.\n\n```elixir\n# Starts an unpooled connection\n{:ok, top} =\n    Mongo.start_link(url: \"mongodb://localhost:27017/db-name\",\n                     username: \"test_user\",\n                     password: \"hunter2\",\n                     auth_source: \"admin_test\")\n\ntop\n|> Mongo.find(\"test-collection\", %{})\n|> Enum.to_list()\n```\n\nFor secure requests, you may need to add some more options; see the \"AWS, TLS and Erlang SSL ciphers\" section below.\n\nFailing operations return a `{:error, error}` tuple where `error` is a\n`Mongo.Error` object:\n\n```elixir\n{:error,\n %Mongo.Error{\n   code: 13435,\n   error_labels: [],\n   host: nil,\n   message: \"not master and slaveOk=false\",\n   resumable: true,\n   retryable_reads: true,\n   retryable_writes: true\n }}\n```","ref":"readme.html#simple-connection-to-mongodb"},{"type":"extras","title":"Examples - The Elixir Driver for MongoDB","doc":"","ref":"readme.html#examples"},{"type":"extras","title":"Find - The Elixir Driver for MongoDB","doc":"Using `$and`\n\n```elixir\n@topology\n|> Mongo.find(\"users\", %{\"$and\" => [%{email: \"my@email.com\"}, %{first_name: \"first_name\"}]})\n|> Enum.to_list()\n```\n\nUsing `$or`\n\n```elixir\n@topology\n|> Mongo.find(\"users\", %{\"$or\" => [%{email: \"my@email.com\"}, %{first_name: \"first_name\"}]})\n|> Enum.to_list()\n```\n\nUsing `$in`\n\n```elixir\n@topology\n|> Mongo.find(\"users\", %{email: %{\"$in\" => [\"my@email.com\", \"other@email.com\"]}})\n|> Enum.to_list()\n```","ref":"readme.html#find"},{"type":"extras","title":"How to use the `Mongo.Stream`? - The Elixir Driver for MongoDB","doc":"Most query functions return a `Mongo.Stream` struct that implements the `Enumerable` protocol. The module checks out \nthe session and streams the batches from the server until the last batch has been received. \nThe session is then checked in for reuse. [Sessions](https://github.com/mongodb/specifications/blob/master/source/sessions/driver-sessions.md) are \ntemporary and reusable data structures, e.g. to support transactions. They are required by the Mongo DB driver specification.\n\nThe use of internal structures of the `Mongo.Stream` struct is therefore not planned. For example, the following code results in an open session and the `docs` will only contain the first batch:\n\n```elixir\n%Mongo.Stream{docs: docs} = Mongo.aggregate(@topology, collection, pipeline, opts)\nEnum.map(docs, fn elem -> elem end)\n```\n\nThe `Mongo.Stream` struct should therefore always be processed by an `Enum` or `Stream` function so that the session management \ncan take place automatically:\n\n```elixir\n@topology\n|> Mongo.aggregate(collection, pipeline, opts)\n|> Enum.to_list()\n```","ref":"readme.html#how-to-use-the-mongo-stream"},{"type":"extras","title":"Inserts - The Elixir Driver for MongoDB","doc":"To insert a single document:\n\n```elixir\nMongo.insert_one(top, \"users\", %{first_name: \"John\", last_name: \"Smith\"})\n```\n\nTo insert a list of documents:\n\n```elixir\nMongo.insert_many(top, \"users\", [\n  %{first_name: \"John\", last_name: \"Smith\"},\n  %{first_name: \"Jane\", last_name: \"Doe\"}\n])\n```","ref":"readme.html#inserts"},{"type":"extras","title":"mongodb_ecto - The Elixir Driver for MongoDB","doc":"The version 1.4.0 supports the [mongodb_ecto](https://github.com/elixir-mongo/mongodb_ecto) package.\nA series of changes are required to support the adapter. Some BSON encoders and a missing generic update function were added for the adapter.\nMost notably, the `find-then-modify` command functions `find_one_and_update` and `find_one_and_replace` now return appropriate\n`FindAndModifyResult` structs that contain additional write information otherwise neglected, which the adapter requires.\n\nAfter upgrading the driver to version 1.4.0 you need to change the code regarding the results of\n* `Mongo.find_one_and_update`\n* `Mongo.find_one_and_replace`","ref":"readme.html#mongodb_ecto"},{"type":"extras","title":"Data Representation - The Elixir Driver for MongoDB","doc":"This driver chooses to accept both maps and lists of key-value tuples when encoding BSON documents (1), but will only\ndecode documents into maps. Maps are convenient to work with, but Elixir map keys are not ordered, unlike BSON document\nkeys.\n\nThat design decision means document key order is lost when encoding Elixir maps to BSON and, conversely, when decoding\nBSON documents to Elixir maps. However, see [Preserve Document Key Order](#preserve-document-key-order) to learn how to\npreserve key order when it matters.\n\nAdditionally, the driver accepts both atoms and strings for document keys, but will only decode them into strings.\nCreating atoms from arbitrary input (such as database documents) is\n[discouraged](https://elixir-lang.org/getting-started/mix-otp/genserver.html#:~:text=However%2C%20naming%20dynamic,our%20system%20memory!)\nbecause atoms are not garbage collected.\n\n[BSON symbols (deprecated)](https://bsonspec.org/spec.html#:~:text=Symbol.%20%E2%80%94%20Deprecated) can only be decoded (2).\n\n    BSON                Elixir\n    ----------          ------\n    double              0.0\n    string              \"Elixir\"\n    document            [{\"key\", \"value\"}] | %{\"key\" => \"value\"} (1)\n    binary              %BSON.Binary{binary: <<42, 43>>, subtype: :generic}\n    UUID                %BSON.Binary{binary: <<42, 43>>, subtype: :uuid}\n    UUID (old style)    %BSON.Binary{binary: <<42, 43>>, subtype: :uuid_old}\n    object id           %BSON.ObjectId{value: <<...>>}\n    boolean             true | false\n    UTC datetime        %DateTime{}\n    null                nil\n    regex               %BSON.Regex{pattern: \"...\"}\n    JavaScript          %BSON.JavaScript{code: \"...\"}\n    timestamp           #BSON.Timestamp \"\n    integer 32          42\n    integer 64          #BSON.LongNumber \n    symbol              \"foo\" (2)\n    min key             :BSON_min\n    max key             :BSON_max\n    decimal128          Decimal{}","ref":"readme.html#data-representation"},{"type":"extras","title":"Preserve Document Key Order - The Elixir Driver for MongoDB","doc":"","ref":"readme.html#preserve-document-key-order"},{"type":"extras","title":"Encoding from Elixir to BSON - The Elixir Driver for MongoDB","doc":"For some MongoDB operations, the order of the keys in a document affect the result. For example, that is the case when\nsorting a query by multiple fields.\n\nIn those cases, driver users should represent documents using a list of tuples (or a keyword list) to preserve the\norder. Example:\n\n```elixir\n@topology\n|> Mongo.find(\"users\", %{}, sort: [last_name: 1, first_name: 1, _id: 1])\n|> Enum.to_list()\n```\n\nThe query above will sort users by last name, then by first name and finally by ID. If an Elixir map had been used to\nspecify `:sort`, query results would end up sorted unexpectedly wrong.","ref":"readme.html#encoding-from-elixir-to-bson"},{"type":"extras","title":"Decoding from BSON to Elixir - The Elixir Driver for MongoDB","doc":"Decoded BSON documents are always represented by Elixir maps because the driver depends on that to implement its\nfunctionality.\n\nIf the order of document keys as stored by MongoDB is needed, the driver can be configured to use a BSON decoder module\nthat puts a list of keys in the original order under the `:__order__` key (and it works recursively).\n\n```elixir\nconfig :mongodb_driver,\n  decoder: BSON.PreserveOrderDecoder\n```\n\nIt is possible to customize the key. For example, to use `:original_order` instead of the default `:__order__`:\n\n```elixir\nconfig :mongodb_driver,\n  decoder: {BSON.PreserveOrderDecoder, key: :original_order}\n```\n\nThe resulting maps with annotated key order can be recursively transformed into lists of tuples. That allows for\npreserving the order again when encoding. Here is an example of how to achieve that:\n\n```elixir\ndefmodule MapWithOrder do\n  def to_list(doc, order_key \\\\ :__order__) do\n    do_to_list(doc, order_key)\n  end\n\n  defp do_to_list(%{__struct__: _} = elem, _order_key) do\n    elem\n  end\n\n  defp do_to_list(doc, order_key) when is_map(doc) do\n    doc\n    |> Map.get(order_key, Map.keys(doc))\n    |> Enum.map(fn key -> {key, do_to_list(Map.get(doc, key), order_key)} end)\n  end\n\n  defp do_to_list(xs, order_key) when is_list(xs) do\n    Enum.map(xs, fn elem -> do_to_list(elem, order_key) end)\n  end\n\n  defp do_to_list(elem, _order_key) do\n    elem\n  end\nend\n\n# doc = ...\nMapWithOrder.to_list(doc)\n```\n\nNote that structs are kept as-is, to handle special values such as `BSON.ObjectId`.\n\nThe decoder module is defined at compile time. The default decoder is `BSON.Decoder`, which does not preserve document\nkey order. As it needs to execute fewer operations when decoding data received from MongoDB, it offers improved\nperformance. Therefore, the default decoder is recommended for most use cases of this driver.","ref":"readme.html#decoding-from-bson-to-elixir"},{"type":"extras","title":"Writing your own encoding info - The Elixir Driver for MongoDB","doc":"If you want to write a custom struct to your mongo collection - you can do that\nby implementing `Mongo.Encoder` protocol for your module. The output should be a map,\nwhich will be passed to the Mongo database.\n\nExample:\n\n```elixir\ndefmodule CustomStruct do\n  @fields [:a, :b, :c, :id]\n  @enforce_keys @fields\n  defstruct @fields\n  defimpl Mongo.Encoder do\n    def encode(%{a: a, b: b, id: id}) do\n      %{\n        _id: id,\n        a: a,\n        b: b,\n        custom_encoded: true\n      }\n    end\n  end\nend\n```\n\nSo, given the struct:\n\n```elixir\n%CustomStruct{a: 10, b: 20, c: 30, id: \"5ef27e73d2a57d358f812001\"}\n```\n\nit will be written to database, as:\n\n```json\n{\n  \"a\": 10,\n  \"b\": 20,\n  \"custom_encoded\": true,\n  \"_id\": \"5ef27e73d2a57d358f812001\"\n}\n```","ref":"readme.html#writing-your-own-encoding-info"},{"type":"extras","title":"Collections - The Elixir Driver for MongoDB","doc":"While using the `Mongo.Encoder` protocol give you the possibility to encode your structs into maps the opposite way to decode those maps into structs is missing. To handle it you can use the `Mongo.Collection` which provides some boilerplate code for a better support of structs while using the MongoDB driver\n\n- automatic load and dump function\n- reflection functions\n- type specification\n- support for embedding one and many structs\n- support for `after load` function\n- support for `before dump` function\n- support for id generation\n- support for default values\n- support for derived values\n- support for alias attribute names\n\nBut in the case of queries and updates, a rewrite of the attribute names does not take place. It is still up to you\nto use the correct attribute names.\n\nWhen using the MongoDB driver only maps and keyword lists are used to represent documents.\nIf you prefer to use structs instead of the maps to give the document a stronger meaning or to emphasize\nits importance, you have to create a `defstruct` and fill it from the map manually:\n\n```elixir\ndefmodule Label do\n  defstruct name: \"warning\", color: \"red\"\nend\n\niex> label_map = Mongo.find_one(:mongo, \"labels\", %{})\n  %{\"name\" => \"warning\", \"color\" => \"red\"}\niex> label = %Label{name: label_map[\"name\"], color: label_map[\"color\"]}\n```\n\nWe have defined a module `Label` as `defstruct`, then we get the first label document\nthe collection `labels`. The function `find_one` returns a map. We convert the map manually and\nget the desired struct. If we want to save a new structure, we have to do the reverse. We convert the struct into a map:\n\n```elixir\niex> label = %Label{}\niex> label_map = %{\"name\" => label.name, \"color\" => label.color}\niex> {:ok, _} = Mongo.insert_one(:mongo, \"labels\", label_map)\n```\n\nAlternatively, you can also remove the `__struct__` key from `label`. The MongoDB driver automatically\nconverts the atom keys into strings (Or use the `Mongo.Encode` protocol)\n\n```elixir\niex>  Map.drop(label, [:__struct__])\n%{color: :red, name: \"warning\"}\n```\n\nIf you use nested structures, the work becomes a bit more complex. In this case, you have to use the inner structures\nconvert manually, too. If you take a closer look at the necessary work, two basic functions can be derived:\n\n- `load` Conversion of the map into a struct.\n- `dump` Conversion of the struct into a map.\n\n`Mongo.Collection` provides the necessary macros to automate this boilerplate code. The above example can be rewritten as follows:\n\n```elixir\ndefmodule Label do\n    use Mongo.Collection\n\n    document do\n      attribute :name, String.t(), default: \"warning\"\n      attribute :color, String.t(), default: :red\n    end\nend\n```\n\nThis results in the following module:\n\n```elixir\ndefmodule Label do\n\n    defstruct [name: \"warning\", color: \"red\"]\n\n    @type t() :: %Label{String.t(), String.t()}\n\n    def new()...\n    def load(map)...\n    def dump(%Label{})...\n    def __collection__(:attributes)...\n    def __collection__(:types)...\n    def __collection__(:collection)...\n    def __collection__(:id)...\n\nend\n```\n\nYou can now create new structs with the default values and use the conversion functions between map and structs:\n\n```elixir\niex(1)> x = Label.new()\n%Label{color: :red, name: \"warning\"}\niex(2)> m = Label.dump(x)\n%{color: :red, name: \"warning\"}\niex(3)> Label.load(m, true)\n%Label{color: :red, name: \"warning\"}\n```\n\nThe `load/2` function distinguishes between keys of type binarys `load(map, false)` and keys of type atoms `load(map, true)`. The default is `load(map, false)`:\n\n```elixir\niex(1)> m = %{\"color\" => :red, \"name\" => \"warning\"}\niex(2)> Label.load(m)\n%Label{color: :red, name: \"warning\"}\n```\n\nIf you would now expect atoms as keys, the result of the conversion is not correct in this case:\n\n```elixir\niex(3)> Label.load(m, true)\n%Label{color: nil, name: nil}\n```\n\nThe background is that MongoDB always returns binarys as keys and structs use atoms as keys.\nFor more information look at the module documentation `Mongo.Collection`.\nOf course, using the `Mongo.Collection` is not free. When loading and saving, the maps are converted into structures, which increases CPU usage somewhat. When it comes to speed, it is better to use the maps directly.","ref":"readme.html#collections"},{"type":"extras","title":"Breaking changes - The Elixir Driver for MongoDB","doc":"Prior to version 0.9.2 the dump function returns atoms as key. Since the `dump/1` function is the inverse function of `load/1`,\nwhich uses binary keys as default, the `dump/1` function should return binary keys as well. This increases the consistency and\nyou can do:\n\n    l = Label.load(doc)\n    doc = Label.dump(l)\n    assert l == Label.load(doc)","ref":"readme.html#breaking-changes"},{"type":"extras","title":"Using the Repo Module - The Elixir Driver for MongoDB","doc":"For convenience, you can also `use` the `Mongo.Repo` module in your application to configure the MongoDB application.\n\nSimply create a new module and include the `use Mongo.Repo` macro:\n\n```elixir\ndefmodule MyApp.Repo do\n  use Mongo.Repo,\n    otp_app: :my_app,\n    topology: :mongo\nend\n```\n\nTo configure the MongoDB add the configuration to your `config.exs`:\n\n```elixir\nconfig :my_app, MyApp.Repo,\n  url: \"mongodb://localhost:27017/my-app-dev\",\n  timeout: 60_000,\n  idle_interval: 10_000,\n  queue_target: 5_000\n```\n\nFinally, we can add the `Mongo.Repo` instance to our application supervision tree:\n\n```elixir\n  children = [\n    # ...\n    MyApp.Repo,\n    # ...\n  ]\n```\n\nIn addition, the convenient configuration, the `Mongo.Repo` module will also include query functions to use with your\n`Mongo.Collection` modules.\n\nFor more information check out the `Mongo.Repo` module documentation and the `Mongo` module documentation.","ref":"readme.html#using-the-repo-module"},{"type":"extras","title":"Breaking changes - The Elixir Driver for MongoDB","doc":"Prior to version 0.9.2 some `Mongo.Repo` functions use the `dump/1` function for the query (and update) parameter. \nThis worked only for some query that used only the attributes of the document. In the case of nested documents, \nit didn't work, so it is changed to be more consistent. The `Mongo.Repo` module is very simple without any query \nrewriting like Ecto does. In the case you want to use the `:name` option, you need to specify the query and update \ndocuments in the `Mongo.Repo` functions following the specification in the MongoDB. Example:\n\n    defmodule MyApp.Session do\n        @moduledoc false\n        use Mongo.Collection\n        \n        alias BSON.Binary\n        \n        collection :s do\n            attribute :uuid, Binary.t(), name: :u \n        end\n    end\n\nIf you use the `Mongo.Repo` module and want to fetch a specific session document, this won't work:\n\n    MyApp.Repo.get_by(MyApp.Session, %{uuid: session_uuid})\n\nbecause the `get_by/2` function uses the query parameter without any rewriting. You need to change the query:\n\n    MyApp.Repo.get_by(MyApp.Session, %{u: session_uuid})\n\nA rewriting is too complex for now because MongoDB has a lot of options.","ref":"readme.html#breaking-changes"},{"type":"extras","title":"Logging - The Elixir Driver for MongoDB","doc":"You config the logging output by adding in your config file this line\n\n```elixir\nconfig :mongodb_driver, log: true\n```\n\nThe attribute `log` supports `true`, `false` or a log level like `:info`. The default value is `false`. If you turn\nlogging on, then you will see log output (command, collection, parameters):\n\n```\n[info] CMD find \"my-collection\" [filter: [name: \"Helga\"]] db=2.1ms\n```","ref":"readme.html#logging"},{"type":"extras","title":"Telemetry - The Elixir Driver for MongoDB","doc":"The driver uses the [:telemetry](https://github.com/beam-telemetry/telemetry) package to emit the execution duration\nfor each command. The event name is `[:mongodb_driver, :execution]` and the driver uses the following meta data:\n\n```elixir\nmetadata = %{\n    type: :mongodb_driver,\n    command: command,\n    params: parameters,\n    collection: collection,\n    options: Keyword.get(opts, :telemetry_options, [])\n}\n\n:telemetry.execute([:mongodb_driver, :execution], %{duration: duration}, metadata)\n```\n\nIn a Phoenix application with installed Phoenix Dashboard the metrics can be used by defining a metric in the Telemetry module:\n\n```elixr\n      summary(\"mongodb_driver.execution.duration\",\n        tags: [:collection, :command],\n        unit: {:microsecond, :millisecond}\n      ),\n```\n\nThen you see for each collection the execution time for each different command in the Dashboard metric page.","ref":"readme.html#telemetry"},{"type":"extras","title":"Network compression - The Elixir Driver for MongoDB","doc":"The driver supports two compressors\n\n* zlib, which is supported by Erlang \n* zstd, which is optional and supported by https://github.com/silviucpp/ezstd bindings.\n\nTo activate zlib compression:\n1. Append `compressors=zlib` to the URL connection string:\n```elixir\n{:ok, top} = Mongo.start_link(url: \"mongodb://localhost:27017/db?compressors=zlib\")\n```\n\nTo activate zstd compression:\n1. Add `{:ezstd, \"~> 1.1\"}` to the dependencies of your `mix.exs` file. The driver will provide the related code.\n2. Append `compressors=zstd` to the URL connection string:\n\n```elixir\n{:ok, top} = Mongo.start_link(url: \"mongodb://localhost:27017/db?compressors=zstd\")\n```\n\nThe driver uses compression for the following functions:\n\n* `Mongo.aggregate/4`\n* `Mongo.find/4`\n* `Mongo.insert_one/4`\n* `Mongo.insert_many/4`\n* `Mongo.update/4`\n* `Mongo.update_documents/6`\n* `Mongo.find_one_and_update/5`\n* `Mongo.find_one_and_replace/5`\n* `Mongo.find_one_and_delete/4`\n* `Mongo.count/4`\n* `Mongo.distinct/5`\n* `Mongo.delete_documents/5`\n* `Mongo.create/4`\n\nYou can disable the compression for a single function by using the option `compression: false`, for example:\n\n```\nMongo.find(top, \"tasks\", %{}, compression: false) |> Enum.to_list()\n```\nThe compression significantly reduces the amount of data, while increasing the load on the CPU.\nThis is certainly interesting for environments in which network transmission has to be paid for.\n\nzlib compression requires a greater penalty in terms of speed than zstd compression. \nThe zstd compression offers a good compromise between compression rate and speed and \nis undoubtedly supported by all current MongoDB.\n\nThe speed also depends on the `batch_size` attribute. A higher speed is achieved for certain batch sizes. \nSimple experiments can be carried out here to determine which size shortens the duration of the queries:\n\n```elixir\n:timer.tc(fn -> Mongo.find(top, \"tasks\", %{}, limit: 30_000, batch_size: 1000) |> Stream.reject(fn _x -> true end) |> Stream.run() end)\n```","ref":"readme.html#network-compression"},{"type":"extras","title":"Connection Pooling - The Elixir Driver for MongoDB","doc":"The driver supports pooling by DBConnection (2.x). By default `mongodb_driver` will start a single\nconnection, but it also supports pooling with the `:pool_size` option. For 3 connections add the `pool_size: 3` option to `Mongo.start_link` and to all\nfunction calls in `Mongo` using the pool:\n\n```elixir\n# Starts an pooled connection\n{:ok, top} = Mongo.start_link(url: \"mongodb://localhost:27017/db-name\", pool_size: 3)\n\n# Gets an enumerable stream for the results\ntop\n|> Mongo.find(\"test-collection\", %{})\n|> Enum.to_list()\n```\n\nIf you're using pooling it is recommended to add it to your application supervisor:\n\n```elixir\ndef start(_type, _args) do\n\n  children = [\n    {Mongo, [name: :mongo_db, url: \"mongodb://localhost:27017/test\", pool_size: 3]}\n  ]\n\n  opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n  Supervisor.start_link(children, opts)\nend\n```\n\nWe can use the `:mongo_db` atom instead of a process pid. This allows us to call the `Mongo` functions directly from\nevery place in the code.","ref":"readme.html#connection-pooling"},{"type":"extras","title":"Replica Sets - The Elixir Driver for MongoDB","doc":"By default, the driver will discover the deployment's topology and will connect\nto the replica set automatically, using either the seed list syntax or the URI\nsyntax. Assuming the deployment has nodes at `hostname1.net:27017`,\n`hostname2.net:27017` and `hostname3.net:27017`, either of the following\ninvocations will discover the entire deployment:\n\n```elixir\n{:ok, pid} = Mongo.start_link(database: \"test\", seeds: [\"hostname1.net:27017\"])\n\n{:ok, pid} = Mongo.start_link(url: \"mongodb://hostname1.net:27017/test\")\n```\n\nTo ensure that the connection succeeds even when some of the nodes are not\navailable, it is recommended to list all nodes in both the seed list and the\nURI, as follows:\n\n```elixir\n{:ok, pid} = Mongo.start_link(database: \"test\", seeds: [\"hostname1.net:27017\", \"hostname2.net:27017\", \"hostname3.net:27017\"])\n\n{:ok, pid} = Mongo.start_link(url: \"mongodb://hostname1.net:27017,hostname2.net:27017,hostname3.net:27017/test\")\n```\n\nUsing an SRV URI also discovers all nodes of the deployment automatically.","ref":"readme.html#replica-sets"},{"type":"extras","title":"Migration - The Elixir Driver for MongoDB","doc":"Despite the schema-free approach, migration is still desirable. Migrations are used to maintain the indexes \nand to drop collections that are no longer needed. Capped collections must be migrated. \nThe driver provides a workflow similar to Ecto that can be used to create migrations.\n\nFirst we create a migration script:\n```elixir\n\nmix mongo.gen.migration add_indexes\n\n```\n\nIn `priv/mongo/migrations` you will find an Elixir script like `20220322173354_add_indexes.exs`:\n\n```elixr\ndefmodule Mongo.Migrations.AddIndexes do\n  def up() do\n    indexes = [\n      [key: [email: 1], name: \"email_index\", unique: true]\n    ]\n\n    Mongo.create_indexes(:my_db, \"my_collection\", indexes)\n  end\n\n  def down() do\n    Mongo.drop_index(:my_db, \"my_collection\", \"email_index\")\n  end\nend\n\n```\n\nAfter that you can run the migration using a task:\n\n```\nmix mongo.migrate\n\n🔒 migrations locked\n⚡️ Successfully migrated Elixir.Mongo.Migrations.CreateIndex\n🔓 migrations unlocked\n\n```\n\nOr let it run if your application starts:\n\n```elixir\ndefmodule MyApp.Release do\n  @moduledoc \"\"\"\n  Used for executing DB release tasks when run in production without mix\n  installed.\n  \"\"\"\n\n  def migrate() do\n    Application.load(:my_app)\n    Application.ensure_all_started(:ssl)\n    Application.ensure_all_started(:mongodb_driver)\n    Mongo.start_link(name: :mongo_db, url: \"mongodb://localhost:27017/my-database\", timeout: 60_000, pool_size: 1, idle_interval: 10_000)\n\n    Mongo.Migration.migrate()\n  end\nend\n```\n\nWith the release features of Elixir you can add an overlay script like this:\n\n```shell\n#!/bin/sh\ncd -P -- \"$(dirname -- \"$0\")\"\nexec ./my_app eval MyApp.Release.migrate\n```\n\n```shell\n#!/bin/sh\ncd -P -- \"$(dirname -- \"$0\")\"\nPHX_SERVER=true exec ./my_app start\n```\n\nAnd then you need just to call migrate before you start the server:\n\n```shell\n/app/bin/migrate && /app/bin/server\n```\n\nOr if you use a Dockerfile:\n\n```dockerfile\nENTRYPOINT /app/bin/migrate && /app/bin/server\n```\n\nThe migration module tries to *lock* the migration collection to ensure that only one instance is running the migration. \nUnfortunately MongoDB does not support collection locks, so need to use a software lock:\n\n```elixir\nMongo.update_one(topology, \n  \"migrations\", \n  %{_id: \"lock\", used: false}, \n  %{\"$set\": %{used: true}}, \n  upsert: true)\n```\nYou can lock and unlock the migration collection using these functions in case of an error:\n\n1. `Mongo.Migration.lock()` \n2. `Mongo.Migration.unlock()` or `mix mongo.unlock`\n\nIf nothing helps, just delete the document with `{_id: \"lock\"}` from the migration collection.\n\nFor more information see:\n\n- `Mongo.Migration`\n- `Mix.Tasks.Mongo`\n- https://hexdocs.pm/mix/1.14/Mix.Tasks.Release.html","ref":"readme.html#migration"},{"type":"extras","title":"Configuration: - The Elixir Driver for MongoDB","doc":"You need to configure the migration module and specify at least the `:otp_app` and `:topology` values. Here are the\ndefault values:\n\n    config :mongodb_driver,\n        migration:\n            [\n                topology: :mongo,\n                collection: \"migrations\",\n                path: \"migrations\",\n                otp_app: :mongodb_driver\n            ]\n\nThe following  options are available:\n* `:collection` - Version numbers of migrations will be saved in a collection named `migrations` by default.\n* `:path` - the `priv` directory for migrations. `:path` defaults to \"migrations\" and migrations should be placed at \"priv/mongo/migrations\". The pattern to build the path is `:priv/:topology/:path`\n* `:otp_app` - the name of the otp_app to resolve the `priv` folder, defaults to `:mongodb_driver`. In most cases you use your application name.\n* `:topology` - the topology for running the migrations, `:topology` defaults to `:mongo`","ref":"readme.html#configuration"},{"type":"extras","title":"Supporting multiple topologies: - The Elixir Driver for MongoDB","doc":"Each function `lock/1, unlock/1, migrate/1, drop/1` accepts a keyword list (options) to override the default config having \nfull control of the migration process. The options are passed through the migration scripts. \n\nThat means you can support multiple topologies, databases and migration collections. Example\n\n    Mongo.start_link(name: :topology_1, url: \"mongodb://localhost:27017/mig_test_1\", timeout: 60_000, pool_size: 5, idle_interval: 10_000)\n    Mongo.start_link(name: :topology_2, url: \"mongodb://localhost:27017/mig_test_2\", timeout: 60_000, pool_size: 5, idle_interval: 10_000)\n\n    IO.puts(\"running default migration\")\n    Mongo.Migration.migrate()","ref":"readme.html#supporting-multiple-topologies"},{"type":"extras","title":"default values specified in the configs - The Elixir Driver for MongoDB","doc":"IO.puts(\"running topology_2 migration\")\n    Mongo.Migration.migrate([topology: :topology_2])","ref":"readme.html#default-values-specified-in-the-configs"},{"type":"extras","title":"override the topology - The Elixir Driver for MongoDB","doc":"Adding the options parameter in the `up/1` and `down/1` function of the migration script is supported as well. It is\npossible to pass additional parameters to the migration scripts.\n\n    defmodule Mongo.Migrations.Topology.CreateIndex do\n        def up(opts) do \n            IO.inspect(opts)\n            ...\n        end\n        \n        def down(opts) do\n            IO.inspect(opts)\n            ...\n        end\n    end\n\nThe topology is part of the namespace and of the migration path as well. The default value is defined in the configuration.\nYou can specify the topology in the case of creating a new migration script by appending the name to the script call:\n```elixir\n\nmix mongo.gen.migration add_indexes topology_2\n\n```\n\nIn `priv/topology_2/migrations` you will find an Elixir script like `20220322173354_add_indexes.exs`:\n\n```elixr\ndefmodule Mongo.Migrations.Topology2.AddIndexes do\n    ...\nend\n\n```\n\nBy using the `:topology` keyword, you can organise the migration scripts in different sub-folders. The migration path is prefixed with the `priv` folder of the application and the topology name.\n\nIf you call\n\n    Mongo.Migration.migrate([topology: :topology_2])\n\nthen the migration scripts under `/priv/topology_2/` are used and the options keyword list is passed through\nto the `up/1` function if it is implemented. That means you can create migration scripts for multiple topologies\nseparated in sub folders and module namespaces.","ref":"readme.html#override-the-topology"},{"type":"extras","title":"Auth Mechanisms - The Elixir Driver for MongoDB","doc":"For versions of Mongo 3.0 and greater, the auth mechanism defaults to SCRAM.\n\nIf connecting to MongoDB Enterprise Edition or MongoDB Atlas, the [PLAIN](https://www.mongodb.com/docs/manual/tutorial/authenticate-nativeldap-activedirectory/)\nauth mechanism is supported for LDAP authentication. The GSSAPI auth mechanism used for Kerberos authentication\nis not currently supported.\n\nIf you'd like to use [MONGODB-X509](https://www.mongodb.com/docs/v6.0/tutorial/configure-x509-client-authentication/)\nauthentication, you can specify that as a `start_link` option. \n\nYou need roughly three additional configuration steps:\n\n* Deploy with x.509 Authentication\n* Add x.509 Certificate subject as a User\n* Authenticate with an x.509 Certificate\n\nTo get the x.509 authentication working you need to prepare the ssl configuration accordingly:\n* you need to set the ssl option: `verify_peer`\n* you need to specify the `cacertfile` because Erlang BEAM don't provide any CA certificate store by default\n* you maybe need to customize the hostname check to allow wildcard certificates\n* you need to specify the `username` from the subject entry of the user certificate\n\nIf you use a user certificate from Atlas a working configuration looks like this. First we\nuse the [castore](https://hex.pm/packages/castore) package as the CA certificate store. After downloading\nthe user certificate we extract the username subject entry from the PEM file:\n\n```shell\nopenssl x509 -in   -inform PEM -subject -nameopt RFC2253\n\n> CN=cert-user\n```\n\nThe configuration looks now:\n```elixir\n  opts = [\n      url: \"mongodb+srv://cluster0.xxx.mongodb.net/myFirstDatabase?authSource=%24external&retryWrites=true&w=majority\",\n      ssl: true,\n      username: \"CN=cert-user\",\n      password: \"\",\n      auth_mechanism: :x509,\n      ssl_opts: [\n        verify: :verify_peer,\n        cacertfile: to_charlist(CAStore.file_path()),\n        certfile: '/path-to-cert/X509-cert-2227052404946303101.pem',\n        customize_hostname_check: [\n          match_fun:\n            :public_key.pkix_verify_hostname_match_fun(:https)\n        ]\n      ]]\n\n    Mongo.start_link(opts)\n```\n\nCurrently, we need to specify *an empty password* to get the x.509 auth module working. This will be changed soon.","ref":"readme.html#auth-mechanisms"},{"type":"extras","title":"x509 and using a dedicated MongoDB Atlas server - The Elixir Driver for MongoDB","doc":"Using OTP 26 changed the default configuration regarding TLS. You may see issues when \nconnecting to a dedicated Atlas Server using OTP 26. You can restrict the allowed versions and force to use TLS 1.2 instead\nof TLS 1.3.\n\n```elixir\n   ...\n    versions: [:\"tlsv1.2\"],\n   ...\n```\n\nSee also [MongoDB Security](https://www.mongodb.com/docs/atlas/reference/faq/security/) and \nthe [Issue 226](https://github.com/zookzook/elixir-mongodb-driver/issues/226) for some background information.","ref":"readme.html#x509-and-using-a-dedicated-mongodb-atlas-server"},{"type":"extras","title":"AWS, TLS and Erlang SSL Ciphers - The Elixir Driver for MongoDB","doc":"Some MongoDB cloud providers (notably AWS) require a particular TLS cipher that isn't enabled\nby default in the Erlang SSL module. In order to connect to these services,\nyou'll want to add this cipher to your `ssl_opts`:\n\n```elixir\n{:ok, pid} = Mongo.start_link(database: \"test\",\n      ssl_opts: [\n        ciphers: ['AES256-GCM-SHA384'],\n        cacertfile: \"...\",\n        certfile: \"...\")\n      ]\n)\n```\n\nSee the example `AWSX509.Example` as well.","ref":"readme.html#aws-tls-and-erlang-ssl-ciphers"},{"type":"extras","title":"Timeout - The Elixir Driver for MongoDB","doc":"The `:timeout` option sets the maximum time that the caller is allowed to hold the connection’s state (to send and to receive data). \nThe default value is 15 seconds. The connection pool defines additional timeout values. \nYou can use the `:timeout` as a global option to override the default value:\n\n```elixir\n# Starts an pooled connection\n{:ok, top} = Mongo.start_link(url: \"mongodb://localhost:27017/db-name\", timeout: 60_000)\n```\n\nEach single connection uses `60_000` (60 seconds) as the timeout value instead of `15_000`. But you can override the default value by\nusing the `:timeout` option, when running a single command:\n\n```elixir\nMongo.find(top, \"dogs\", %{}, timeout: 120_000)\n```\n\nNow the driver will use 120 seconds as the timeout for the single query.","ref":"readme.html#timeout"},{"type":"extras","title":"Read Preferences - The Elixir Driver for MongoDB","doc":"The `:read_preference` option sets [read preference](https://www.mongodb.com/docs/manual/core/read-preference/) for the query. The read preference is\na simple map, supporting the following keys:\n\n* `:mode`, possible values: `:primary`, `:primary_preferred`, `:secondary`, `:secondary_preferred` and `:nearest`\n* `:max_staleness_ms`, the maxStaleness value in milliseconds\n* `:tags`, the set of tags, for example: `[dc: \"west\", usage: \"production\"]`\n\nThe driver selects the server using the read preference. \n\n```elixr \nprefs = %{\n    mode: :secondary,\n    max_staleness_ms: 120_000,\n    tags: [dc: \"west\", usage: \"production\"]\n}\n\nMongo.find_one(top, \"dogs\", %{name: \"Oskar\"}, read_preference: prefs)\n```","ref":"readme.html#read-preferences"},{"type":"extras","title":"Change Streams - The Elixir Driver for MongoDB","doc":"Change streams are available in replica set and sharded cluster deployments\nand tell you about changes of documents in collections. They work like endless\ncursors.\n\nThe special thing about change streams is that they are resumable: in case of\na resumable error, no exception is propagated to the application, but instead\nthe cursor is re-scheduled at the last successful location.\n\nThe following example will never stop, thus it is a good idea to use a process\nfor reading from change streams:\n\n```elixir\nseeds = [\"hostname1.net:27017\", \"hostname2.net:27017\", \"hostname3.net:27017\"]\n{:ok, top} = Mongo.start_link(database: \"my-db\", seeds: seeds, appname: \"getting rich\")\nstream =  Mongo.watch_collection(top, \"accounts\", [], fn doc -> IO.puts \"New Token #{inspect doc}\" end, max_time: 2_000 )\nEnum.each(stream, fn doc -> IO.puts inspect doc end)\n```\n\nAn example with a spawned process that sends messages to the monitor process:\n\n```elixir\ndef for_ever(top, monitor) do\n    stream = Mongo.watch_collection(top, \"users\", [], fn doc -> send(monitor, {:token, doc}) end)\n    Enum.each(stream, fn doc -> send(monitor, {:change, doc}) end)\nend\n\nspawn(fn -> for_ever(top, self()) end)\n```\n\nFor more information see `Mongo.watch_collection/5`","ref":"readme.html#change-streams"},{"type":"extras","title":"Indexes - The Elixir Driver for MongoDB","doc":"To create indexes you can call the function `Mongo.create_indexes/4`:\n\n```elixir\nindexes =  [[key: [files_id: 1, n: 1], name: \"files_n_index\", unique: true]]\nMongo.create_indexes(top, \"my_collection\", indexes, opts)\n```\n\nYou specify the `indexes` parameter as a keyword list with all options described in the documentation of the [createIndex](https://docs.mongodb.com/manual/reference/command/createIndexes/#dbcmd.createIndexes) command.\n\nFor more information see:\n\n- `Mongo.create_indexes/4`\n- `Mongo.drop_index/4`","ref":"readme.html#indexes"},{"type":"extras","title":"Bulk Writes - The Elixir Driver for MongoDB","doc":"The motivation for bulk writes lies in the possibility of optimization, the same operations\nto group. Here, a distinction is made between disordered and ordered bulk writes.\nIn disordered, inserts, updates, and deletes are grouped as individual commands\nsent to the database. There is no influence on the order of the execution.\nA good use case is the import of records from one CSV file.\nThe order of the inserts does not matter.\n\nFor ordered bulk writers, order compliance is important to keep.\nIn this case, only the same consecutive operations are grouped.\n\nCurrently, all bulk writes are optimized in memory. This is unfavorable for large bulk writes.\nIn this case, one can use streaming bulk writes that only have a certain set of\ngroup operation in memory and when the maximum number of operations\nhas been reached, operations are written to the database. The size can be specified.\n\nUsing ordered bulk writes. In this example we first insert some dog's name, add an attribute `kind`\nand change all dogs to cats. After that we delete three cats. This example would not work with\nunordered bulk writes.\n\n```elixir\n\nbulk = \"bulk\"\n       |> OrderedBulk.new()\n       |> OrderedBulk.insert_one(%{name: \"Greta\"})\n       |> OrderedBulk.insert_one(%{name: \"Tom\"})\n       |> OrderedBulk.insert_one(%{name: \"Waldo\"})\n       |> OrderedBulk.update_one(%{name: \"Greta\"}, %{\"$set\": %{kind: \"dog\"}})\n       |> OrderedBulk.update_one(%{name: \"Tom\"}, %{\"$set\": %{kind: \"dog\"}})\n       |> OrderedBulk.update_one(%{name: \"Waldo\"}, %{\"$set\": %{kind: \"dog\"}})\n       |> OrderedBulk.update_many(%{kind: \"dog\"}, %{\"$set\": %{kind: \"cat\"}})\n       |> OrderedBulk.delete_one(%{kind: \"cat\"})\n       |> OrderedBulk.delete_one(%{kind: \"cat\"})\n       |> OrderedBulk.delete_one(%{kind: \"cat\"})\n\nresult = Mongo.BulkWrite.write(top, bulk, w: 1)\n```\n\nIn the following example we import 1.000.000 integers into the MongoDB using the stream api:\n\nWe need to create an insert operation for each number. Then we call the `Mongo.UnorderedBulk.stream`\nfunction to import it. This function returns a stream function that accumulates\nall inserts operations until the limit `1000` is reached. In this case the operation group is send to\nMongoDB. So using the stream api you can reduce the memory using while\nimporting big volume of data.\n\n```elixir\n1..1_000_000\n|> Stream.map(fn i -> Mongo.BulkOps.get_insert_one(%{number: i}) end)\n|> Mongo.UnorderedBulk.write(:mongo, \"bulk\", 1_000)\n|> Stream.run()\n```\n\nFor more information see:\n\n- `Mongo.UnorderedBulk`\n- `Mongo.OrderedBulk`\n- `Mongo.BulkWrite`\n- `Mongo.BulkOps`\n\nand have a look at the test units as well.","ref":"readme.html#bulk-writes"},{"type":"extras","title":"GridFS - The Elixir Driver for MongoDB","doc":"The driver supports the GridFS specifications. You create a `Mongo.GridFs.Bucket`\nstruct and with this struct you can upload and download files. For example:\n\n```elixir\n    bucket = Bucket.new(top)\n    upload_stream = Upload.open_upload_stream(bucket, \"test.jpg\")\n    src_filename = \"./test/data/test.jpg\"\n    File.stream!(src_filename, [], 512) |> Stream.into(upload_stream) |> Stream.run()\n\n    file_id = upload_stream.id\n```\n\nIn the example a new bucket with default values is used to upload a file from the file system (`./test/data/test.jpg`) to the MongoDB (using the name `test.jpg`). The `upload_stream` struct contains the id of the new file which can be used to download the stored file. The following code fragments downloads the file by using the `file_id`.\n\n```elixir\n    dest_filename = \"/tmp/my-test-file.jps\"\n\n    with {:ok, stream} <- Mongo.GridFs.Download.open_download_stream(bucket, file_id) do\n      stream\n      |> Stream.into(File.stream!(dest_filename))\n      |> Stream.run\n    end\n```\n\nFor more information see:\n\n- [Mongo.GridFs.Bucket](https://hexdocs.pm/mongodb_driver/Mongo.GridFs.Bucket.html#content)\n- [Mongo.GridFs.Download](https://hexdocs.pm/mongodb_driver/Mongo.GridFs.Download.html#content)\n- [Mongo.GridFs.Upload](https://hexdocs.pm/mongodb_driver/Mongo.GridFs.Upload.html#content)","ref":"readme.html#gridfs"},{"type":"extras","title":"Transactions - The Elixir Driver for MongoDB","doc":"Since MongoDB 4.x, transactions for multiple write operations are possible. Transaction uses sessions, which\njust contain a transaction number for each transaction. The `Mongo.Session` is responsible for the\ndetails, and you can use a convenient api for transactions:\n\n```elixir\n\n{:ok, ids} = Mongo.transaction(top, fn ->\n{:ok, %InsertOneResult{:inserted_id => id1}} = Mongo.insert_one(top, \"dogs\", %{name: \"Greta\"})\n{:ok, %InsertOneResult{:inserted_id => id2}} = Mongo.insert_one(top, \"dogs\", %{name: \"Waldo\"})\n{:ok, %InsertOneResult{:inserted_id => id3}} = Mongo.insert_one(top, \"dogs\", %{name: \"Tom\"})\n{:ok, [id1, id2, id3]}\nend, w: 1)\n\n```\nThe `Mongo.transaction/3` function supports nesting. This allows the functions to be called from each other and all write operations\nare still in the same transaction. The session is stored in the process dictionary under the key `:session`. The surrounding\n`Mongo.transaction/3` call creates the session and starts the transaction, storing the session in the process dictionary, commits or\naborts the transaction. All other `Mongo.transaction/3` calls just call the function parameter without other actions.\n\n```elixir\ndef insert_dog(top, name) do\n  Mongo.insert_one(top, \"dogs\", %{name: name})\nend\n\ndef insert_dogs(top) do\n  Mongo.transaction(top, fn ->\n    insert_dog(top, \"Tom\")\n    insert_dog(top, \"Bell\")\n    insert_dog(top, \"Fass\")\n    :ok\n  end)\nend\n\n:ok = Mongo.transaction(top, fn ->\n    insert_dog(top, \"Greta\")\n    insert_dogs(top)\nend)\n```\n\nIt is also possible to get more control over the progress of the transaction:\n\n```elixir\nalias Mongo.Session\n\n{:ok, session} = Session.start_session(top, :write, [])\n:ok = Session.start_transaction(session)\n\nMongo.insert_one(top, \"dogs\", %{name: \"Greta\"}, session: session)\nMongo.insert_one(top, \"dogs\", %{name: \"Waldo\"}, session: session)\nMongo.insert_one(top, \"dogs\", %{name: \"Tom\"}, session: session)\n\n:ok = Session.commit_transaction(session)\n:ok = Session.end_session(top, session)\n```\nFor more information see `Mongo.Session` and have a look at the test units as well.","ref":"readme.html#transactions"},{"type":"extras","title":"Aborting a transaction - The Elixir Driver for MongoDB","doc":"You have some options to abort a transaction. The simplest possibility is to return an `:error`. For nested\nfunction calls, the `Mongo.abort_transaction/1` function call that throws an exception is suitable.\nThat means, you can just generate a `raise :should_not_happen` exception as well.","ref":"readme.html#aborting-a-transaction"},{"type":"extras","title":"Command Monitoring - The Elixir Driver for MongoDB","doc":"You can watch all events that are triggered while the driver sends requests and processes responses. You can use the\n`Mongo.EventHandler` as a starting point. It logs the events from the topic `:commands` (by ignoring the `:isMaster` command)\nto `Logger.info`:\n\n```elixir\niex> Mongo.EventHandler.start()\niex> {:ok, top} = Mongo.start_link(url: \"mongodb://localhost:27017/test\")\n{:ok, #PID<0.226.0>}\n iex> Mongo.find_one(top, \"test\", %{}) |> Enum.to_list()\n[info] Received command: %Mongo.Events.CommandStartedEvent{command: [find: \"test\", ...\n[info] Received command: %Mongo.Events.CommandSucceededEvent{command_name: :find, ...\n```","ref":"readme.html#command-monitoring"},{"type":"extras","title":"Testing - The Elixir Driver for MongoDB","doc":"Latest MongoDB is used while running the tests. Replica set of three nodes is created and runs all tests, except the socket and ssl test. If you want to\nrun the test cases against other MongoDB deployments or older versions, you can use the [mtools](https://github.com/rueckstiess/mtools) for deployment and run the test cases locally:\n\n```bash\npyenv global 3.6\npip3 install --upgrade pip\npip3 install 'mtools[all]'\nexport PATH=to-your-mongodb/bin/:$PATH\nulimit -S -n 2048","ref":"readme.html#testing"},{"type":"extras","title":"in case of Mac OS X - The Elixir Driver for MongoDB","doc":"mlaunch init --setParameter enableTestCommands=1 --replicaset --name \"rs_1\"\nmongosh --host localhost:27017 --eval 'rs.initiate({_id: \"rs_1\", members: [{_id: 0, host: \"127.0.0.1:27017\"}, {_id: 1, host: \"127.0.0.1:27018\"}, {_id: 2, host: \"127.0.0.1:27019\"}]})'\nmix test --exclude ssl --exclude socket\n```\n\nThe SSL test suite is disabled by default.","ref":"readme.html#in-case-of-mac-os-x"},{"type":"extras","title":"Enable the SSL Tests - The Elixir Driver for MongoDB","doc":"`mix test --exclude ssl`","ref":"readme.html#enable-the-ssl-tests"},{"type":"extras","title":"Enable SSL on Your MongoDB Server - The Elixir Driver for MongoDB","doc":"```bash\n$ openssl req -newkey rsa:2048 -new -x509 -days 365 -nodes -out mongodb-cert.crt -keyout mongodb-cert.key\n$ cat mongodb-cert.key mongodb-cert.crt > mongodb.pem\n$ mongod --sslMode allowSSL --sslPEMKeyFile /path/to/mongodb.pem\n```\n\n- For `--sslMode` you can use one of `allowSSL` or `preferSSL`\n- You can enable any other options you want when starting `mongod`","ref":"readme.html#enable-ssl-on-your-mongodb-server"},{"type":"extras","title":"Additional articles - The Elixir Driver for MongoDB","doc":"* [Connecting to MongoDB with Elixir](https://zookzook.github.io/2024/08-25.html)\n* [Using Network Compression with MongoDB in Elixir](https://zookzook.github.io/2024/09-15.html)","ref":"readme.html#additional-articles"},{"type":"extras","title":"Copyright and License - The Elixir Driver for MongoDB","doc":"Copyright 2015 Eric Meadows-Jönsson and Justin Wood \\\nCopyright 2019 - present Michael Maier\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at [https://www.apache.org/licenses/LICENSE-2.0](https://www.apache.org/licenses/LICENSE-2.0)\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [1.5.2](https://github.com/zookzook/elixir-mongodb-driver/compare/v1.5.1...v1.5.2) (2025-02-11)","ref":"changelog.html"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* improved error handling when using change-streams ([c07c5a1](https://github.com/zookzook/elixir-mongodb-driver/commit/c07c5a1207153fb0e8f2e3a4c2dd3d0c6042acf1))","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Features - Changelog","doc":"* Added support for directConnection setting in connection string (thanks to colacheng)\n\n\n## [1.5.1](https://github.com/zookzook/elixir-mongodb-driver/compare/v1.5.0...v1.5.1) (2025-02-04)","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* **master:** ensure url_parser does not fail on missing txt record ([#261](https://github.com/zookzook/elixir-mongodb-driver/issues/261)) ([e4a3102](https://github.com/zookzook/elixir-mongodb-driver/commit/e4a3102235090ffd966db4f1b4ca81d14413a95d))\n\n## [1.5.0](https://github.com/zookzook/elixir-mongodb-driver/compare/v1.4.1...v1.5.0) (2024-09-20)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Features - Changelog","doc":"* added support for op_compressed (zlib and zstd) ([cf32c87](https://github.com/zookzook/elixir-mongodb-driver/commit/cf32c8739ef88175a0c914bd2ef96419f13d992f))","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* **update/4:** improve Mongo.update/4 function ([#245](https://github.com/zookzook/elixir-mongodb-driver/issues/245)) ([50b511d](https://github.com/zookzook/elixir-mongodb-driver/commit/50b511d01b7ecd3350a3b21110d15fa0fbbb6fb6))\n\n## [1.4.1](https://github.com/zookzook/elixir-mongodb-driver/compare/v1.4.0...v1.4.1) (2024-05-02)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* improved the reconnection workflow ([08d7fbc](https://github.com/zookzook/elixir-mongodb-driver/commit/08d7fbc05bff833de177ae168ca3bb7fa4425572))\n\n## [1.4.0](https://github.com/zookzook/elixir-mongodb-driver/compare/v1.2.1...v1.4.0) (2024-02-10)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Features - Changelog","doc":"* Compatibility changes to support mongodb_ecto adapter, thanks to https://github.com/brennana","ref":"changelog.html#features"},{"type":"extras","title":"Miscellaneous Chores - Changelog","doc":"* release 1.2.1 ([0ef1482](https://github.com/zookzook/elixir-mongodb-driver/commit/0ef14829361bde236cfc054d774a3a51d0abea29))\n\n## [1.2.1](https://github.com/zookzook/elixir-mongodb-driver/compare/v1.2.0...v1.2.1) (2023-11-26)","ref":"changelog.html#miscellaneous-chores"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* added support for read preference specified by the URL ([#207](https://github.com/zookzook/elixir-mongodb-driver/issues/207)) ([9e4d569](https://github.com/zookzook/elixir-mongodb-driver/commit/9e4d56957a8bd2605bf50dbe5eea551b4fc2dc40))\n* applies the global timeout value to each query ([#215](https://github.com/zookzook/elixir-mongodb-driver/issues/215)) ([64f8ea1](https://github.com/zookzook/elixir-mongodb-driver/commit/64f8ea16ed47fb724e5fca6d70ef99f3ecef0f51))\n* handle read preferences without tags ([50ea98d](https://github.com/zookzook/elixir-mongodb-driver/commit/50ea98db82217bbd9a2f37ad57f6f271b2bff7c2))\n* preserve the order of the keys ([#211](https://github.com/zookzook/elixir-mongodb-driver/issues/211)) ([b360d87](https://github.com/zookzook/elixir-mongodb-driver/commit/b360d87ad02383e37ad53dafa036abfb9e2bbc53))\n\n## [1.2.0](https://github.com/zookzook/elixir-mongodb-driver/compare/v1.1.0...v1.2.0) (2023-08-30)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Features - Changelog","doc":"* Supports passing arrayFilters option through find_one_and_update ([#201](https://github.com/zookzook/elixir-mongodb-driver/issues/201)) ([082878b](https://github.com/zookzook/elixir-mongodb-driver/commit/082878b121ac02fc763cf5be0b6b197abbcbbe9e))","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* fixed typo ([e6eff31](https://github.com/zookzook/elixir-mongodb-driver/commit/e6eff31fd1c001074f73aab18d8d88a1cd33005c))\n\n## [1.1.0](https://github.com/zookzook/elixir-mongodb-driver/compare/v1.0.3...v1.1.0) (2023-07-30)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Features - Changelog","doc":"* add support for Elixir 1.15 ([#195](https://github.com/zookzook/elixir-mongodb-driver/issues/195)) ([f621a62](https://github.com/zookzook/elixir-mongodb-driver/commit/f621a62d5bb825cfd77e8f3024d569f23be0376d))\n\n## [1.0.3](https://github.com/zookzook/elixir-mongodb-driver/compare/v1.0.2...v1.0.3) (2023-05-13)","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* check if monitor pid exists before stopping ([6e0c8b2](https://github.com/zookzook/elixir-mongodb-driver/commit/6e0c8b2625d0c424d194a0efcd799177a4c916f1))","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add support of errInfo ([#187](https://github.com/zookzook/elixir-mongodb-driver/pull/187))\n* add support for the hint option ([#175](https://github.com/zookzook/elixir-mongodb-driver/issues/175)) ([4c817b7](https://github.com/zookzook/elixir-mongodb-driver/commit/4c817b721eb5430dc20eaae754a24d671cb52a62))\n* add telemetry start event to fix [#174](https://github.com/zookzook/elixir-mongodb-driver/issues/174) ([e79db9e](https://github.com/zookzook/elixir-mongodb-driver/commit/e79db9e0faedf3b37dcaf8fab6a9aa98dba3b43b))\n\n## [1.0.2](https://github.com/zookzook/elixir-mongodb-driver/compare/v1.0.1...v1.0.2) (2023-01-02)","ref":"changelog.html#enhancements"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* deprecated 'use Bitwise' ([#168](https://github.com/zookzook/elixir-mongodb-driver/issues/168)) ([a980d57](https://github.com/zookzook/elixir-mongodb-driver/commit/a980d5782a56a0a8168c5229fe22b7a935c433b3))\n* use the basename of the file path ([3a10c56](https://github.com/zookzook/elixir-mongodb-driver/commit/3a10c5604a2cbc5d284a17578280e96c93f61e63))\n\n## [1.0.1](https://github.com/zookzook/elixir-mongodb-driver/compare/v1.0.0...v1.0.1) (2022-12-17)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* replace :code.priv_dir/1 function ([da0fd6c](https://github.com/zookzook/elixir-mongodb-driver/commit/da0fd6cdc777c4d1cb1df0abac98af1f4a37ad11))\n\n## [1.0.0](https://github.com/zookzook/elixir-mongodb-driver/compare/0.9.2...v1.0.0) (2022-11-27)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* add migration ([da65de4](https://github.com/zookzook/elixir-mongodb-driver/commit/da65de4d8fd7cf6a15ac0c42b3022ca1fe743876))\n* remove a bug in the hello handshake protocol (thanks to fireproofsocks for reporting) ([59aa841](https://github.com/zookzook/elixir-mongodb-driver/commit/59aa841cc619f77979cc3027c76e918373685723))\n* remove derived attributes in the dump function ([c1b60b4](https://github.com/zookzook/elixir-mongodb-driver/commit/c1b60b413329f32d4e0bd52c3988b89b19fe7f5a))","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"* improve the dump and load functions ([#154](https://github.com/zookzook/elixir-mongodb-driver/issues/154)) ([e7f2d44](https://github.com/zookzook/elixir-mongodb-driver/commit/e7f2d44a01fa25cd85cb8fd1f935ba5a201fe011))\n* use the same timestamps in new/0 function ([0db61da](https://github.com/zookzook/elixir-mongodb-driver/commit/0db61dac03eb2a27d4d47576ed402ad1e6c452f4))","ref":"changelog.html#enhancements"},{"type":"extras","title":"Miscellaneous Chores - Changelog","doc":"* release 1.0.0 ([64e274a](https://github.com/zookzook/elixir-mongodb-driver/commit/64e274a761dd9e6757d1b506ee3ba4308ac1448f))","ref":"changelog.html#miscellaneous-chores"},{"type":"extras","title":"0.9.3 (2022-10-14) - Changelog","doc":"* Bugfix\n  * fix a bug in the hello handshake protocol (thanks to fireproofsocks for reporting)\n* Enhancements\n  * add migration","ref":"changelog.html#0-9-3-2022-10-14"},{"type":"extras","title":"0.9.2 (2022-09-24) - Changelog","doc":"* Bugfix\n  * fix a crash in the streaming hello monitor, if the server sends more than one response at once \n  * add support for the new hello handshake\n  * refactor :timeout option (thanks to JD-Robertson for reporting)\n  * add timestamps macro to the collection module to handle inserted_at and updated_at attributes (thanks to carlosliracl)","ref":"changelog.html#0-9-2-2022-09-24"},{"type":"extras","title":"0.9.1 (2022-05-27) - Changelog","doc":"* Bugfix\n  * add backward compatible for Elixir < 1.13 (thanks to ja-jimenez)","ref":"changelog.html#0-9-1-2022-05-27"},{"type":"extras","title":"0.9.0 (2022-05-21) - Changelog","doc":"* Enhancements\n  * add colored log output\n  * add telemetry support for execution\n  * add new Repo module (thanks to daskycodes)\n  * add missing typespecs (thanks to fdie)\n  * refactor transaction api to support nested transaction\n  * add `Mongo.rename_collection/3` command","ref":"changelog.html#0-9-0-2022-05-21"},{"type":"extras","title":"0.8.4 (2022-03-09) - Changelog","doc":"* Bugfix\n  * add missing excludes from dump function (collections)","ref":"changelog.html#0-8-4-2022-03-09"},{"type":"extras","title":"0.8.3 (2022-02-17) - Changelog","doc":"* Bugfix\n  * fix no function clause matching (thanks to bodbdigr)","ref":"changelog.html#0-8-3-2022-02-17"},{"type":"extras","title":"0.8.2 (2022-02-03) - Changelog","doc":"* Enhancements\n  * Remove a compiler warning (thanks to a-jimenez )","ref":"changelog.html#0-8-2-2022-02-03"},{"type":"extras","title":"0.8.1 (2022-01-22) - Changelog","doc":"* Enhancements\n  * Fix for serializing BSON Regex without options (thanks to MillionIntegrals)\n  * Misc doc changes (thanks to kianmeng)\n  * Added support for OP_MSG exhaustAllowed flag\n  * Added support for streaming protocol \n  * Added Insights app for development ]()","ref":"changelog.html#0-8-1-2022-01-22"},{"type":"extras","title":"0.8.0 (2021-11-07) (0.7.5 was not published) - Changelog","doc":"* Enhancements\n  * replica set connection: faster topology update if the primary is down (thanks to p-mongo)\n  * added custom `Mongo.Encoder` protocol (thanks to esse)\n  * added collection from yildun project\n  * fixed an issue that the bulk operation does not stop after any insert/update/delete failed (thanks to ja-jimenez)","ref":"changelog.html#0-8-0-2021-11-07-0-7-5-was-not-published"},{"type":"extras","title":"0.7.4 (2021-06-21) - Changelog","doc":"* Enhancements\n  * added a new option to specify a timeout, when increasing the connection pool is no option","ref":"changelog.html#0-7-4-2021-06-21"},{"type":"extras","title":"0.7.3 (2021-05-29) - Changelog","doc":"* Enhancements\n  * added support for OTP 24\n  * Add support for tls setting in connection string (tschmittni)\n  * Replace deprecated functions (OTP 24) (aenglisc )","ref":"changelog.html#0-7-3-2021-05-29"},{"type":"extras","title":"0.7.2 (2021-05-19) - Changelog","doc":"* Enhancements\n  * Adds test to cover one of Mongo.find/4 errors (vukanac)\n  * Update specs for Mongo.find/4 with error tuple (vukanac)\n  * Fix build warnings and correct typespec (joeapearson)\n  * Update db_connection version to remove System.stacktrace warnings (vukanac)\n  * Update SCRAM auth procedure (LetThereBeDwight)","ref":"changelog.html#0-7-2-2021-05-19"},{"type":"extras","title":"0.7.1 (2021-01-01) - Changelog","doc":"* Enhancements\n    * upgraded decimal to 2.0, jason to 1.2\n    * Add proper support for tailable cursors and awaitData (PR #74)","ref":"changelog.html#0-7-1-2021-01-01"},{"type":"extras","title":"0.7.0 (2020-04-17) - Changelog","doc":"* Enhancements\n    * refactored event notification system\n    * added support for retryable reads and writes\n    * refactored the test cases\n    * now using mtools for a MongoDB deployment in the travis ci environment\n    * travis ci uses only the latest MongoDB version [The failCommand](https://github.com/mongodb/mongo/wiki/The-%22failCommand%22-fail-point)\n    * `Session.commit_transaction` returns now `:ok` or an error `{:error, %Mongo.Error{}}`\n\n* Bugfixes\n    * Using `max_staleness_ms` > 0 results in a crash\n    * Read preferences are sent to mongos","ref":"changelog.html#0-7-0-2020-04-17"},{"type":"extras","title":"0.6.5 (2020-03-30) - Changelog","doc":"* Enhancements\n    * updated db_connection dependency\n    * generalize inconsistent typespecs\n    * new function `BSON.ObjectId.decode/1` and `BSON.ObjectId.encode/1`\n    * new function `Mongo.uuid/1`","ref":"changelog.html#0-6-5-2020-03-30"},{"type":"extras","title":"0.6.4 (2020-01-24) - Changelog","doc":"* Bugfixes\n    * fixed bug in `Mongo.TopologyDescription` in case of a shard cluster deployment (#39)","ref":"changelog.html#0-6-4-2020-01-24"},{"type":"extras","title":"0.6.3 (2020-01-23) - Changelog","doc":"* Enhancements\n    * basic support for inserting structs\n    * removed duplicated code\n    * Cursor-API raises a `Mongo.Error` instead of a `FunctionClauseError`\n\n* Bugfixes\n    * `:appname` option (typo) #38\n    * fixed index creation in `Mongo.GridFs.Bucket`","ref":"changelog.html#0-6-3-2020-01-23"},{"type":"extras","title":"0.6.2 (2019-11-15) - Changelog","doc":"* Enhancements\n    * refactored the api of `Mongo.limits` and `Mongo.wire_version`\n    * add support for tracking recovery token from response in a sharded transaction","ref":"changelog.html#0-6-2-2019-11-15"},{"type":"extras","title":"0.6.1 (2019-11-01) - Changelog","doc":"* Enhancements\n    * refactored `Mongo.Session` and `Mongo.Session.SessionPool` because of poor performance","ref":"changelog.html#0-6-1-2019-11-01"},{"type":"extras","title":"0.6.0 (2019-09-18) - Changelog","doc":"* Enhancements\n    * refactored `writeConcern`\n    * refactored `filter_nils`\n    * refactored usage of `ReadPreference`\n    * added support for sessions (`ServerSession`, `SessionPool`, `Session`)\n    * added support for transaction\n    * added Decimal128 encoder\n    * added support for transaction to gridfs and bulk operation\n    * added `create` command (explicitly creating a collection or view)","ref":"changelog.html#0-6-0-2019-09-18"},{"type":"extras","title":"0.5.7 (2019-06-25) - Changelog","doc":"* Bug Fixes\n   * Test for existing index in `Bucket` works right now\n\n* Enhancements\n   * Better handling for the `:timeout` options","ref":"changelog.html#0-5-7-2019-06-25"},{"type":"extras","title":"0.5.6 (2019-06-14) - Changelog","doc":"* Bug Fixes\n    * Fixed a match error in `after_fun` of cursor module\n    * Fixed a match error in the result of function `Monitor.force_check`\n    * Resolved decode problem for the Binary (Old) BinData subtype\n\n* Enhancements\n    * Added support for `Mongo.BulkWriteResult`","ref":"changelog.html#0-5-6-2019-06-14"},{"type":"extras","title":"0.5.5 (2019-05-22) - Changelog","doc":"* Bug Fixes\n    * Fixed a match error when using Windows OS","ref":"changelog.html#0-5-5-2019-05-22"},{"type":"extras","title":"0.5.4 (2019-05-21) - Changelog","doc":"* Enhancements\n   * The driver provides now client metadata\n   * Added support for connecting via UNIX sockets (`:socket` and `:socket_dir`)\n   * Added support for bulk writes (ordered/unordered, in-memory/stream)\n   * Added support for `op_msg` with payload type 1\n   * Merged code from https://github.com/ankhers/mongodb/commit/63c20ff7e427744a5df915751adfaf6e5e39ae62\n   * Merged changes from https://github.com/ankhers/mongodb/pull/283\n   * Merged changes from https://github.com/ankhers/mongodb/pull/281","ref":"changelog.html#0-5-4-2019-05-21"},{"type":"extras","title":"0.5.3 (2019-05-02) - Changelog","doc":"* Enhancements\n   * Travis now using the right MongoDB version\n\n* Bug Fixes\n   * Added test unit for change streams\n   * Removed debug code from change streams","ref":"changelog.html#0-5-3-2019-05-02"},{"type":"extras","title":"0.5.2 (2019-05-01) - Changelog","doc":"* Enhancements\n  * Added `op_msg` support ([See](https://docs.mongodb.com/manual/reference/mongodb-wire-protocol/#op-msg))\n  * Fixed change streams in case of error codes: 11601, 136 and 237 from resuming\n  * Reorganized error handling","ref":"changelog.html#0-5-2-2019-05-01"},{"type":"extras","title":"0.5.1 (2019-04-28) - Changelog","doc":"* Enhancements\n  * Upgraded to DBConnection 2.0.6\n  * Refactored code, simplified code and api\n  * Replaced deprecated op_code by database commands\n  * Update_one, update_many, replace_one, replace_many return upserted ids\n  * Add support for all find options\n  * Add support for MongoDB 3.6 collection [Change Streams](https://docs.mongodb.com/manual/changeStreams/)\n  * Ass support for SCRAM-SHA-256 (MongoDB 4.x)","ref":"changelog.html#0-5-1-2019-04-28"},{"type":"extras","title":"0.4.8-dev - Changelog","doc":"* Enhancements\n  * Added hostname and port to exceptions\n  * Added support for x509 authentication\n  * Allow passing only partial `read_preference` information\n  * Add support for GridFS\n\n* Bug Fixes\n  * Fixed a connection leak\n  * Properly parse write concern for URL\n  * Properly follow read preference for `secondary_preferred`","ref":"changelog.html#0-4-8-dev"},{"type":"extras","title":"v0.4.7 (2018-09-13) - Changelog","doc":"* Enhancements\n  * Added 4.0 to supported versions\n  * Initial support for mongodb+srv URLs\n  * Support for Decimal128","ref":"changelog.html#v0-4-7-2018-09-13"},{"type":"extras","title":"v0.4.6 (2018-05-20) - Changelog","doc":"* Enhancements\n  * Added `:connect_timout_ms` to `Mongo.start_link/1`\n  * Reorganized documentation","ref":"changelog.html#v0-4-6-2018-05-20"},{"type":"extras","title":"0.4.5 (2018-04-08) - Changelog","doc":"* Enhancements\n  * Should now be able to send a query to your server before the connection\n    is fully made\n\n* Bug Fixes\n  * Should actually be able to query for longer than 5 seconds","ref":"changelog.html#0-4-5-2018-04-08"},{"type":"extras","title":"0.4.4 (2018-02-09) - Changelog","doc":"* Enhancements\n  * Added support for using a mongo url via the `:url` key\n  * Added MongoDB 3.6 to supported versions\n  * Added support for the deprecated `undefined` BSON type\n\n* Bug Fixes\n  * Added another case for BSON NaN\n  * Fixed encoding and decoding of the BSON Timestamp type\n  * Should now figure out Topology for replica sets even if you exclude the\n    `:type` key\n  * Fixed an issue where our monitors would become empty, preventing the driver\n    from reconnecting to a downed database","ref":"changelog.html#0-4-4-2018-02-09"},{"type":"extras","title":"0.4.3 (2017-09-16) - Changelog","doc":"* Enhancements\n  * Send TLS server name indication (SNI) if none is set in the `:ssl_opts`\n  * Fixed a couple dialyzer issues\n  * Add basic examples of `$and`, `$or`, and `$in` operators in README\n\n* Bug Fixes\n  * Ensure cursor requests are routed to the proper node in the cluster\n  * No longer attempting to authenticate against arbiter nodes\n  * Prevent monitor errors if you have stopped the mongo process","ref":"changelog.html#0-4-3-2017-09-16"},{"type":"extras","title":"0.4.2 (2017-08-28) - Changelog","doc":"* Bug fixes\n  * Fix application crash when a replica set member goes offline\n  * Fix application crash on start when a replica set member is offline","ref":"changelog.html#0-4-2-2017-08-28"},{"type":"extras","title":"0.4.1 (2017-08-09) - Changelog","doc":"* Bug fixes\n  * Monitors no longer use a pool\n  * Can now connect to a Mongo instance using a CNAME\n  * Pass options through Mongo.aggregate/4","ref":"changelog.html#0-4-1-2017-08-09"},{"type":"extras","title":"0.4.0 (2017-06-07) - Changelog","doc":"* Replica Set Support","ref":"changelog.html#0-4-0-2017-06-07"},{"type":"extras","title":"0.3.0 (2017-05-11) - Changelog","doc":"* Breaking changes\n  * Remove `BSON.DateTime` and replace it with native Elixir `DateTime`","ref":"changelog.html#0-3-0-2017-05-11"},{"type":"extras","title":"0.2.1 (2017-05-08) - Changelog","doc":"* Enhancements\n  * SSL support\n  * Add functions `BSON.DateTime.to_elixir_datetime/1` and `BSON.DateTime.from_elixir_datetime/1`\n\n* Changes\n  * Requires Elixir ~> 1.3","ref":"changelog.html#0-2-1-2017-05-08"},{"type":"extras","title":"0.2.0 (2016-11-11) - Changelog","doc":"* Enhancements\n  * Add `BSON.ObjectID.encode!/1` and `BSON.ObjectID.decode!/1`\n  * Optimize and reduce binary copying\n  * Add tuple/raising versions of functions in `Mongo`\n  * Add `:inserted_count` field to `Mongo.InsertManyResult`\n  * Support NaN and infinite numbers in bson float encode/decode\n  * Add `Mongo.object_id/0` for generating objectids\n  * Add `Mongo.child_spec/2`\n  * Add `Mongo.find_one_and_update/5`\n  * Add `Mongo.find_one_and_replace/5`\n  * Add `Mongo.find_one_and_delete/4`\n\n* Bug fixes\n  * Fix float endianness\n\n* Breaking changes\n  * Switched to using `db_connection` library, see the current docs for changes","ref":"changelog.html#0-2-0-2016-11-11"},{"type":"extras","title":"0.1.1 (2015-12-17) - Changelog","doc":"* Enhancements\n  * Add `BSON.DateTime.from_datetime/1`\n\n* Bug fixes\n  * Fix timestamp epoch in generated object ids\n  * Fix `Mongo.run_command/3` to accept errors without code","ref":"changelog.html#0-1-1-2015-12-17"},{"type":"extras","title":"0.1.0 (2015-08-25) - Changelog","doc":"Initial release","ref":"changelog.html#0-1-0-2015-08-25"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS","ref":"license.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}